attackDefs["stone_spike"] = {
	name = "Stone Spike",
	type = ATK_EARTH,
	power = 60,
	accuracy = 95,
	costtype = CST_SP,
	cost = 4,
	desc = "Orbal Art\nLight Earth Damage to one enemy\nMay cause Dizzy",
	status = COND_DIZZY,
	statuschance = 5,
	target = TGT_ENEMY,		
	anim = function(mo, targets, hittargets, timer)
		if timer == 10
			localquake(mo.battlen, FRACUNIT*10, 10)
			damageObject(hittargets[1])
			for i = 1,5
				local rock = P_SpawnMobj(hittargets[1].x, hittargets[1].y, hittargets[1].z, MT_FALLINGROCK)
				rock.momx = P_RandomRange(-6, 6)*FRACUNIT
				rock.momy = P_RandomRange(-6, 6)*FRACUNIT
				rock.momz = 5*FRACUNIT
				rock.fuse = TICRATE/2
			end
		end
				
		if timer == TICRATE then return true end
	end,
}

attackDefs["stone_hammer"] = {
	name = "Stone Hammer",
	type = ATK_EARTH,	    		
	power = 140,
	accuracy = 95,
	costtype = CST_SP,
	cost = 8,
	desc = "Orbal Art\nMedium Earth Damage to one enemy\nMay cause Dizzy",
	status = COND_DIZZY,
	statuschance = 5,
	target = TGT_ENEMY,		
	anim = function(mo, targets, hittargets, timer)
		if timer == 1			
			for i = 1,10
				local rock = P_SpawnMobj(hittargets[1].x + P_RandomRange(-10, 10)*FRACUNIT,
				hittargets[1].y + P_RandomRange(-10, 10)*FRACUNIT,
				hittargets[1].z + P_RandomRange(500, 600)*FRACUNIT, MT_FALLINGROCK)
				rock.momz = -20*FRACUNIT
				rock.fuse = 2*TICRATE
			end
		end
		
		if timer == TICRATE
			localquake(mo.battlen, FRACUNIT*10, 10)
			damageObject(hittargets[1])
		end
				
		if timer == 2*TICRATE then return true end
	end,
}

attackDefs["gaea_titanis"] = {
	name = "Gaea Titanis",
	type = ATK_EARTH,	    		
	power = 350,
	accuracy = 95,
	costtype = CST_SP,
	cost = 12,
	desc = "Orbal Art\nHeavy Earth Damage to one enemy\nMay cause Dizzy",
	status = COND_DIZZY,
	statuschance = 5,
	target = TGT_ENEMY,		
	anim = function(mo, targets, hittargets, timer)
		local t = hittargets[1]
		if timer < 3*TICRATE
			if not (leveltime%10)
				local j = P_SpawnMobj(t.x, t.y, t.z, MT_DUMMY)
				j.sprite = SPR_CRCB
				j.frame = FF_FULLBRIGHT|A
				j.color = SKINCOLOR_BROWN
				j.colorized = true
				j.fuse = TICRATE
				j.scale = FRACUNIT
				j.destscale = 5*FRACUNIT

				j.renderflags = RF_SLOPESPLAT|RF_NOSPLATBILLBOARD
				j.flags2 = MF2_SPLAT

				P_CreateFloorSpriteSlope(j)
				j.floorspriteslope.o = {
					x = j.x+32*FRACUNIT,
					y = j.y+32*FRACUNIT,
					z = j.z
				}
			end

			if timer > 30 and timer < 80
				local rock = P_SpawnMobj(t.x, t.y, t.z, MT_FALLINGROCK)
				rock.momx = P_RandomRange(-10, 10)*FRACUNIT
				rock.momy = P_RandomRange(-10, 10)*FRACUNIT
				rock.momz = P_RandomRange(10, 20)*FRACUNIT
				rock.color = SKINCOLOR_ORANGE
				rock.colorized = true

				rock.fuse = 2*TICRATE
			end
		end

		if timer == 2 
			playSound(mo.battlen, sfx_rumble)
			localquake(mo.battlen, 5*FRACUNIT, 30)
		end
		
		if timer == 30
			playSound(mo.battlen, sfx_rocks1)
			localquake(mo.battlen, 12*FRACUNIT, 75)
			damageObject(t)
		end

		if timer == 3*TICRATE then return true end
	end,
}

attackDefs["titanic_roar"] = {
	name = "Titanic Roar",
	type = ATK_EARTH,   		
	power = 650,
	accuracy = 95,
	costtype = CST_SP,
	cost = 40,
	desc = "Orbal Art\nSevere Earth Damage to one enemy",
	target = TGT_ENEMY,
	anim = function(mo, targets, hittargets, timer)
		if timer < 7*TICRATE
			localquake(mo.battlen, FRACUNIT*10, 10)

			local rock = P_SpawnMobj(P_RandomRange(-500, 500)*FRACUNIT, P_RandomRange(-500, 500)*FRACUNIT, mo.z, MT_FALLINGROCK)
			rock.scale = P_RandomRange(FRACUNIT/8, FRACUNIT)
			rock.momz = P_RandomRange(1, 5)*FRACUNIT
			rock.fuse = 10
		end

		if timer == 5*TICRATE
			for i = 1, 20
				local rock = P_SpawnMobj(hittargets[1].x + P_RandomRange(-10, 10)*FRACUNIT,
				hittargets[1].y + P_RandomRange(-10, 10)*FRACUNIT,
				hittargets[1].z + P_RandomRange(500, 600)*FRACUNIT, MT_FALLINGROCK)
				rock.momz = -20*FRACUNIT
				rock.fuse = 2*TICRATE
			end

			localquake(mo.battlen, FRACUNIT*20, 10)
			damageObject(hittargets[1])
		end
		
		if timer == 7
		playSound(mo.battlen, sfx_s3kcbl)
		end
		
		if timer == 8*TICRATE then return true end
	end,
}

attackDefs["quake"] = {
	name = "Quake",
	type = ATK_EARTH,
	power = 60,
	accuracy = 95,
	costtype = CST_SP,
	cost = 8,
	desc = "Orbal Art\nLight Earth Damage to all enemies\nMay cause Dizzy",
	status = COND_DIZZY,
	statuschance = 5,
	target = TGT_ALLENEMIES,		
	anim = function(mo, targets, hittargets, timer)
		for k,v in ipairs(hittargets)
			if timer == (10 + (k*3))
				localquake(mo.battlen, FRACUNIT*10, 10)
				damageObject(v)
				for i = 1,5
					local rock = P_SpawnMobj(v.x, v.y, v.z, MT_FALLINGROCK)
					rock.momx = P_RandomRange(-6, 6)*FRACUNIT
					rock.momy = P_RandomRange(-6, 6)*FRACUNIT
					rock.momz = 5*FRACUNIT
					rock.fuse = TICRATE/2
				end
			end
		end
				
		if timer == (TICRATE + (#hittargets*3)) then return true end
	end,
}

attackDefs["stone_impact"] = {
	name = "Stone Impact",
	type = ATK_EARTH,	    		
	power = 140,
	accuracy = 95,
	costtype = CST_SP,
	cost = 16,
	desc = "Orbal Art\nMedium Earth Damage to all enemies\nMay cause Dizzy",
	status = COND_DIZZY,
	statuschance = 5,
	target = TGT_ALLENEMIES,		
	anim = function(mo, targets, hittargets, timer)
		for k,v in ipairs(hittargets)
			if timer == k*3	
				for i = 1,7
					local rock = P_SpawnMobj(v.x + P_RandomRange(-10, 10)*FRACUNIT,
					v.y + P_RandomRange(-10, 10)*FRACUNIT,
					v.z + P_RandomRange(500, 600)*FRACUNIT, MT_FALLINGROCK)
					rock.momz = -20*FRACUNIT
					rock.fuse = 2*TICRATE
				end
			end
			
			if timer == TICRATE + k*3
				localquake(mo.battlen, FRACUNIT*10, 10)
				damageObject(v)
			end
		end
				
		if timer == (2*TICRATE + (#hittargets*3)) then return true end
	end,
}

attackDefs["atlas_hammer"] = {
	name = "Atlas Hammer",
	type = ATK_EARTH,	    		
	power = 350,
	accuracy = 95,
	costtype = CST_SP,
	cost = 24,
	desc = "Orbal Art\nHeavy Earth Damage to all enemies\nMay cause Dizzy",
	status = COND_DIZZY,
	statuschance = 5,
	target = TGT_ALLENEMIES,
	anim = function(mo, targets, hittargets, timer)
		for k,v in ipairs(hittargets)
			local t = v
			local time = timer + (k*8)
			if time < 3*TICRATE
				if not (leveltime%10)
					local j = P_SpawnMobj(t.x, t.y, t.z, MT_DUMMY)
					j.sprite = SPR_CRCB
					j.frame = FF_FULLBRIGHT|A
					j.color = SKINCOLOR_BROWN
					j.colorized = true
					j.fuse = TICRATE
					j.scale = FRACUNIT
					j.destscale = 5*FRACUNIT

					j.renderflags = RF_SLOPESPLAT|RF_NOSPLATBILLBOARD
					j.flags2 = MF2_SPLAT

					P_CreateFloorSpriteSlope(j)
					j.floorspriteslope.o = {
						x = j.x+32*FRACUNIT,
						y = j.y+32*FRACUNIT,
						z = j.z
					}
				end

				if time > 30 and timer < 80
					local rock = P_SpawnMobj(t.x, t.y, t.z, MT_FALLINGROCK)
					rock.momx = P_RandomRange(-10, 10)*FRACUNIT
					rock.momy = P_RandomRange(-10, 10)*FRACUNIT
					rock.momz = P_RandomRange(10, 20)*FRACUNIT
					rock.color = SKINCOLOR_ORANGE
					rock.colorized = true

					rock.fuse = 2*TICRATE
				end
			end

			if time == 2 
				playSound(mo.battlen, sfx_rumble)
				localquake(mo.battlen, 5*FRACUNIT, 30)
			end
			
			if time == 30
				playSound(mo.battlen, sfx_rocks1)
				localquake(mo.battlen, 12*FRACUNIT, 75)
				damageObject(t)
			end
		end
				
		if timer == 3*TICRATE + (#hittargets*8) then return true end
	end,
}

attackDefs["aqua_bleed"] = {
	name = "Aqua Bleed",
	type = ATK_WATER,	    		
	power = 60,
	accuracy = 95,
	costtype = CST_SP,
	cost = 4,
	desc = "Orbal Art\nLight Water Damage to one enemy",
	technical = COND_BURN,
	target = TGT_ENEMY,		
	anim = function(mo, targets, hittargets, timer)
		if timer == 10
			localquake(mo.battlen, FRACUNIT*10, 10)
			damageObject(hittargets[1])
			local water = P_SpawnMobj(hittargets[1].x, hittargets[1].y, hittargets[1].z, MT_DUMMY)
			water.sprite = SPR_WATE
			water.frame = FF_FULLBRIGHT|A
			water.fuse = 5
		elseif timer == 15
			local water = P_SpawnMobj(hittargets[1].x, hittargets[1].y, hittargets[1].z, MT_DUMMY)
			water.sprite = SPR_WATE
			water.frame = FF_FULLBRIGHT|B
			water.fuse = 5
		elseif timer == 20
			local water = P_SpawnMobj(hittargets[1].x, hittargets[1].y, hittargets[1].z, MT_DUMMY)
			water.sprite = SPR_WATE
			water.frame = FF_FULLBRIGHT|C
			water.fuse = 5
		elseif timer == 25
			local water = P_SpawnMobj(hittargets[1].x, hittargets[1].y, hittargets[1].z, MT_DUMMY)
			water.sprite = SPR_WATE
			water.frame = FF_FULLBRIGHT|D
			water.fuse = 5
		elseif timer == 30
			local water = P_SpawnMobj(hittargets[1].x, hittargets[1].y, hittargets[1].z, MT_DUMMY)
			water.sprite = SPR_WATE
			water.frame = FF_FULLBRIGHT|E
			water.fuse = 5
		elseif timer == 35
			local water = P_SpawnMobj(hittargets[1].x, hittargets[1].y, hittargets[1].z, MT_DUMMY)
			water.sprite = SPR_WATE
			water.frame = FF_FULLBRIGHT|F
			water.fuse = 5
		elseif timer == 40
			local water = P_SpawnMobj(hittargets[1].x, hittargets[1].y, hittargets[1].z, MT_DUMMY)
			water.sprite = SPR_WATE
			water.frame = FF_FULLBRIGHT|G
			water.fuse = 5
		elseif timer == 45
			local water = P_SpawnMobj(hittargets[1].x, hittargets[1].y, hittargets[1].z, MT_DUMMY)
			water.sprite = SPR_WATE
			water.frame = FF_FULLBRIGHT|H
			water.fuse = 8
		end
				
		if timer == 80 then return true end
	end,
}

attackDefs["blue_impact"] = {
	name = "Blue Impact",
	type = ATK_WATER,	    		
	power = 140,
	accuracy = 95,
	costtype = CST_SP,
	cost = 8,
	desc = "Orbal Art\nMedium Water Damage to one enemy",
	technical = COND_BURN,
	target = TGT_ENEMY,		
	anim = function(mo, targets, hittargets, timer)
		if timer < 30
			local water = P_SpawnMobj(hittargets[1].x + P_RandomRange(-10, 10)*FRACUNIT,
			hittargets[1].y + P_RandomRange(-10, 10)*FRACUNIT,
			hittargets[1].z + P_RandomRange(500, 600)*FRACUNIT, MT_LAVAFALL_LAVA)
			water.momz = -20*FRACUNIT
			water.fuse = 2*TICRATE
			water.color = SKINCOLOR_WAVE
			water.colorized = true
		end
		
		if timer == TICRATE
			damageObject(hittargets[1])
		end
				
		if timer == 2*TICRATE then return true end
	end,
}

attackDefs["blue_ascension"] = {
	name = "Blue Ascension",
	type = ATK_WATER,	    		
	power = 350,
	accuracy = 95,
	costtype = CST_SP,
	cost = 12,
	desc = "Orbal Art\nHeavy Water Damage to one enemy",
	technical = COND_BURN,
	target = TGT_ENEMY,		
	anim = function(mo, targets, hittargets, timer)
		local targ = hittargets[1]

		if timer == 1
		or timer == 10
		or timer == 20
		or timer == 30
		or timer == 40
		or timer == 50
		or timer == 60
		or timer == 70
		or timer == 80
			localquake(mo.battlen, FRACUNIT*10, 10)
			playSound(mo.battlen, sfx_water1)
			targ.varx = P_RandomRange(-200, 200)
			targ.vary = P_RandomRange(-200, 200)
		end
		
		if timer < 100
			local water = P_SpawnMobj(targ.x + targ.varx*FRACUNIT, 
			targ.y + targ.vary*FRACUNIT, targ.z + 2*FRACUNIT, MT_LAVAFALL_LAVA)
			water.color = SKINCOLOR_WAVE
			water.colorized = true
			water.momz = 20*FRACUNIT
			water.fuse = 2*TICRATE
			water.rollangle = ANGLE_180
		end
		
		if timer > 120 and timer < 180
			local water = P_SpawnMobj(targ.x, targ.y, targ.z + 2*FRACUNIT, MT_LAVAFALL_LAVA)
			water.color = SKINCOLOR_WAVE
			water.colorized = true
			water.momz = 20*FRACUNIT
			water.fuse = 2*TICRATE
			water.rollangle = ANGLE_180
		end
		
		if timer == 120
			localquake(mo.battlen, FRACUNIT*10, 10)
			playSound(mo.battlen, sfx_water1)
			damageObject(hittargets[1])
		end
				
		if timer == 200 then return true end
	end,
}

attackDefs["maelstorm"] = {
	name = "Maelstorm",
	type = ATK_WATER,	    		
	power = 650,
	accuracy = 95,
	costtype = CST_SP,
	cost = 40,
	desc = "Orbal Art\nSevere Water Damage to one enemy",
	target = TGT_ENEMY,		
	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]
		if timer == 1 then mo.waterMobj = {} end
		
		if timer < 60
			if not S_SoundPlaying(target, sfx_water1) then S_StartSound(target, sfx_water1) end
			local an = leveltime*ANG1*2
			local m = P_SpawnMobj(target.x, target.y, target.z, MT_LAVAFALL_LAVA)
			m.color = SKINCOLOR_WAVE
			m.colorized = true
			m.fuse = TICRATE
			m.tics = TICRATE
			m.extravalue = an + (360/8)*ANG1
			m.extravalue2 = timer
			m.momz = 56*FRACUNIT
			table.insert(mo.waterMobj, m)
		end
	
		for k,v in ipairs(mo.waterMobj)
			if v.valid
				P_TeleportMove(v, target.x + v.extravalue2*cos(v.extravalue), target.y + v.extravalue2*sin(v.extravalue), v.z)
				v.extravalue = $+ ANG1*64
				v.extravalue2 = $+8			
				
				if timer == 60 
					table.remove(mo.firespin.waterMobj, k)
					P_RemoveMobj(v)
				end
			end
		end
		
		if timer == 50 then damageObject(target) end		
		if timer == 70 then mo.waterMobj = nil return true end
	end,
}

attackDefs["blue_drop"] = {
	name = "Blue Drop",
	type = ATK_WATER,
	power = 60,
	accuracy = 95,
	costtype = CST_SP,
	cost = 8,
	desc = "Orbal Art\nLight Water Damage to all enemies",
	technical = COND_FREEZE,
	target = TGT_ALLENEMIES,		
	anim = function(mo, targets, hittargets, timer)
		for k,v in ipairs(hittargets)
			local time = (timer + (k*3))	

			if time == 10
				localquake(mo.battlen, FRACUNIT*10, 10)
				damageObject(v)
				local water = P_SpawnMobj(v.x, v.y, v.z, MT_DUMMY)
				water.sprite = SPR_WATE
				water.frame = FF_FULLBRIGHT|A
				water.fuse = 5
			elseif time == 15
				local water = P_SpawnMobj(v.x, v.y, v.z, MT_DUMMY)
				water.sprite = SPR_WATE
				water.frame = FF_FULLBRIGHT|B
				water.fuse = 5
			elseif time == 20
				local water = P_SpawnMobj(v.x, v.y, v.z, MT_DUMMY)
				water.sprite = SPR_WATE
				water.frame = FF_FULLBRIGHT|C
				water.fuse = 5
			elseif time == 25
				local water = P_SpawnMobj(v.x, v.y, v.z, MT_DUMMY)
				water.sprite = SPR_WATE
				water.frame = FF_FULLBRIGHT|D
				water.fuse = 5
			elseif time == 30
				local water = P_SpawnMobj(v.x, v.y, v.z, MT_DUMMY)
				water.sprite = SPR_WATE
				water.frame = FF_FULLBRIGHT|E
				water.fuse = 5
			elseif time == 35
				local water = P_SpawnMobj(v.x, v.y, v.z, MT_DUMMY)
				water.sprite = SPR_WATE
				water.frame = FF_FULLBRIGHT|F
				water.fuse = 5
			elseif time == 40
				local water = P_SpawnMobj(v.x, v.y, v.z, MT_DUMMY)
				water.sprite = SPR_WATE
				water.frame = FF_FULLBRIGHT|G
				water.fuse = 5
			elseif time == 45
				local water = P_SpawnMobj(v.x, v.y, v.z, MT_DUMMY)
				water.sprite = SPR_WATE
				water.frame = FF_FULLBRIGHT|H
				water.fuse = 8
			end
		end
				
		if timer == (80 + (#hittargets*3)) then return true end
	end,
}

attackDefs["hydro_cannon"] = {
	name = "Hydro Cannon",
	type = ATK_WATER,	    		
	power = 140,
	accuracy = 95,
	costtype = CST_SP,
	cost = 16,
	desc = "Orbal Art\nMedium Water Damage to all enemies",
	technical = COND_BURN,
	target = TGT_ALLENEMIES,		
	anim = function(mo, targets, hittargets, timer)
		for k,v in ipairs(hittargets)
			if timer < 30
				local water = P_SpawnMobj(v.x + P_RandomRange(-10, 10)*FRACUNIT,
				v.y + P_RandomRange(-10, 10)*FRACUNIT,
				v.z + P_RandomRange(500, 600)*FRACUNIT, MT_LAVAFALL_LAVA)
				water.momz = -20*FRACUNIT
				water.fuse = 2*TICRATE
				water.color = SKINCOLOR_WAVE
				water.colorized = true
			end
			
			if timer == TICRATE
				damageObject(v)
			end
		end
				
		if timer == (2*TICRATE + (#hittargets*3)) then return true end
	end,
}

attackDefs["genesis_flood"] = {
	name = "Genesis Flood",
	type = ATK_WATER,	    		
	power = 350,
	accuracy = 95,
	costtype = CST_SP,
	cost = 24,
	desc = "Orbal Art\nHeavy Water Damage to all enemies",
	technical = COND_BURN,
	target = TGT_ALLENEMIES,
	anim = function(mo, targets, hittargets, timer)
		for k,v in ipairs(hittargets)
			if timer == k*5
			or timer == 10 + (k*5)
			or timer == 20 + (k*5)
			or timer == 30 + (k*5)
			or timer == 40 + (k*5)
			or timer == 50 + (k*5)
			or timer == 60 + (k*5)
			or timer == 70 + (k*5)
			or timer == 80 + (k*5)
				localquake(mo.battlen, FRACUNIT*10, 10)
				playSound(mo.battlen, sfx_water1)
				v.varx = P_RandomRange(-200, 200)
				v.vary = P_RandomRange(-200, 200)
			end
			
			if timer < 100 + (k*5) and v.varx and v.vary
				local water = P_SpawnMobj(v.x + v.varx*FRACUNIT, 
				v.y + v.vary*FRACUNIT, v.z + 2*FRACUNIT, MT_LAVAFALL_LAVA)
				water.color = SKINCOLOR_WAVE
				water.colorized = true
				water.momz = 20*FRACUNIT
				water.fuse = 2*TICRATE
				water.rollangle = ANGLE_180
			end
			
			if timer > 120 + (k*5) and timer < 180 + (k*5)
				local water = P_SpawnMobj(v.x, v.y, v.z + 2*FRACUNIT, MT_LAVAFALL_LAVA)
				water.color = SKINCOLOR_WAVE
				water.colorized = true
				water.momz = 20*FRACUNIT
				water.fuse = 2*TICRATE
				water.rollangle = ANGLE_180
			end
			
			if timer == 120 + (k*5)
				localquake(mo.battlen, FRACUNIT*10, 10)
				playSound(mo.battlen, sfx_water1)
				damageObject(v)
			end
		end
				
		if timer == 200 + (#hittargets*5) then return true end
	end,
}

attackDefs["scrap_bolt"] = {
	name = "Scrap Bolt",
	type = ATK_METAL,
	power = 60,
	accuracy = 95,
	critical = 5,
	costtype = CST_SP,
	cost = 4,
	desc = "Tita's Invention\nLight Metal Damage to a enemy\nCan do crits",
	target = TGT_ENEMY,
	technical = COND_FREEZE,
	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]

		if timer == 10
			playSound(mo.battlen, sfx_karin)
		end

		if timer <= 30
			local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
			thok.state = S_CDUST1
			thok.momz = P_RandomRange(3, 10)*FRACUNIT
			thok.color = SKINCOLOR_SILVER
			thok.tics = P_RandomRange(10, 35)
			thok.scale = FRACUNIT*3/2
		end

		if timer == 20
			damageObject(target)
			for i = 1, 32
				local thok = P_SpawnMobj(target.x, target.y, target.z, MT_SUPERSPARK)
				thok.momx = P_RandomRange(3, 10)*FRACUNIT
				thok.momy = P_RandomRange(3, 10)*FRACUNIT
				thok.momz = P_RandomRange(3, 10)*FRACUNIT
				thok.color = SKINCOLOR_JET
				thok.scale = FRACUNIT*3/2
				thok.colorized = true
			end
		elseif timer == 42
			return true
		end
	end,
}

attackDefs["metal_blast"] = {
	name = "Metal Blast",
	type = ATK_METAL,
	power = 140,
	accuracy = 95,
	critical = 5,
	costtype = CST_SP,
	cost = 8,
	desc = "Tita's Invention\nMedium Metal Damage to a enemy\nCan do crits",
	target = TGT_ENEMY,
	technical = COND_FREEZE,
	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]
		
		if timer == 1 then playSound(mo.battlen, sfx_hama3) end

		if timer < 40 and not (leveltime%8)
			for k = 1, 36
				local lolusuck = P_SPMAngle(target, MT_SUPERSPARK, k*10*ANG10)
				lolusuck.color = SKINCOLOR_JET
				lolusuck.colorized = true
				P_InstaThrust(lolusuck, k*10*ANG10, P_RandomRange(35, 50)*FRACUNIT)

				local lolusuckstill = P_SPMAngle(target, MT_SPINDUST, k*10*ANG10)
				lolusuckstill.color = SKINCOLOR_JET
				lolusuckstill.colorized = true
				P_InstaThrust(lolusuckstill, k*10*ANG10, P_RandomRange(10, 19)*FRACUNIT)
			end
		end
		
		if timer == 40 then damageObject(target) end
		
		if timer > 40 and timer < 60
			local hit = P_SpawnMobj(target.x + P_RandomRange(-50, 50)*FRACUNIT, target.y + P_RandomRange(-50, 50)*FRACUNIT, target.z, MT_SUPERSPARK)
			hit.momz = 20*FRACUNIT
			hit.color = SKINCOLOR_JET
			hit.colorized = true
			
			local hitagainlol = P_SpawnMobj(target.x + P_RandomRange(-50, 50)*FRACUNIT, target.y + P_RandomRange(-50, 50)*FRACUNIT, target.z, MT_THOK)
			hitagainlol.momz = 36*FRACUNIT
			hitagainlol.color = SKINCOLOR_JET
		end
		
		if timer == 95 then return true end
	end,
}

attackDefs["blast_force"] = {
	name = "Blast Force",
	type = ATK_METAL,
	power = 350,
	accuracy = 95,
	critical = 5,
	costtype = CST_SP,
	cost = 16,
	desc = "Tita's Invention\nHeavy Metal Damage to a enemy\nCan do crits",
	target = TGT_ENEMY,
	technical = COND_FREEZE,
	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]

		if timer == 20
		or timer == 40
		or timer == 50
		or timer == 60
		or timer == 65
		or timer == 70
		or timer == 75
		or timer == 80
			playSound(mo.battlen, sfx_hamas1)
			for i = 1, 32
				local x,y,z = target.x+P_RandomRange(-60, 60)*FRACUNIT, target.y+P_RandomRange(-60, 60)*FRACUNIT, target.z+P_RandomRange(-20, 60)*FRACUNIT
				local thok = P_SpawnMobj(x, y, z, MT_SUPERSPARK)
				thok.momx = P_RandomRange(-10, 10)*FRACUNIT
				thok.momy = P_RandomRange(-10, 10)*FRACUNIT
				thok.momz = P_RandomRange(3, 10)*FRACUNIT
				thok.color = SKINCOLOR_JET
				thok.scale = FRACUNIT*3/2
				thok.colorized = true
			end
		end

		if timer == 85 then damageObject(target) end

		if timer > 85 and timer < 100
			local hit = P_SpawnMobj(target.x + P_RandomRange(-50, 50)*FRACUNIT, target.y + P_RandomRange(-50, 50)*FRACUNIT, target.z, MT_SUPERSPARK)
			hit.momz = 20*FRACUNIT
			hit.color = SKINCOLOR_JET
			hit.colorized = true
			
			local hitagainlol = P_SpawnMobj(target.x + P_RandomRange(-50, 50)*FRACUNIT, target.y + P_RandomRange(-50, 50)*FRACUNIT, target.z, MT_THOK)
			hitagainlol.momz = 36*FRACUNIT
			hitagainlol.color = SKINCOLOR_JET
			
			if not (leveltime%4)
				for k = 1, 36
					local lolusuck = P_SPMAngle(target, MT_SUPERSPARK, k*10*ANG10)
					lolusuck.color = SKINCOLOR_JET
					lolusuck.colorized = true
					P_InstaThrust(lolusuck, k*10*ANG10, P_RandomRange(35, 50)*FRACUNIT)

					local lolusuckstill = P_SPMAngle(target, MT_SPINDUST, k*10*ANG10)
					lolusuckstill.color = SKINCOLOR_JET
					lolusuckstill.colorized = true
					P_InstaThrust(lolusuckstill, k*10*ANG10, P_RandomRange(10, 19)*FRACUNIT)
				end
			end
		elseif timer == 130
			return true
		end
	end,
}

attackDefs["scrap_wave"] = {
	name = "Scrap Wave",
	type = ATK_METAL,
	power = 60,
	accuracy = 95,
	critical = 5,
	costtype = CST_SP,
	cost = 8,
	desc = "Tita's Invention\nLight Metal Damage to all enemies\nCan do crits",
	target = TGT_ALLENEMIES,
	technical = COND_FREEZE,
	anim = function(mo, targets, hittargets, timer)
		for i,target in ipairs(hittargets)
			local time = timer-(i*7)

			if time == 30
				playSound(mo.battlen, sfx_karin)
			end

			if time <= 55
				local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
				thok.state = S_CDUST1
				thok.momz = P_RandomRange(3, 10)*FRACUNIT
				thok.color = SKINCOLOR_SILVER
				thok.tics = P_RandomRange(10, 35)
				thok.scale = FRACUNIT*3/2
			end

			if time == 50
				damageObject(target)
				for i = 1, 32
					local thok = P_SpawnMobj(target.x, target.y, target.z, MT_SUPERSPARK)
					thok.momx = P_RandomRange(3, 10)*FRACUNIT
					thok.momy = P_RandomRange(3, 10)*FRACUNIT
					thok.momz = P_RandomRange(3, 10)*FRACUNIT
					thok.color = SKINCOLOR_JET
					thok.scale = FRACUNIT*3/2
					thok.colorized = true
				end
			end
		end
		
		if timer == 60+(#hittargets*7) return true end
	end,
}

attackDefs["junk_blast"] = {
	name = "Junk Blast",
	type = ATK_METAL,
	power = 140,
	accuracy = 95,
	critical = 5,
	costtype = CST_SP,
	cost = 16,
	desc = "Tita's Invention\nMedium Metal Damage to all enemies\nCan do crits",
	target = TGT_ALLENEMIES,
	technical = COND_FREEZE,
	anim = function(mo, targets, hittargets, timer)
		for i,target in ipairs(hittargets)
			local time = timer-(i*20)

			if time == 1 then playSound(mo.battlen, sfx_hama3) end

			if time < 40 and not (leveltime%10)
				for k = 1, 36
					local lolusuck = P_SPMAngle(target, MT_SUPERSPARK, k*10*ANG10)
					lolusuck.color = SKINCOLOR_JET
					lolusuck.colorized = true
					P_InstaThrust(lolusuck, k*10*ANG10, P_RandomRange(35, 50)*FRACUNIT)

					local lolusuckstill = P_SPMAngle(target, MT_SPINDUST, k*10*ANG10)
					lolusuckstill.color = SKINCOLOR_JET
					lolusuckstill.colorized = true
					P_InstaThrust(lolusuckstill, k*10*ANG10, P_RandomRange(10, 19)*FRACUNIT)
				end
			end

			if time == 40 then damageObject(target) end

			if time > 40 and timer < 60
				local hit = P_SpawnMobj(target.x + P_RandomRange(-50, 50)*FRACUNIT, target.y + P_RandomRange(-50, 50)*FRACUNIT, target.z, MT_SUPERSPARK)
				hit.momz = 20*FRACUNIT
				hit.color = SKINCOLOR_JET
				hit.colorized = true
				
				local hitagainlol = P_SpawnMobj(target.x + P_RandomRange(-50, 50)*FRACUNIT, target.y + P_RandomRange(-50, 50)*FRACUNIT, target.z, MT_THOK)
				hitagainlol.momz = 36*FRACUNIT
				hitagainlol.color = SKINCOLOR_JET
			end
		end
		
		if timer == 80+(#hittargets*20) then return true end
	end,
}

attackDefs["orbal_parts"] = {
	name = "Orbal Parts",
	type = ATK_METAL,
	power = 350,
	accuracy = 95,
	critical = 5,
	costtype = CST_SP,
	cost = 24,
	desc = "Tita's Invention\nHeavy Metal Damage to all enemies\nCan do crits",
	target = TGT_ALLENEMIES,
	technical = COND_FREEZE,
	anim = function(mo, targets, hittargets, timer)
		for i,target in ipairs(hittargets)
			local time = timer-(i*7)

			if time == 20
			or time == 40
			or time == 50
			or time == 60
			or time == 65
			or time == 70
			or time == 75
			or time == 80
				playSound(mo.battlen, sfx_hamas1)
				for i = 1, 32
					local x,y,z = target.x+P_RandomRange(-60, 60)*FRACUNIT, target.y+P_RandomRange(-60, 60)*FRACUNIT, target.x+P_RandomRange(-20, 60)*FRACUNIT
					local thok = P_SpawnMobj(x, y, z, MT_SUPERSPARK)
					thok.momx = P_RandomRange(-10, 10)*FRACUNIT
					thok.momy = P_RandomRange(-10, 10)*FRACUNIT
					thok.momz = P_RandomRange(3, 10)*FRACUNIT
					thok.color = SKINCOLOR_JET
					thok.scale = FRACUNIT*3/2
					thok.colorized = true
				end
			end

			if time == 85 then damageObject(target) end

			if time > 85 and time < 100
				local hit = P_SpawnMobj(target.x + P_RandomRange(-50, 50)*FRACUNIT, target.y + P_RandomRange(-50, 50)*FRACUNIT, target.z, MT_SUPERSPARK)
				hit.momz = 20*FRACUNIT
				hit.color = SKINCOLOR_JET
				hit.colorized = true
				
				local hitagainlol = P_SpawnMobj(target.x + P_RandomRange(-50, 50)*FRACUNIT, target.y + P_RandomRange(-50, 50)*FRACUNIT, target.z, MT_THOK)
				hitagainlol.momz = 36*FRACUNIT
				hitagainlol.color = SKINCOLOR_JET
				
				if not (leveltime%14)
					for k = 1, 36
						local lolusuck = P_SPMAngle(target, MT_SUPERSPARK, k*10*ANG10)
						lolusuck.color = SKINCOLOR_JET
						lolusuck.colorized = true
						P_InstaThrust(lolusuck, k*10*ANG10, P_RandomRange(35, 50)*FRACUNIT)

						local lolusuckstill = P_SPMAngle(target, MT_SPINDUST, k*10*ANG10)
						lolusuckstill.color = SKINCOLOR_JET
						lolusuckstill.colorized = true
						P_InstaThrust(lolusuckstill, k*10*ANG10, P_RandomRange(10, 19)*FRACUNIT)
					end
				end
			end
		end
		
		if timer == 110+(#hittargets*7) then return true end
	end,
}

attackDefs["chaos_brand"] = {
	name = "Chaos Brand",
	type = ATK_GRAVITY,
	power = 60,
	accuracy = 95,
	costtype = CST_SP,
	cost = 4,
	desc = "Orbal Art\nLight Gravity Damage to one enemy",
	target = TGT_ENEMY,	
	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]

		if timer == 20
			playSound(mo.battlen, sfx_absorb)
			local x,y = target.x, target.y
			local frei = P_SpawnMobj(x, y, target.z+FRACUNIT*10, MT_DUMMY)
			frei.state = S_PLAY_STND
			frei.dispoffset = 5
			frei.tics = -1
			frei.fuse = 60
			frei.sprite = SPR_FREI
			frei.frame = G|TR_TRANS20|FF_FULLBRIGHT
			frei.scale = FRACUNIT*2
			frei.basescale = frei.scale
			frei.color = SKINCOLOR_WHITE
			mo.frei = frei
		elseif timer > 20 and timer <= 50
			mo.frei.basescale = max(1, $ - FRACUNIT/12)
			if timer%2 == 0
				mo.frei.flags2 = $|MF2_DONTDRAW
				if timer%4 == 0
					mo.frei.scale = mo.frei.basescale*10/8
				else
					mo.frei.scale = mo.frei.basescale
				end
			else
				mo.frei.flags2 = $ & ~ MF2_DONTDRAW
			end

			local x = target.x + P_RandomRange(-120, 120)*target.scale
			local y = target.y + P_RandomRange(-120, 120)*target.scale
			local a = P_SpawnMobj(x, y, target.z + 180*target.scale, MT_DUMMY)
			a.state = S_CQUICKBOOM1
			a.color = SKINCOLOR_WHITE
			a.flags = $|MF_NOCLIPHEIGHT
			a.scale = FRACUNIT*3/2
			a.momz = -target.scale*20

			local h_angle = P_RandomRange(1, 359)*ANG1
			local v_angle = P_RandomRange(1, 359)*ANG1
			local dist = 256
			local spd = P_RandomRange(40, 50)

			local s_x = target.x+ dist*FixedMul(cos(h_angle), cos(v_angle))
			local s_y = target.y+ dist*FixedMul(sin(h_angle), cos(v_angle))
			local s_z = (target.z+target.height/2)+ dist* sin(v_angle)

			local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

			s.frame = A
			s.color = SKINCOLOR_WHITE
			s.scale = FRACUNIT/2
			s.destscale = 1
			s.target = mo
			s.tics = 10
			s.momx = (target.x - s.x)/10
			s.momy = (target.y - s.y)/10
			s.momz = (target.z - s.z)/10
		elseif timer == 51
			damageObject(target)
			mo.frei.fuse = 1
			for i = 1, 16
				local boom = P_SpawnMobj(target.x + P_RandomRange(-20, 20)*FRACUNIT, target.y + P_RandomRange(-20, 20)*FRACUNIT, target.z + 10*FRACUNIT, MT_DUMMY)
				boom.state = S_CQUICKBOOM1
				boom.color = SKINCOLOR_WHITE
				boom.momx = P_RandomRange(-20, 20)*FRACUNIT
				boom.momy = P_RandomRange(-20, 20)*FRACUNIT
				boom.momz = P_RandomRange(-20, 20)*FRACUNIT
				boom.scale = FRACUNIT*3/2
			end
			playSound(mo.battlen, sfx_megi6)
			localquake(mo.battlen, FRACUNIT*16, 10)
			mo.frei = nil
		elseif timer == 90
			return true
		end
	end,
}

attackDefs["ascension"] = {
	name = "Ascension",
	type = ATK_GRAVITY,	    		
	power = 140,
	accuracy = 95,
	costtype = CST_SP,
	cost = 8,
	desc = "Orbal Art\nMedium Gravity Damage to one enemy",
	target = TGT_ENEMY,
	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]
		
		if not (leveltime%15) then playSound(mo.battlen, sfx_hamas2) end

		if timer == 10 or timer == 30 or timer == 50
			target.gryvax = target.x+P_RandomRange(-60, 60)*FRACUNIT
			target.gryvay = target.y+P_RandomRange(-60, 60)*FRACUNIT
		elseif timer == 70
			target.gryvax = target.x
			target.gryvay = target.y
			
			damageObject(target)
		end
		
		if timer > 11 and timer < 90
			local x, y = target.gryvax, target.gryvay
			for i = 1, 16
				local x2 = x + 60*cos((i*20)*ANG1)
				local y2 = y + 60*sin((i*20)*ANG1)
				
				local spark = P_SpawnMobj(x2, y2, target.z, MT_DUMMY)
				spark.state = S_BOXSPARKLE1
				spark.momz = P_RandomRange(1, 20)*FRACUNIT
			end
		end
				
		if timer == 100
			target.gryvax = nil
			target.gryvay = nil
			return true
		end
	end,
}

attackDefs["luminous_ray"] = {
	name = "Luminous Ray",
	type = ATK_GRAVITY,	    		
	power = 350,
	accuracy = 95,
	costtype = CST_SP,
	cost = 12,
	desc = "Orbal Art\nHeavy Gravity Damage to one enemy",
	target = TGT_ENEMY,
	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]
		if timer == 10	
			target.grydynedist = 100
			target.grydyneangle = 1
		end
		
		if timer > 30 and timer < 60
			target.grydyneangle = $+5
		elseif timer > 70 and timer < 100
			target.grydyneangle = $-5
			target.grydynedist = $+10
		elseif timer > 115
			target.grydyneangle = $+12
			if target.grydynedist > 0 
				target.grydynedist = $-40
			elseif target.grydynedist <= 0 and not target.grydynedamage
				target.grydynedamage = true
				
				damageObject(target)
				DoExplosion(target)
			end
		end
		
		if timer > 15 and timer < 150 and not (leveltime%4)
			for i = 1, 3
				local x = target.x + target.grydynedist*cos(i*((12*ANG10)+(target.grydyneangle*ANG1)))
				local y = target.y + target.grydynedist*sin(i*((12*ANG10)+(target.grydyneangle*ANG1)))
				local grydyne = P_SpawnMobj(x, y, target.z, MT_DUMMY)
				grydyne.color = SKINCOLOR_WHITE
				grydyne.state = S_MEGITHOK
				grydyne.momz = 20*FRACUNIT
				grydyne.fuse = TICRATE
			end
		end

		if timer == 150
			target.grydynedist = nil
			target.grydyneangle = nil
			target.grydynedamage = nil
			return true
		end
	end,
}

attackDefs["silver_thorn"] = {
	name = "Silver Thorn",
	type = ATK_GRAVITY,
	power = 60,
	accuracy = 95,
	costtype = CST_SP,
	cost = 8,
	desc = "Orbal Art\nLight Gravity Damage to all enemies",
	target = TGT_ALLENEMIES,
	anim = function(mo, targets, hittargets, timer)
		for k,e in ipairs(hittargets)
			local time = timer - 10*(k-1)
			local target = e

			if time == 20
				playSound(mo.battlen, sfx_absorb)
				local x,y = target.x, target.y
				local frei = P_SpawnMobj(x, y, target.z+FRACUNIT*10, MT_DUMMY)
				frei.state = S_PLAY_STND
				frei.dispoffset = 5
				frei.tics = -1
				frei.fuse = 60
				frei.sprite = SPR_FREI
				frei.frame = G|TR_TRANS20|FF_FULLBRIGHT
				frei.scale = FRACUNIT*2
				frei.basescale = frei.scale
				frei.color = SKINCOLOR_WHITE
				target.frei = frei
			elseif time > 20 and time <= 50
				target.frei.basescale = max(1, $ - FRACUNIT/12)
				if time%2 == 0
					target.frei.flags2 = $|MF2_DONTDRAW
					if time%4 == 0
						target.frei.scale = target.frei.basescale*10/8
					else
						target.frei.scale = target.frei.basescale
					end
				else
					target.frei.flags2 = $ & ~ MF2_DONTDRAW
				end

				local x = target.x + P_RandomRange(-120, 120)*target.scale
				local y = target.y + P_RandomRange(-120, 120)*target.scale
				local a = P_SpawnMobj(x, y, target.z + 180*target.scale, MT_DUMMY)
				a.state = S_CQUICKBOOM1
				a.color = SKINCOLOR_WHITE
				a.flags = $|MF_NOCLIPHEIGHT
				a.scale = FRACUNIT*3/2
				a.momz = -target.scale*20

				local h_angle = P_RandomRange(1, 359)*ANG1
				local v_angle = P_RandomRange(1, 359)*ANG1
				local dist = 256
				local spd = P_RandomRange(40, 50)

				local s_x = target.x+ dist*FixedMul(cos(h_angle), cos(v_angle))
				local s_y = target.y+ dist*FixedMul(sin(h_angle), cos(v_angle))
				local s_z = (target.z+target.height/2)+ dist* sin(v_angle)

				local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

				s.frame = A
				s.color = SKINCOLOR_WHITE
				s.scale = FRACUNIT/2
				s.destscale = 1
				s.target = mo
				s.tics = 10
				s.momx = (target.x - s.x)/10
				s.momy = (target.y - s.y)/10
				s.momz = (target.z - s.z)/10
			elseif time == 51
				damageObject(target)
				target.frei.fuse = 1
				for i = 1, 16
					local boom = P_SpawnMobj(target.x + P_RandomRange(-20, 20)*FRACUNIT, target.y + P_RandomRange(-20, 20)*FRACUNIT, target.z + 10*FRACUNIT, MT_DUMMY)
					boom.state = S_CQUICKBOOM1
					boom.color = SKINCOLOR_WHITE
					boom.momx = P_RandomRange(-20, 20)*FRACUNIT
					boom.momy = P_RandomRange(-20, 20)*FRACUNIT
					boom.momz = P_RandomRange(-20, 20)*FRACUNIT
					boom.scale = FRACUNIT*3/2
				end
				playSound(mo.battlen, sfx_megi6)
				localquake(mo.battlen, FRACUNIT*16, 10)
				mo.frei = nil
			end
		end

		if timer == 90 + (#hittargets-1)*10 then return true end
	end,
}

attackDefs["argent_ark"] = {
	name = "Argent Ark",
	type = ATK_GRAVITY,	    		
	power = 140,
	accuracy = 95,
	costtype = CST_SP,
	cost = 16,
	desc = "Orbal Art\nMedium Gravity Damage to all enemies",
	target = TGT_ALLENEMIES,		
	anim = function(mo, targets, hittargets, timer)
		if not (leveltime%15) then playSound(mo.battlen, sfx_hamas2) end

		for i,target in ipairs(hittargets)
			local time = timer-(i*4)

			if time == 10
			or time == 30
			or time == 50
				target.gryvax = target.x+P_RandomRange(-60, 60)*FRACUNIT
				target.gryvay = target.y+P_RandomRange(-60, 60)*FRACUNIT
			elseif time == 70
				target.gryvax = target.x
				target.gryvay = target.y
				
				damageObject(target)
			end
			
			if (time > 11 and time < 90) and not (leveltime%5)
				local x, y = target.gryvax, target.gryvay
				for i = 1, 16
					local x2 = x + 60*cos((i*20)*ANG1)
					local y2 = y + 60*sin((i*20)*ANG1)
					
					local spark = P_SpawnMobj(x2, y2, target.z, MT_DUMMY)
					spark.state = S_BOXSPARKLE1
					spark.momz = P_RandomRange(1, 20)*FRACUNIT
				end
			end
		end
				
		if timer == 100+(#hittargets*4)
			for k,v in ipairs(hittargets)
				v.gryvax = nil
				v.gryvay = nil
			end

			return true
		end
	end,
}

attackDefs["claiomh_solarion"] = {
	name = "Claiomh Solarion",
	type = ATK_GRAVITY,	    		
	power = 350,
	accuracy = 95,
	costtype = CST_SP,
	cost = 24,
	desc = "Orbal Art\nHeavy Gravity Damage to all enemies",
	target = TGT_ALLENEMIES,
	anim = function(mo, targets, hittargets, timer)
		for i,target in ipairs(hittargets)
			local time = timer-(i*4)

			if time == 10	
				target.grydynedist = 100
				target.grydyneangle = 1
			end
			
			if time > 30 and time < 60
				target.grydyneangle = $+5
			elseif time > 70 and time < 100
				target.grydyneangle = $-5
				target.grydynedist = $+10
			elseif time > 115
				target.grydyneangle = $+12
				if target.grydynedist > 0 
					target.grydynedist = $-40
				elseif target.grydynedist <= 0 and not target.grydynedamage
					target.grydynedamage = true
					
					damageObject(target)
					DoExplosion(target)
				end
			end
			
			if time > 15 and time < 150 and not (leveltime%10)
				for i = 1, 3
					local x = target.x + target.grydynedist*cos(i*((12*ANG10)+(target.grydyneangle*ANG1)))
					local y = target.y + target.grydynedist*sin(i*((12*ANG10)+(target.grydyneangle*ANG1)))
					local grydyne = P_SpawnMobj(x, y, target.z, MT_DUMMY)
					grydyne.color = SKINCOLOR_WHITE
					grydyne.state = S_MEGITHOK
					grydyne.momz = 20*FRACUNIT
					grydyne.fuse = TICRATE
				end
			end
		end

		if timer == 150+(#hittargets*4)
			for k,v in ipairs(hittargets)
				v.grydynedist = nil
				v.grydyneangle = nil
				v.grydynedamage = nil
			end

			return true
		end
	end,
}

attackDefs["last_disaster"] = {
	name = "Last Disaster",
	type = ATK_GRAVITY,	    		
	power = 600,
	accuracy = 95,
	costtype = CST_SP,
	cost = 40,
	desc = "Orbal Art\nSevere Gravity Damage to one enemy",
	target = TGT_ENEMY,
	anim = function(mo, targets, hittargets, timer)
		if timer == 2 
			playSound(mo.battlen, sfx_megi2)
			localquake(mo.battlen, 20*FRACUNIT, 100)
		end

		if P_RandomChance(FRACUNIT/20)
			local grydyne = P_SpawnMobj(hittargets[1].x+P_RandomRange(-300, 300)*FRACUNIT, hittargets[1].y+P_RandomRange(-300, 300)*FRACUNIT, hittargets[1].floorz, MT_DUMMY)
			if grydyne.valid
				grydyne.state = S_BOXSPARKLE1
				grydyne.scale = 5*FRACUNIT
				grydyne.destscale = FRACUNIT
				grydyne.fuse = TICRATE
					
				if timer <= 140
					grydyne.momz = 20*FRACUNIT
				else
					grydyne.momz = -40*FRACUNIT
					P_TeleportMove(grydyne, grydyne.x, grydyne.y, grydyne.floorz + 600*FRACUNIT)
				end
			end
		end

		if timer < 10 
			hittargets[1].momz = 15*FRACUNIT 
			hittargets[1].hitfloor = nil
		elseif timer >= 10 and timer < 140
			P_TeleportMove(hittargets[1], hittargets[1].x+P_RandomRange(-50, 50)*FRACUNIT, hittargets[1].y+P_RandomRange(-50, 50)*FRACUNIT, hittargets[1].z+P_RandomRange(-3, 3)*FRACUNIT)
			hittargets[1].rollangle = $+ANGLE_22h
			hittargets[1].momz = 0
		elseif timer >= 140 and timer <= 200 and not hittargets[1].hitfloor
			hittargets[1].momz = -30*FRACUNIT
			hittargets[1].rollangle = 0

			P_SpawnGhostMobj(hittargets[1])
				
			if not hittargets[1].hitfloor and P_IsObjectOnGround(hittargets[1])
				playSound(hittargets[1].battlen, sfx_pstop)
				localquake(hittargets[1].battlen, 30*FRACUNIT, 20)
				hittargets[1].hitfloor = true
			end
		end

		if timer == 100
			damageObject(hittargets[1])
				
			local aura = P_SpawnMobj(hittargets[1].x, hittargets[1].y, hittargets[1].z, MT_DUMMY)
			aura.scale = 1
			aura.sprite = SPR_FORC
			aura.destscale = 5*FRACUNIT
			aura.fuse = TICRATE
		end

		
		if timer >= 200
			for i = 1, #hittargets
				hittargets[i].hitfloor = nil
			end
			
			return true
		end
	end,
}