if not srb2p return end

DNG_Abilities["estelle"] = {

	jfunc = 	function(p)
					local mo = p.mo

					p.drawangle = mo.angle
					P_SetObjectMomZ(mo, FRACUNIT*10)
					local t = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
					t.color = mo.color
					P_InstaThrust(mo,mo.angle,(25*FRACUNIT)/*(mo.scale)*/)
					S_StartSound(p.mo,sfx_spdpad)
				end,

		func =		function(p)
					local mo = p.mo

					if mo.p_abl
						if not P_IsObjectOnGround(mo)
							if (leveltime%3)
								local g = P_SpawnGhostMobj(mo)
								g.tics = 4
								g.colorized = true
							end
						else
							mo.p_abl = false
						end
					end
				end,
}

freeslot("SPR_REDY", "SPR_ECHR", "SPR_EFIR", "SPR_DEFE", "SPR_ERIP", "SPR_BASH", "sfx_eethit", "sfx_icebrk", "sfx_usestf", "sfx_tear", "sfx_teara", "sfx_tearal","sfx_curia", "sfx_ewheel", "sfx_ewhell", "sfx_thelas", "sfx_athela", "sfx_cocyt", "sfx_icebr2")
sfxinfo[sfx_ewheel].caption = "Wheel of time!" //Caption says this
sfxinfo[sfx_ewheel].priority = "99999" //Make it high so NOTHING can interrupt this one


charStats["estelle"] = {

		-- GENERAL

		name = "Estelle",			-- This is only for bots / enemies
		basehp = 60,			-- base HP for level 1
		basesp = 72,
		persona = "estelleskillset",
		melee_natk = "staff_hit",
		melee_satk = "twheeloftime",

		supercolor_start = SKINCOLOR_SUPERORANGE1,
		
		wep = "birchstaff",		-- default weapon.
		weptype = WPT_GENERICMELEE,	-- Equippable weapon type(s)

		atk = 33,
		acc = 90,
		crit = 2,

		-- ANIMS
		-- Anims are built like this:
		-- {SPR_SPRITE, frame1, frame2, frame3, ... , duration between each frame}

		anim_stand = 		{SPR_REDY, A, 8, "SPR2_REDY"},					-- standing
		anim_stand_hurt =	{SPR_REDY, A, 1, "SPR2_REDY"},					-- standing (low HP) *
		anim_stand_bored =	{SPR_REDY, A, 8, "SPR2_REDY"},					-- standing (occasionally plays after anim_stand has played several times)
		anim_guard = 		{SPR_DEFE, A, 1, "SPR2_DEFE"},					-- guarding
		anim_move =			{SPR_PLAY, A, B, C, D, 2, "SPR2_WALK"},	-- moving
		anim_run =			{SPR_PLAY, A, B, C, D, E, 2, "SPR2_RUN_"},	-- guess what
		anim_atk =			{SPR_PLAY, A, B, C, 2, "SPR2_ROLL"},			-- attacking
		anim_aoa_end =		{SPR_PLAY, C, B, A, 2, "SPR2_ROLL"},			-- jumping out of all-out attack
		anim_hurt =			{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- taking damage
		anim_getdown =		{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- knocked down from weakness / crit *
		anim_downloop =		{SPR_ERIP, A, 1, "SPR2_ERIP"},					-- is down
		anim_getup =		{SPR_REDY, A, 1, "SPR2_REDY"},			-- gets up from down
		anim_death =		{SPR_PLAY, A, 30, "SPR2_DEAD"},					-- dies
		anim_revive =		{SPR_PLAY, A, B, C, 1, "SPR2_ROLL"},			-- gets revived
		anim_evoker =		{SPR_ECHR, A, 8, "SPR2_ECHR"},
		anim_evoker_shoot = {SPR_EFIR, A, 8, "SPR2_EFIR"},
		anim_special1 = 	{SPR_BASH, A, 2, "SPR2_BASH"}, -- hammer prep
		anim_special2 = 	{SPR_BASH, B, C, D, E, 2, "SPR2_BASH"}, -- hammer swing
		anim_special3 = 	{SPR_BASH, A, "SPR2_BASH"},	-- hammer swung
		
		vfx_summon = {"sfx_eesmn1", "sfx_eesmn2", "sfx_eesmn3", "sfx_eesmn4"},
		vfx_skill = {"sfx_eeskl1", "sfx_eeskl2", "sfx_eeskl3", "sfx_eeskl4", "sfx_eeskl5"},
		vfx_item = {"sfx_eesmn2"},
		vfx_hurt = {"sfx_eehrt1", "sfx_eehrt2", "sfx_eehrt3", "sfx_eehrt4", "sfx_eehrt5"},
		vfx_hurtx = {"sfx_eehrt5"},
		vfx_die = {"sfx_eedie", "sfx_eedie2"},
		vfx_heal = {"sfx_eeheal", "sfx_eehels"},
		vfx_healself = {"sfx_eehels"},
		vfx_kill = {"sfx_eekil1", "sfx_eekil2", "sfx_eekil3", "sfx_eekil4"},
		vfx_1more = {"sfx_ee1mor", "sfx_ee1mo"},
		vfx_crit = {"sfx_eecrt1", "sfx_eecrt2", "sfx_eecrt3", "sfx_eecrt4"},
		vfx_aoaask = {"sfx_eeaoi1", "sfx_eeaoi2", "sfx_eeaoi3", "sfx_eeaoi4"},
		vfx_aoado = {"sfx_eeaoa1", "sfx_eeaoa2", "sfx_eeaoa3", "sfx_eeaoa4", "sfx_eeaoa5"},
		vfx_aoarelent = {"sfx_eemis2"},
		vfx_miss = {"sfx_eemis1", "sfx_eemis2"},
		vfx_dodge = {"sfx_eedog"},
		vfx_win = {"sfx_eewin1", "sfx_eewin2", "sfx_eewin3", "sfx_eewin4"},
		vfx_levelup = {"sfx_eekil1", "sfx_eelevl", "sfx_eelev2"},
		vfx_tartarus_pit = {"sfx_eemis1"},
		vfx_tartarus_item = {"sfx_eeitem"},
		vfx_tartarus_spring = {"sfx_eespng"},
		vfx_tartarus_spike = {"sfx_eehrt1", "sfx_eehrt2", "sfx_eehrt3", "sfx_eehrt4", "sfx_eehrt5"},
		vfx_tartarus_critspike = {"sfx_eehrt5"},
		vfx_tartarus_spikepit = {"sfx_eempit"},

		icon = "H_ESTICO",	-- icon for net select and other menus
		hudbust = "H_ESTBAR",			-- patch to draw on the stat hud
		hudaoa = "H_ESTAOA",	-- patch for all out attack hud
		hudcutin = "ESTL_A",	-- cut in
		aoa_quote = "Alright guys!Time for \nsome ul-tra-vio-lence!",

		tip = "A Senior A-Rank Bracer. The healer and supporter of the group with Ice(Water in Bionis) Orbal Arts by using her ARCUS Orbment.She also can buff others but keep in mind of her HP and Endurance a little."
}
	
VFX_freeslotC("estelle")
	
personaList["estelleskillset"] = {
		-- GENERAL
		name = "Estelle",
		arcana = nil,

		-- STATS (@ lv10)

		sprite = SPR_NULL,
		anim_idle = 	{SPR_NULL, A, 8},
		anim_atk  = 	{SPR_NULL, A, 8},
		startframe = 0,

		strength = 5,
		magic = 11,
		endurance = 9,
		luck = 4,
		agility = 10,
		weak = ATK_CURSE|ATK_FIRE,
		resist = ATK_ICE|ATK_BLESS,
		skills = {
						{"tear", 1}, {bionis and "aqua_bleed" or "icicle_edge", 4}, 
						{"curia", 13}, {"la_tear", 14},
						{"crest", 16}, 
						{"morale", 17},
						{bionis and "blue_drop" or "diamond_dust", 18},
						{"thelas", 19},
						{bionis and "blue_impact" or "frost_edge", 20, bionis and "aqua_bleed" or "icicle_edge"},
						{"teara", 23, "tear"},
						{"recuria", 28, "curia"}, {bionis and "hydro_cannon" or "ice_hammer", 32, bionis and "blue_drop" or "diamond_dust"},
						{"athelas", 34, "thelas"},
						{"swellinghope", 35, "morale"},
						{"la_crest", 38, "crest"},
						{"la_teara", 42, "la_tear"},
						{bionis and "blue_ascension" or "crystal_edge", 46, bionis and "blue_impact" or "frost_edge"}, {"tearal", 55, "teara"},
						{bionis and "genesis_flood" or "cocytus", 60, bionis and "hydro_cannon" or "ice_hammer"},
						{"la_tearal", 65, "la_teara"},
						{bionis and "maelstorm" or "diamond_nova", 70, "crystal_edge"},
						
				},
}


VFX_freeslotC("estelle")
//True Wheel of Time, aka Zoraxua rages at the camera for his own incompetency lmao
attackDefs["twheeloftime"] = {
		name = "Wheel Of Time", 
		type = ATK_ALMIGHTY,
		power = 400,
		accuracy = 999,
		critical = 10, -- was 7
		target = TGT_ENEMY,
		cost = CST_SP,
		cost = 200,
		technical = COND_FREEZE, //Free crits on burning enemies lol
		status = COND_SHOCK, //And lets make burn likely
		statuschance = 50,
		hits = 10,
		anim_norepel = true,
		norepel = true, //Please no reflect lol

		desc = "Estelle's S-Craft\nSpins around the enemy hitting them\n with the staff and thunders",
		anim = 	function(mo, targets, hittargets, timer)
		local cam = server.P_BattleStatus[mo.battlen].cam
		local target = hittargets[1]
			
			if timer == 1
			mo.sx = mo.x
			mo.sy = mo.y
			ANIM_set(mo, mo.anim_evoker_shoot, true)
			playSound(mo.battlen, sfx_eeaoi2)
			mo.angle = R_PointToAngle2(mo.x,mo.y,target.x,target.y)
			cam.momx = 0
			cam.momy = 0
			cam.momz = 0
			elseif timer == 2
			local cx = mo.x + 256*cos(mo.angle)
			local cy = mo.y + 256*sin(mo.angle)
			P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*16)
			server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
			elseif timer == 35 //Zoraxua's seal of 2 braincells: telling the camera to aim before moving
			local cx = mo.x + 256*cos(mo.angle + ANG1*180)
			local cy = mo.y + 256*sin(mo.angle + ANG1*180)
			P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*16)
			server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
			elseif timer >= 36
			and timer <= 45
			mo.momx = (target.x - mo.x)/36
			mo.momy = (target.y - mo.y)/36
				if timer == 45
					P_SetObjectMomZ(mo,10*FRACUNIT)
					ANIM_set(mo, mo.anim_aoa_end, true)
				end
			elseif timer >= 50
			and timer < 55
			mo.momx = 0
			mo.momy = 0
			mo.momz = 0
			elseif timer >= 55
			and timer < 60
			mo.momx = (target.x - mo.x)/5
			mo.momy = (target.y - mo.y)/5
			mo.momz = (target.z - mo.z)/5
			if timer == 58
			local cx = target.x + 168*cos(target.angle + ANG1*20)
			local cy = target.y + 168*sin(target.angle + ANG1*20)
			P_TeleportMove(cam, cx, cy, target.z + FRACUNIT*16)
			server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, target.x, target.y)
			end
	//		CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, target.z + FRACUNIT*16, 50*FRACUNIT)
	//		CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y))
			elseif timer == 60
			local cx = target.x - 768*cos(target.angle)
			local cy = target.y - 768*sin(target.angle)
			P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*40)
			server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, target.x, target.y)
			damageObject(target) // 1
			DoExplosion(target)
			P_StartQuake(FRACUNIT*12, 10)
			P_InstaThrust(mo,mo.angle - ANGLE_180, 25*FRACUNIT)
			elseif timer == 61
			mo.momx = 0
			mo.momy = 0
			mo.momz = 0
			mo.angle = $1 + ANGLE_90
			ANIM_set(mo, mo.anim_special1, true)
			elseif timer == 81
				for i = 1, 32 //Sparks
					local angle = P_RandomRange(1, 359)*ANG1
					local dist = P_RandomRange(30, 36)

					local s = P_SpawnMobj(target.x+(dist*cos(angle)), target.y+(dist*sin(angle)), target.floorz, MT_DUMMY)
					s.state, s.color, s.scale = S_SSPK1, SKINCOLOR_ORANGE, target.scale*2
					s.momz, s.destscale = P_RandomRange(5, 24)*FRACUNIT, FRACUNIT/6
					P_InstaThrust(s, angle, P_RandomRange(6, 8)*FRACUNIT)
				end
			local cx = target.x - 768*cos(target.angle)
			local cy = target.y - 768*sin(target.angle)
			P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*32)
			server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, target.x, target.y)
			ANIM_set(mo, mo.anim_evoker, true)
			playSound(mo.battlen, sfx_eeaoi3)
			elseif timer > 85
			and timer <= 115
			ANIM_set(mo, mo.anim_run, true)
			P_InstaThrust(mo,mo.angle,80*FRACUNIT)
			local estghost = P_SpawnGhostMobj(mo)
			estghost.fuse = 25
			mo.angle = $1 - (ANGLE_45/2)
			elseif timer > 115
			and timer <= 255
			P_InstaThrust(mo,mo.angle,80*FRACUNIT)
			local estghost = P_SpawnGhostMobj(mo)
			estghost.fuse = 35
			mo.angle = $1 - (ANGLE_45/2)
				if timer == 116
				playSound(mo.battlen, sfx_cutlyd)
				playSound(mo.battlen, sfx_ewhell)
				elseif timer == 151
				or timer == 186
				or timer == 221
				local z2 = P_SpawnMobj(target.x, target.y, target.floorz, MT_DUMMY)
				z2.state, z2.scale, z2.color = S_LZIO21, target.scale*15/4, SKINCOLOR_ORANGE
				z2.destscale = target.scale*3/2
				playSound(mo.battlen, sfx_elthr)
				damageObject(target) //2, 3, 4
				elseif timer == 225
					local b = P_SpawnMobj(target.x, target.y, target.z + 16*FRACUNIT, MT_THOK)
					b.fuse = 15
					b.scale = FRACUNIT/4
					b.destscale = 52*FRACUNIT
					b.scalespeed = ((207*FRACUNIT)/4)/15
					b.frame = A|FF_FULLBRIGHT
					b.color = SKINCOLOR_ORANGE
				end
			elseif timer > 255
			and timer <= 360
			P_InstaThrust(mo,mo.angle,80*FRACUNIT)
			local estghost = P_SpawnGhostMobj(mo)
			estghost.colorized = true
			estghost.fuse = 70
			mo.angle = $1 - (ANGLE_45/2)
				if timer == 260
				playSound(mo.battlen, sfx_ewheel)
				elseif timer == 340
					for k,v in ipairs(mo.allies)
						if v and v.control and v.control.valid
							P_FlashPal(v.control, 1, 35)
						end
					end
				elseif timer == 261
				or timer == 281
				or timer == 301
				or timer == 321
				or timer == 341
				//+20
				local z2 = P_SpawnMobj(target.x, target.y, target.floorz, MT_DUMMY)
				z2.state, z2.scale, z2.color = S_LZIO21, target.scale*15/4, SKINCOLOR_ORANGE
				z2.destscale = target.scale*3/2
				playSound(mo.battlen, sfx_elthr)
				damageObject(target) //5, 6, 7, 8, 9
				local b = P_SpawnMobj(target.x, target.y, target.z + 16*FRACUNIT, MT_THOK)
				b.fuse = 26
				b.scale = FRACUNIT/4
				b.destscale = 52*FRACUNIT
				b.scalespeed = ((207*FRACUNIT)/4)/25
				b.frame = A|FF_FULLBRIGHT
				b.color = SKINCOLOR_ORANGE
				end
			elseif timer == 365
			P_TeleportMove(mo,mo.sx,mo.sy,mo.z+32*FRACUNIT)
			ANIM_set(mo, mo.anim_aoa_end, true)
			mo.momx = 0
			mo.momy = 0
			elseif timer > 369
			and timer < 375
			local cx = mo.x + 256*cos(mo.angle + ANGLE_180)
			local cy = mo.y + 256*sin(mo.angle + ANGLE_180)
			P_TeleportMove(cam, cx, cy, mo.z)
			server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
			elseif timer == 375
			ANIM_set(mo, mo.anim_stand, true)
			playSound(mo.battlen, sfx_eethit)
			damageObject(target)//10!
			elseif timer == 410
			return true
			end
		end,
	}


attackDefs["morale"] = {
		name = "Morale",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 15,
		desc = "Shouts to encourage allies.\nRaises attack by 1 stage.",
		target = TGT_ALLALLIES,
		buff = true,
		anim = function(mo, targets, hittargets, timer)

			for i = 1, #targets do

			local target = targets[i]

				if timer == 20 + (i-1)*16
					playSound(mo.battlen, sfx_courge)
					VFX_Play(target, VFX_SUMMON)
					buffStat(target, "atk")
					for i = 1,16
						local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						dust.angle = ANGLE_90 + ANG1* (22*(i-1))
						dust.state = S_CDUST1
						P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
						dust.color = SKINCOLOR_GOLD
						dust.scale = FRACUNIT*2
					end

				elseif timer > 20 + (i-1)*16 and timer <= 50 + (i-1)*16

					if leveltime%2 == 0
						for i = 1,16

							local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
							thok.state = S_CDUST1
							thok.momz = P_RandomRange(3, 10)*FRACUNIT
							thok.color = SKINCOLOR_APRICOT
							thok.tics = P_RandomRange(10, 35)
							thok.scale = FRACUNIT*3/2
						end
					end

					for i = 1, 8
						local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
						thok.sprite = SPR_SUMN
						thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
						thok.momz = P_RandomRange(6, 16)*FRACUNIT
						thok.color = SKINCOLOR_SUNSET
						thok.tics = P_RandomRange(10, 35)
					end
				end
			end
			if timer == 60 + (#targets-1)*16
				return true
			end
		end,
}

attackDefs["staff_hit"] = {
		name = "Staff Hit",
		type = ATK_STRIKE,
		power = 45,
		accuracy = 85,
		critical = 7, -- was 7
		target = TGT_ENEMY,
		cost = CST_HP,
		nometronome = true,
		norandom = true,
		cost = 0,
		desc = "A strong hit with the staff.",
		anim_norepel = true,	-- do not bounce back our ANIMATION
		physical = true,	-- don't play the summoning anim for phys attacks, duh
		anim = 	function(mo, targets, hittargets, timer)
					local target = targets[1]
					if timer == 1
						if mo.anim_special1 and #mo.anim_special1
						ANIM_set(mo, mo.anim_special1, true)
						end
						playSound(mo.battlen, sfx_s220)

						-- fake A_LobShot:
						mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)

						local z = mo.z
						local hit = P_SpawnMobj(target.x & (64*FRACUNIT -1), target.y & (64*FRACUNIT -1), target.subsector.sector.floorheight, MT_NULL)
						hit.tics = TICRATE

						local dist = P_AproxDistance(target.x - mo.x, target.y - mo.y)
						local horizontal = dist / TICRATE
						local vertical = FixedMul((gravity*TICRATE)/2, mo.scale)

						mo.momx = FixedMul(horizontal, cos(mo.angle))
						mo.momy = FixedMul(horizontal, sin(mo.angle))
						mo.momz = vertical


						-- move camera to an interresting spot

						local an = target.angle + 45*ANG1

						local cx = target.x + 384*cos(an)
						local cy = target.y + 384*sin(an)

						CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, server.P_BattleStatus[mo.battlen].cam.z, 70*FRACUNIT)
						CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y), ANG1*4)
						--CAM_aiming(server.P_BattleStatus[mo.battlen].cam, -ANG1*10, ANG1)

					elseif timer == TICRATE - 7
						ANIM_set(mo, mo.anim_special2)	-- hammer hit prep

					elseif timer == TICRATE
						damageObject(hittargets[1])
						P_InstaThrust(mo, 0, 0)

						-- explode hearts all over!
						-- heart ring:
						for i = 1, 8
							local h = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
							h.state = S_AOADUST1
							h.fuse = TICRATE
							P_InstaThrust(h, (360/8 *i)*ANG1, FRACUNIT*32)

							if i%2
								createSplat(mo)
							end
						end

						P_StartQuake(FRACUNIT*30, 8)
						playSound(mo.battlen, sfx_eethit)

						for i = 1, 16
							local h = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
							h.state = S_AOADUST1
							h.fuse = TICRATE
							h.momx = P_RandomRange(-24, 24)*FRACUNIT
							h.momy = P_RandomRange(-24, 24)*FRACUNIT
							h.momz = P_RandomRange(2, 24)*FRACUNIT
						end
					elseif timer == TICRATE*2
						return true
					end
				end,
}

attackDefs["icicle_edge"] = {
		name = "Icicle Edge",
		type = ATK_ICE,
		power = 60,
		accuracy = 95,
		costtype = CST_SP,
		cost = 4,
		status = COND_FREEZE,
		statuschance = 5,
		desc = "Orbal Art\nLight ice damage to a enemy.\nMay freeze",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]

			if timer == 25
				playSound(mo.battlen, sfx_bufu3)
			end

			if (timer >= 21 and timer <= 54) and (target.bufus and #target.bufus)
				if not (leveltime%2)
					for i = 1, 2
						local bs_target = target.bufus[P_RandomRange(1, #target.bufus)]
						local bs_scales = {FRACUNIT/2, FRACUNIT*3/4, FRACUNIT}

						local d = 30 -- i got lazy
						local bs = P_SpawnMobj(bs_target.x+(P_RandomRange(-(d), d)*bs_target.scale), bs_target.y+(P_RandomRange(-(d), d)*bs_target.scale), bs_target.z+(P_RandomRange(0, d*3/2)*bs_target.scale), MT_BUFU)
						bs.state, bs.scale, bs.color = S_BUFU_PARTICLE_D, bs_scales[P_RandomRange(1, #bs_scales)], SKINCOLOR_ICY
						bs.momz = P_RandomRange(-1, 1)*FRACUNIT
					end
				end
			end
			if (timer == 5) -- setup table to store bufu stuff
				target.bufus = {}
			elseif (timer >= 21 and timer <= 27)
				if not (timer%3)
					for i = 1, P_RandomRange(2, 3)
						local bufu_destscales = {FRACUNIT*11/10, FRACUNIT*5/4, FRACUNIT*13/10} -- 1.20, 1.25, 1.30
						local b = P_SpawnMobj(target.x+P_RandomRange(-25, 25)*FRACUNIT, target.y+P_RandomRange(-25, 25)*FRACUNIT, target.z, MT_BUFU)
						b.state, b.scale = S_BUFU, FRACUNIT/3
						b.destscale = bufu_destscales[P_RandomRange(1, #bufu_destscales)]
						b.momz, b.risetime = P_RandomRange(3, 7)*FRACUNIT, P_RandomRange(4, 6)
						target.bufus[#target.bufus+1] = b
					end
				end
			elseif (timer >= 47 and timer <= 54)
				for k, v in ipairs(target.bufus)
					v.sx, v.sy, v.sz = $ or v.x, $ or v.y, $ or v.z
					P_TeleportMove(v, v.sx+P_RandomRange(-2, 2)*v.scale, v.sy+P_RandomRange(-2, 2)*v.scale, v.sz+P_RandomRange(-2, 2)*v.scale)
					if (timer == 53) then v.state = S_BUFU_FLASH end
				end
			elseif (timer == 55)
				for k, v in ipairs(target.bufus)
					local ba = P_SpawnMobj(v.x, v.y, v.z, MT_BUFU_PARTICLE)
					ba.state, ba.scale = S_BUFU_PARTICLE_A, v.scale
					ba.momx, ba.momy, ba.momz = P_RandomRange(-5, 5)*FRACUNIT, P_RandomRange(-5, 5)*FRACUNIT, P_RandomRange(5, 11)*FRACUNIT

					local bb = P_SpawnMobj(v.x, v.y, v.z, MT_BUFU_PARTICLE)
					bb.state, bb.scale = S_BUFU_PARTICLE_B, v.scale
					bb.momx, bb.momy, bb.momz = P_RandomRange(-3, 3)*FRACUNIT, P_RandomRange(-3, 3)*FRACUNIT, P_RandomRange(7, 14)*FRACUNIT
					for i = 1, 9
						local curangle = ANG1*40*i

						local dust = P_SpawnMobj(target.x+(12*cos(curangle)), target.y+(12*sin(curangle)), target.z+(12*FRACUNIT), MT_DUMMY)
						dust.flags = $|MF_NOGRAVITY|MF_NOCLIPHEIGHT
						dust.state, dust.scale, dust.angle = S_BUFUDYNE_DUST1, FRACUNIT*3/4, curangle
						dust.destscale = FRACUNIT*2
						dust.scalespeed = FRACUNIT/18
						P_InstaThrust(dust, dust.angle, 6*FRACUNIT)
						dust.momz = 3*FRACUNIT/2
					end
					P_RemoveMobj(v)
				end
				playSound(mo.battlen, sfx_bufu2)
				damageObject(target)
			elseif (timer == 90)
				target.bufus = nil
				return true
			end
		end,
}

attackDefs["diamond_dust"] = {
		name = "Diamond Dust",
		type = ATK_ICE,
		power = 60,
		accuracy = 90,
		costtype = CST_SP,
		cost = 8,
		status = COND_FREEZE,
		statuschance = 2,
		desc = "Orbal Art\nLight ice damage to all enemies.\nMay freeze",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
			for k, e in ipairs(hittargets)
				local time = timer - 10*(k-1)
				local target = e

				if time == 25
					playSound(mo.battlen, sfx_bufu3)
				end

				if (time >= 21 and time <= 54) and (target.bufus and #target.bufus)
					if not (leveltime%2)
						for i = 1, 2
							local bs_target = target.bufus[P_RandomRange(1, #target.bufus)]
							local bs_scales = {FRACUNIT/2, FRACUNIT*3/4, FRACUNIT}

							local d = 30 -- i got lazy
							local bs = P_SpawnMobj(bs_target.x+(P_RandomRange(-(d), d)*bs_target.scale), bs_target.y+(P_RandomRange(-(d), d)*bs_target.scale), bs_target.z+(P_RandomRange(0, d*3/2)*bs_target.scale), MT_BUFU)
							bs.state, bs.scale, bs.color = S_BUFU_PARTICLE_D, bs_scales[P_RandomRange(1, #bs_scales)], SKINCOLOR_ICY
							bs.momz = P_RandomRange(-1, 1)*FRACUNIT
							bs.fuse = TICRATE*5
						end
					end
				end
				if (time == 5) -- setup table to store bufu stuff
					target.bufus = {}
				elseif (time >= 21 and time <= 27)
					if not (time%3)
						for i = 1, P_RandomRange(2, 3)
							local bufu_destscales = {FRACUNIT*11/10, FRACUNIT*5/4, FRACUNIT*13/10} -- 1.20, 1.25, 1.30
							local b = P_SpawnMobj(target.x+P_RandomRange(-25, 25)*FRACUNIT, target.y+P_RandomRange(-25, 25)*FRACUNIT, target.z, MT_BUFU)
							b.state, b.scale = S_BUFU, FRACUNIT/3
							b.destscale = bufu_destscales[P_RandomRange(1, #bufu_destscales)]
							b.momz, b.risetime = P_RandomRange(3, 7)*FRACUNIT, P_RandomRange(4, 6)
							target.bufus[#target.bufus+1] = b
							b.fuse = TICRATE*5
						end
					end
				elseif (time >= 47 and time <= 54)
					for k, v in ipairs(target.bufus)
						v.sx, v.sy, v.sz = $ or v.x, $ or v.y, $ or v.z
						P_TeleportMove(v, v.sx+P_RandomRange(-2, 2)*v.scale, v.sy+P_RandomRange(-2, 2)*v.scale, v.sz+P_RandomRange(-2, 2)*v.scale)
						if (timer == 53) then v.state = S_BUFU_FLASH end
					end
				elseif (time == 55)
					for k, v in ipairs(target.bufus)
						local ba = P_SpawnMobj(v.x, v.y, v.z, MT_BUFU_PARTICLE)
						ba.state, ba.scale = S_BUFU_PARTICLE_A, v.scale
						ba.momx, ba.momy, ba.momz = P_RandomRange(-5, 5)*FRACUNIT, P_RandomRange(-5, 5)*FRACUNIT, P_RandomRange(5, 11)*FRACUNIT

						local bb = P_SpawnMobj(v.x, v.y, v.z, MT_BUFU_PARTICLE)
						bb.state, bb.scale = S_BUFU_PARTICLE_B, v.scale
						bb.momx, bb.momy, bb.momz = P_RandomRange(-3, 3)*FRACUNIT, P_RandomRange(-3, 3)*FRACUNIT, P_RandomRange(7, 14)*FRACUNIT
						for i = 1, 9
							local curangle = ANG1*40*i

							local dust = P_SpawnMobj(target.x+(12*cos(curangle)), target.y+(12*sin(curangle)), target.z+(12*FRACUNIT), MT_DUMMY)
							dust.flags = $|MF_NOGRAVITY|MF_NOCLIPHEIGHT
							dust.state, dust.scale, dust.angle = S_BUFUDYNE_DUST1, FRACUNIT*3/4, curangle
							dust.destscale = FRACUNIT*2
							dust.scalespeed = FRACUNIT/18
							P_InstaThrust(dust, dust.angle, 6*FRACUNIT)
							dust.momz = 3*FRACUNIT/2
						end
						P_RemoveMobj(v)
					end
					playSound(mo.battlen, sfx_bufu2)
					damageObject(target)
				elseif (timer == 90 + (#targets-1)*10)
					target.bufus = nil
					return true
				end
			end
		end,
}

attackDefs["frost_edge"] = {
		name = "Frost Edge",
		type = ATK_ICE,
		power = 140,
		accuracy = 95,
		costtype = CST_SP,
		cost = 8,
		status = COND_FREEZE,
		statuschance = 5,
		desc = "Orbal Art\nMedium ice damage to a enemy.\nMay freeze",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			if (timer >= 20 and timer <= 58) and (target.bufulas and #target.bufulas)
				if not (leveltime%2)
					for i = 1, 2
						local bs_target = target.bufulas[P_RandomRange(1, #target.bufulas)]
						local bs_scales = {FRACUNIT*3/4, FRACUNIT, FRACUNIT*5/4}

						local d = 30
						local bs = P_SpawnMobj(bs_target.x+(P_RandomRange(-(d), d)*bs_target.scale), bs_target.y+(P_RandomRange(-(d), d)*bs_target.scale), bs_target.z+(P_RandomRange(0, d*3/2)*bs_target.scale), MT_BUFU)
						bs.state, bs.scale, bs.color = S_BUFU_PARTICLE_D, bs_scales[P_RandomRange(1, #bs_scales)], SKINCOLOR_ICY
						bs.momz = P_RandomRange(-1, 1)*FRACUNIT
					end
				end
			end
			if (timer == 5) -- setup table to store bufu stuff
				target.bufulas = {}
			elseif (timer >= 21 and timer <= 30)
				if not (timer%3)

					playSound(mo.battlen, sfx_bufu3)

					target.bs = $ and $+1 or 1
					local b = P_SpawnMobj(target.x+P_RandomRange(-30, 30)*FRACUNIT, target.y+P_RandomRange(-30, 30)*FRACUNIT, target.z+P_RandomRange(5, 20)*FRACUNIT, MT_BUFU)
					b.state, b.scale = S_BUFULA_LR, FRACUNIT/3
					b.destscale, b.scalespeed = FRACUNIT*165/100+(FRACUNIT/4*(target.bs-1)), FRACUNIT/6
					target.bufulas[#target.bufulas+1] = b
				end
			elseif (timer >= 51 and timer <= 58) -- 7 frames shaking
				for k, v in ipairs(target.bufulas)
					v.sx, v.sy, v.sz = $ or v.x, $ or v.y, $ or v.z
					P_TeleportMove(v, v.sx+P_RandomRange(-2, 2)*v.scale, v.sy+P_RandomRange(-2, 2)*v.scale, v.sz+P_RandomRange(-2, 2)*v.scale)
					if (timer == 57) then v.state = (v.frame == 5 and S_BUFULA_FLASH_A or S_BUFULA_FLASH_B) end
				end
			elseif (timer == 59)
				for k, v in ipairs(target.bufulas)
					for i = 1, 2
						local bp = P_SpawnMobj(v.x, v.y, v.z, MT_BUFU_PARTICLE)
						bp.state, bp.scale = S_BUFULA_PARTICLE, FRACUNIT*3/2
						bp.momx, bp.momy, bp.momz = P_RandomRange(-6, 6)*FRACUNIT, P_RandomRange(-6, 6)*FRACUNIT, P_RandomRange(13, 18)*FRACUNIT
					end
					for i = 1, 2
						local ba = P_SpawnMobj(v.x, v.y, v.z, MT_BUFU_PARTICLE)
						ba.state, ba.scale = S_BUFU_PARTICLE_A, FRACUNIT*3/2
						ba.momx, ba.momy, ba.momz = P_RandomRange(-7, 7)*FRACUNIT, P_RandomRange(-7, 7)*FRACUNIT, P_RandomRange(5, 11)*FRACUNIT
					end
					local bb = P_SpawnMobj(v.x, v.y, v.z, MT_BUFU_PARTICLE)
					bb.state, bb.scale = S_BUFU_PARTICLE_B, FRACUNIT*3/2
					bb.momx, bb.momy, bb.momz = P_RandomRange(-4, 4)*FRACUNIT, P_RandomRange(-4, 4)*FRACUNIT, P_RandomRange(7, 14)*FRACUNIT
					for i = 1, 9
						local curangle = ANG1*40*i

						local dust = P_SpawnMobj(target.x+(18*cos(curangle)), target.y+(18*sin(curangle)), target.z+(5*FRACUNIT), MT_DUMMY)
						dust.flags = $|MF_NOGRAVITY|MF_NOCLIPHEIGHT
						dust.state, dust.scale, dust.angle = S_BUFUDYNE_DUST1, FRACUNIT, curangle
						dust.destscale = FRACUNIT*9/4
						dust.scalespeed = FRACUNIT/18
						P_InstaThrust(dust, dust.angle, 9*FRACUNIT)
						dust.momz = 5*FRACUNIT/2
					end
					P_RemoveMobj(v)
				end
				playSound(mo.battlen, sfx_bufu4)
				damageObject(target)
			elseif (timer == 95)
				target.bufulas, target.bs = nil, nil
				return true
			end
		end,
}

attackDefs["ice_hammer"] = {
		name = "Ice Hammer",
		type = ATK_ICE,
		power = 140,
		accuracy = 90,
		costtype = CST_SP,
		cost = 16,
		status = COND_FREEZE,
		statuschance = 2,
		desc = "Orbal Art\nMedium ice damage to all enemies.\nMay freeze",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
			for k, e in ipairs(hittargets)
				local time = timer - 10*(k-1)
				local target = e
				if (time >= 20 and time <= 58) and (target.bufulas and #target.bufulas)
					if not (leveltime%2)
						for i = 1, 2
							local bs_target = target.bufulas[P_RandomRange(1, #target.bufulas)]
							local bs_scales = {FRACUNIT*3/4, FRACUNIT, FRACUNIT*5/4}

							local d = 30
							local bs = P_SpawnMobj(bs_target.x+(P_RandomRange(-(d), d)*bs_target.scale), bs_target.y+(P_RandomRange(-(d), d)*bs_target.scale), bs_target.z+(P_RandomRange(0, d*3/2)*bs_target.scale), MT_BUFU)
							bs.state, bs.scale, bs.color = S_BUFU_PARTICLE_D, bs_scales[P_RandomRange(1, #bs_scales)], SKINCOLOR_ICY
							bs.momz = P_RandomRange(-1, 1)*FRACUNIT
						end
					end
				end
				if (time == 5) -- setup table to store bufu stuff
					target.bufulas = {}
				elseif (time >= 21 and time <= 30)
					if not (timer%3)

						playSound(mo.battlen, sfx_bufu3)

						target.bs = $ and $+1 or 1
						local b = P_SpawnMobj(target.x+P_RandomRange(-30, 30)*FRACUNIT, target.y+P_RandomRange(-30, 30)*FRACUNIT, target.z+P_RandomRange(5, 20)*FRACUNIT, MT_BUFU)
						b.state, b.scale = S_BUFULA_LR, FRACUNIT/3
						b.destscale, b.scalespeed = FRACUNIT*165/100+(FRACUNIT/4*(target.bs-1)), FRACUNIT/6
						target.bufulas[#target.bufulas+1] = b
					end
				elseif (time >= 51 and time <= 58) -- 7 frames shaking
					for k, v in ipairs(target.bufulas)
						v.sx, v.sy, v.sz = $ or v.x, $ or v.y, $ or v.z
						P_TeleportMove(v, v.sx+P_RandomRange(-2, 2)*v.scale, v.sy+P_RandomRange(-2, 2)*v.scale, v.sz+P_RandomRange(-2, 2)*v.scale)
						if (time == 57) then v.state = (v.frame == 5 and S_BUFULA_FLASH_A or S_BUFULA_FLASH_B) end
					end
				elseif (time == 59)
					for k, v in ipairs(target.bufulas)
						for i = 1, 2
							local bp = P_SpawnMobj(v.x, v.y, v.z, MT_BUFU_PARTICLE)
							bp.state, bp.scale = S_BUFULA_PARTICLE, FRACUNIT*3/2
							bp.momx, bp.momy, bp.momz = P_RandomRange(-6, 6)*FRACUNIT, P_RandomRange(-6, 6)*FRACUNIT, P_RandomRange(13, 18)*FRACUNIT
						end
						for i = 1, 2
							local ba = P_SpawnMobj(v.x, v.y, v.z, MT_BUFU_PARTICLE)
							ba.state, ba.scale = S_BUFU_PARTICLE_A, FRACUNIT*3/2
							ba.momx, ba.momy, ba.momz = P_RandomRange(-7, 7)*FRACUNIT, P_RandomRange(-7, 7)*FRACUNIT, P_RandomRange(5, 11)*FRACUNIT
						end
						local bb = P_SpawnMobj(v.x, v.y, v.z, MT_BUFU_PARTICLE)
						bb.state, bb.scale = S_BUFU_PARTICLE_B, FRACUNIT*3/2
						bb.momx, bb.momy, bb.momz = P_RandomRange(-4, 4)*FRACUNIT, P_RandomRange(-4, 4)*FRACUNIT, P_RandomRange(7, 14)*FRACUNIT
						for i = 1, 9
							local curangle = ANG1*40*i

							local dust = P_SpawnMobj(target.x+(18*cos(curangle)), target.y+(18*sin(curangle)), target.z+(5*FRACUNIT), MT_DUMMY)
							dust.flags = $|MF_NOGRAVITY|MF_NOCLIPHEIGHT
							dust.state, dust.scale, dust.angle = S_BUFUDYNE_DUST1, FRACUNIT, curangle
							dust.destscale = FRACUNIT*9/4
							dust.scalespeed = FRACUNIT/18
							P_InstaThrust(dust, dust.angle, 9*FRACUNIT)
							dust.momz = 5*FRACUNIT/2
						end
						P_RemoveMobj(v)
					end
					playSound(mo.battlen, sfx_bufu4)
					damageObject(target)
				elseif (timer == 95 + (#targets-1)*10)
					target.bufulas, target.bs = nil, nil
					return true
				end
			end
		end,
}

attackDefs["crystal_edge"] = {
		name = "Crystal Edge",
		type = ATK_ICE,
		power = 350,
		accuracy = 95,
		costtype = CST_SP,
		cost = 12,
		status = COND_FREEZE,
		statuschance = 5,
		desc = "Orbal Art\nHeavy ice damage to a enemy.\nMay freeze",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			if (timer >= 20 and timer <= 79) and (target.bd and target.bd.valid)
				local bs_scales = {FRACUNIT, FRACUNIT*5/4, FRACUNIT*3/2}
				-- this doesnt even WORK as intended but it's so fast nobody will notice
				if (target.bd.frame & 0)
					target.bd.sparkheight = 50
				elseif (target.bd.frame & 1)
					target.bd.sparkheight = 86
				elseif (target.bd.frame & 2)
					target.bd.sparkheight = 128
				else
					target.bd.sparkheight = 190
				end

				local bs = P_SpawnMobj(target.bd.x+(P_RandomRange(-60, 60)*target.bd.scale), target.bd.y+(P_RandomRange(-60, 60)*target.bd.scale), target.bd.z+(P_RandomRange(0, target.bd.sparkheight)*target.bd.scale), MT_BUFU)
				bs.state, bs.scale, bs.color = S_BUFU_PARTICLE_D, bs_scales[P_RandomRange(1, #bs_scales)], SKINCOLOR_ICY
				bs.momz = P_RandomRange(-1, 1)*FRACUNIT

				if (timer <= 51)
					local baseangle = P_RandomRange(1, 360)*ANG1
					local dist = 48
					for i = 0, 12
						local angle = baseangle + i*6*ANG1
						local x, y = target.bd.x + dist*cos(angle), target.bd.y + dist*sin(angle)

						local aura = P_SpawnMobj(x, y, target.bd.z+i*FRACUNIT*3, MT_DUMMY)
						aura.state = S_BUFUDYNE_AURA1
						aura.angle = angle - ANGLE_90
						aura.color = SKINCOLOR_WHITE
						aura.momz = P_RandomRange(2, 9)*FRACUNIT
						aura.scale = FRACUNIT/2
						aura.destscale = FRACUNIT*3/2
						P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(3, 5))
					end
				end
			end
			if (timer == 20)
				playSound(mo.battlen, sfx_cocyt)
				target.bd = P_SpawnMobj(target.x, target.y, target.z, MT_BUFU)
				target.bd.state, target.bd.scale = S_COCYTUS_A1, FRACUNIT*3/2
			elseif (timer >= 72 and timer <= 79)
				local bd = target.bd -- I'm lazy
				P_TeleportMove(bd, target.x+(P_RandomRange(-2, 2)*bd.scale), target.y+(P_RandomRange(-2, 2)*bd.scale), target.z)
				if (timer == 78)
					bd.state = S_COCYTUS_BF
				end
			elseif (timer == 80)
				for i = 1, P_RandomRange(17, 20)
					local ba = P_SpawnMobj(target.bd.x+(P_RandomRange(-20, 20)*target.bd.scale), target.bd.y+(P_RandomRange(-20, 20)*target.bd.scale), target.bd.z+(P_RandomRange(0, 128)*target.bd.scale), MT_BUFU_PARTICLE)
					ba.state, ba.scale = S_BUFU_PARTICLE_A, FRACUNIT*7/4
					ba.momx, ba.momy, ba.momz = P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(6, 19)*FRACUNIT
				end
				for i = 1, P_RandomRange(11, 13)
					local bb = P_SpawnMobj(target.bd.x+(P_RandomRange(-20, 20)*target.bd.scale), target.bd.y+(P_RandomRange(-20, 20)*target.bd.scale), target.bd.z+(P_RandomRange(0, 128)*target.bd.scale), MT_BUFU_PARTICLE)
					bb.state, bb.scale = S_BUFU_PARTICLE_B, FRACUNIT*7/4
					bb.momx, bb.momy, bb.momz = P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(9, 23)*FRACUNIT
				end
				for i = 1, 9
					local curangle = ANG1*40*i

					local dust = P_SpawnMobj(target.bd.x+(24*cos(curangle)), target.bd.y+(24*sin(curangle)), target.bd.z, MT_DUMMY)
					dust.flags = $|MF_NOGRAVITY|MF_NOCLIPHEIGHT
					dust.state, dust.scale, dust.angle = S_BUFUDYNE_DUST1, FRACUNIT*5/4, curangle
					dust.destscale = FRACUNIT*5/2
					dust.scalespeed = FRACUNIT/18
					P_InstaThrust(dust, dust.angle, 12*FRACUNIT)
					dust.momz = 4*FRACUNIT
				end
				P_RemoveMobj(target.bd)
				playSound(mo.battlen, sfx_icebrk)
				damageObject(target)
				P_StartQuake(FRACUNIT*20, 10)
			elseif (timer == 110)
				target.bd = nil
				return true
			end
		end,
}

attackDefs["cocytus"] = {
		name = "Cocytus",
		type = ATK_ICE,
		power = 350,
		accuracy = 90,
		costtype = CST_SP,
		cost = 24,
		status = COND_FREEZE,
		statuschance = 2,
		desc = "Orbal Art\nHeavy ice damage to all enemies.\nMay freeze",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
			for k, e in ipairs(hittargets)
				local time = timer - 10*(k-1)
				local target = e
				if (time >= 20 and time <= 79) and (target.bd and target.bd.valid)
					local bs_scales = {FRACUNIT, FRACUNIT*5/4, FRACUNIT*3/2}
					-- this doesnt even WORK as intended but it's so fast nobody will notice
					if (target.bd.frame & 0)
						target.bd.sparkheight = 50
					elseif (target.bd.frame & 1)
						target.bd.sparkheight = 86
					elseif (target.bd.frame & 2)
						target.bd.sparkheight = 128
					else
						target.bd.sparkheight = 190
					end

					local bs = P_SpawnMobj(target.bd.x+(P_RandomRange(-60, 60)*target.bd.scale), target.bd.y+(P_RandomRange(-60, 60)*target.bd.scale), target.bd.z+(P_RandomRange(0, target.bd.sparkheight)*target.bd.scale), MT_BUFU)
					bs.state, bs.scale, bs.color = S_BUFU_PARTICLE_D, bs_scales[P_RandomRange(1, #bs_scales)], SKINCOLOR_ICY
					bs.momz = P_RandomRange(-1, 1)*FRACUNIT

					if (time <= 51)
						local baseangle = P_RandomRange(1, 360)*ANG1
						local dist = 48
						for i = 0, 12
							local angle = baseangle + i*6*ANG1
							local x, y = target.bd.x + dist*cos(angle), target.bd.y + dist*sin(angle)

							local aura = P_SpawnMobj(x, y, target.bd.z+i*FRACUNIT*3, MT_DUMMY)
							aura.state = S_BUFUDYNE_AURA1
							aura.angle = angle - ANGLE_90
							aura.color = SKINCOLOR_WHITE
							aura.momz = P_RandomRange(2, 9)*FRACUNIT
							aura.scale = FRACUNIT/2
							aura.destscale = FRACUNIT*3/2
							P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(3, 5))
						end
					end
				end
				if (time == 20)
					playSound(mo.battlen, sfx_cocyt)
					target.bd = P_SpawnMobj(target.x, target.y, target.z, MT_BUFU)
					target.bd.state, target.bd.scale = S_COCYTUS_A1, FRACUNIT*3/2
				elseif (time >= 72 and time <= 79)
					local bd = target.bd -- I'm lazy
					P_TeleportMove(bd, target.x+(P_RandomRange(-2, 2)*bd.scale), target.y+(P_RandomRange(-2, 2)*bd.scale), target.z)
					if (time == 78)
						bd.state = S_COCYTUS_BF
					end
				elseif (time == 80)
					for i = 1, P_RandomRange(17, 20)
						local ba = P_SpawnMobj(target.bd.x+(P_RandomRange(-20, 20)*target.bd.scale), target.bd.y+(P_RandomRange(-20, 20)*target.bd.scale), target.bd.z+(P_RandomRange(0, 128)*target.bd.scale), MT_BUFU_PARTICLE)
						ba.state, ba.scale = S_BUFU_PARTICLE_A, FRACUNIT*7/4
						ba.momx, ba.momy, ba.momz = P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(6, 19)*FRACUNIT
					end
					for i = 1, P_RandomRange(11, 13)
						local bb = P_SpawnMobj(target.bd.x+(P_RandomRange(-20, 20)*target.bd.scale), target.bd.y+(P_RandomRange(-20, 20)*target.bd.scale), target.bd.z+(P_RandomRange(0, 128)*target.bd.scale), MT_BUFU_PARTICLE)
						bb.state, bb.scale = S_BUFU_PARTICLE_B, FRACUNIT*7/4
						bb.momx, bb.momy, bb.momz = P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(9, 23)*FRACUNIT
					end
					for i = 1, 9
						local curangle = ANG1*40*i

						local dust = P_SpawnMobj(target.bd.x+(24*cos(curangle)), target.bd.y+(24*sin(curangle)), target.bd.z, MT_DUMMY)
						dust.flags = $|MF_NOGRAVITY|MF_NOCLIPHEIGHT
						dust.state, dust.scale, dust.angle = S_BUFUDYNE_DUST1, FRACUNIT*5/4, curangle
						dust.destscale = FRACUNIT*5/2
						dust.scalespeed = FRACUNIT/18
						P_InstaThrust(dust, dust.angle, 12*FRACUNIT)
						dust.momz = 4*FRACUNIT
					end
					P_RemoveMobj(target.bd)
					playSound(mo.battlen, sfx_icebrk)
					damageObject(target)
					P_StartQuake(FRACUNIT*20, 10)
				elseif (timer == 110 + (#targets-1)*10)
					target.bd = nil
					return true
				end
			end
		end,
}

attackDefs["crest"] = {
		name = "Crest",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 6,
		desc = "Orbal Art.\nRaises defence to 1 ally \nby 1 stage",
		target = TGT_ALLY,
		buff = true,
		nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
						local target = targets[n]
						if target.buffs["def"][1] >= 75
							BTL_logMessage(targets[1].battlen, "Limit reached!")
							return true
						end
					end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]

			if timer == 20
				playSound(mo.battlen, sfx_buff)
				buffStat(target, "def")
				for i = 1,16
					local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					dust.angle = ANGLE_90 + ANG1* (22*(i-1))
					dust.state = S_CDUST1
					P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
					dust.color = SKINCOLOR_APRICOT
					dust.scale = FRACUNIT*2
				end

			elseif timer > 20 and timer <= 50

				if leveltime%2 == 0
					for i = 1,16

						local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
						thok.state = S_CDUST1
						thok.momz = P_RandomRange(3, 10)*FRACUNIT
						thok.color = SKINCOLOR_APRICOT
						thok.tics = P_RandomRange(10, 35)
						thok.scale = FRACUNIT*3/2
					end
				end

				for i = 1, 8
					local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
					thok.sprite = SPR_SUMN
					thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
					thok.momz = P_RandomRange(6, 16)*FRACUNIT
					thok.color = SKINCOLOR_APRICOT
					thok.tics = P_RandomRange(10, 35)
				end
			elseif timer == 60
				return true
			end
		end,
}

attackDefs["la_crest"] = {
		name = "La Crest",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 12,
		desc = "Orbal Art.\nRaises defence to all allies \nby 1 stage",
		target = TGT_ALLALLIES,
		buff = true,
		anim = function(mo, targets, hittargets, timer)

			for i = 1, #targets do

				local target = targets[i]

				if timer == 20 + (i-1)*16
					playSound(mo.battlen, sfx_buff)
					buffStat(target, "def")
					for i = 1,16
						local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						dust.angle = ANGLE_90 + ANG1* (22*(i-1))
						dust.state = S_CDUST1
						P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
						dust.color = SKINCOLOR_APRICOT
						dust.scale = FRACUNIT*2
					end

				elseif timer > 20 + (i-1)*16 and timer <= 50 + (i-1)*16

					if leveltime%2 == 0
						for i = 1,16

							local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
							thok.state = S_CDUST1
							thok.momz = P_RandomRange(3, 10)*FRACUNIT
							thok.color = SKINCOLOR_APRICOT
							thok.tics = P_RandomRange(10, 35)
							thok.scale = FRACUNIT*3/2
						end
					end

					for i = 1, 8
						local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
						thok.sprite = SPR_SUMN
						thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
						thok.momz = P_RandomRange(6, 16)*FRACUNIT
						thok.color = SKINCOLOR_APRICOT
						thok.tics = P_RandomRange(10, 35)
					end
				end
			end
			if timer == 60 + (#targets-1)*16
				return true
			end
		end,
}


attackDefs["thelas"] = {
		name = "Thelas",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 15,
		desc = "Orbal Art\nRevives a ally with half HP",
		target = TGT_DEAD,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			local cam = server.P_BattleStatus[mo.battlen].cam
			-- first of all, get this boy back in our party
			if timer == 1
				revivePlayer(target)
				mo.minido = {} //Megidola support: making things
				target.landedonce = false
			end
			local avgx, avgy = 0, 0
			for i = 1, #hittargets
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = ($/#hittargets)	*FRACUNIT
			avgy = ($/#hittargets)	*FRACUNIT
			
			if timer == 5
				local cx = mo.x + 192*cos(mo.angle)
				local cy = mo.y + 192*sin(mo.angle)
				P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*16)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
				summonAura(mo, SKINCOLOR_TEAL)
				ANIM_set(mo, mo.anim_evoker, true)
				ANIM_set(target, target.anim_downloop, true)
			elseif timer == 25
				local cx = target.x + 384*cos(target.angle)
				local cy = target.y + 384*sin(target.angle)
				P_TeleportMove(cam, cx, cy, target.z + FRACUNIT*24)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, target.x, target.y)
				playSound(mo.battlen, sfx_thelas)
			elseif timer < 60
			and timer > 25
				local ran = P_RandomRange(0, 359)*ANG1
				local dist = 256

				mo.minido[#mo.minido+1] = P_SpawnMobj(avgx + dist*cos(ran), avgy + dist*sin(ran), mo.z + 256*FRACUNIT, MT_DUMMY)
				local s = mo.minido[#mo.minido]
				s.angle = ran
				s.state = S_MEGITHOK
				s.scale = $/5
				s.extravalue1 = dist
				s.colorized = true
				s.color = SKINCOLOR_ORANGE
			end
			if timer <= 115
				for i = 1, #mo.minido
					if timer < 115
					local s = mo.minido[i]
					s.angle = $ + ANG1*12
					s.extravalue1 = max(0, $ - 6)

					local x = avgx + s.extravalue1*cos(s.angle)
					local y = avgy + s.extravalue1*sin(s.angle)
					local sz = s.z - FRACUNIT*6
					if s.z > target.z + 16*FRACUNIT
						P_TeleportMove(s, x, y, sz)
					else
						P_TeleportMove(s, x, y, s.z)
						s.destscale = 1
						s.scalespeed = FRACUNIT/20
					end
					elseif timer == 115
						local s = mo.minido[i]
						s.fuse = 2
					end
				end
			end
			if timer == 115
				local heals = target.maxhp/2
				damageObject(target, -heals)
				playSound(mo.battlen, sfx_tear)
				playSound(mo.battlen, sfx_lsheal)
				ANIM_set(target, target.anim_revive, true)
				target.momz = 6*FRACUNIT
				for i = 1, 64
					local thok = P_SpawnMobj(target.x + P_RandomRange(-40, 40)*FRACUNIT, target.y + P_RandomRange(-40, 40)*FRACUNIT, target.z, MT_DUMMY)
					thok.flags = MF_NOBLOCKMAP
					thok.color = SKINCOLOR_ORANGE
					thok.frame = A
					thok.tics = 50
					thok.scale = (P_RandomRange(1, 10)*FRACUNIT)/8
					thok.scalespeed = FRACUNIT/50
					thok.destscale = 1
					thok.momz = P_RandomRange(3, 12)*FRACUNIT
					thok.momx = P_RandomRange(-15, 15)*FRACUNIT
					thok.momy = P_RandomRange(-15, 15)*FRACUNIT
				end
			end
			if timer > 115 and P_IsObjectOnGround(target) and not target.landedonce
				ANIM_set(target, target.anim_stand_hurt, true)
				target.landedonce = true
			end
			if timer == 165
				target.landedonce = nil
				mo.minido = nil
				return true
			end
		end,
}

attackDefs["athelas"] = {
		name = "Athelas",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 30,
		desc = "Orbal Art\nRevives a ally with full HP",
		target = TGT_DEAD,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			local cam = server.P_BattleStatus[mo.battlen].cam
			-- first of all, get this boy back in our party
			if timer == 1
				revivePlayer(target)
				P_TeleportMove(target,target.x,target.y,target.z + FRACUNIT*10)
				local thok = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*16, MT_DUMMY)
				thok.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
				thok.color = SKINCOLOR_WHITE
				thok.frame = A|FF_TRANS90
				thok.tics = 9999
				thok.scale = 1
				mo.atom = thok
			end
			if timer < 160
				target.momz = 0
			end
			if timer > 25 and timer < 130
				mo.atom.momz = -((FRACUNIT*16)/(TICRATE*4))
			end
			if timer == 5
				local cx = mo.x + 192*cos(mo.angle)
				local cy = mo.y + 192*sin(mo.angle)
				P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*16)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
				summonAura(mo, SKINCOLOR_TEAL)
				ANIM_set(mo, mo.anim_evoker, true)
				ANIM_set(target, target.anim_downloop, true)
			elseif timer == 25
				local cx = target.x + 384*cos(target.angle)
				local cy = target.y + 384*sin(target.angle)
				P_TeleportMove(cam, cx, cy, target.z + FRACUNIT*24)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, target.x, target.y)
				playSound(mo.battlen, sfx_athela)
				
			end
			if timer == 25
			local cx = target.x + 64*cos(target.angle)
			local cy = target.y + 64*sin(target.angle)
				local fthok = P_SpawnMobj(cx, cy, target.z+16*FRACUNIT, MT_DUMMY)
				fthok.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
				fthok.color = SKINCOLOR_WHITE
				fthok.frame = A|FF_FULLBRIGHT
				fthok.tics = 9999
				fthok.angle = target.angle + ANGLE_90
				fthok.scale = FRACUNIT/2
				mo.fatom = fthok
			local dx = target.x + 64*cos(target.angle + ANGLE_180)
			local dy = target.y + 64*sin(target.angle + ANGLE_180)
				local bthok = P_SpawnMobj(dx, dy, target.z+16*FRACUNIT, MT_DUMMY)
				bthok.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
				bthok.color = SKINCOLOR_WHITE
				bthok.frame = A|FF_FULLBRIGHT
				bthok.tics = 9999
				bthok.angle = target.angle + ANGLE_270
				bthok.scale = FRACUNIT/2
				mo.batom = bthok
				mo.atom.destscale = FRACUNIT*2
				mo.atom.scalespeed = (FRACUNIT*2)/(TICRATE*4)
			end 
			if timer == 35
				mo.atom.frame = A|FF_TRANS80
			elseif timer == 45
				mo.atom.frame = A|FF_TRANS70
			elseif timer == 55
				mo.atom.frame = A|FF_TRANS60
			elseif timer == 65
				mo.atom.frame = A|FF_TRANS50
			elseif timer == 75
				mo.atom.frame = A|FF_TRANS40
			elseif timer == 85
				mo.atom.frame = A|FF_TRANS30
			elseif timer == 95
				mo.atom.frame = A|FF_TRANS20
			elseif timer == 105
				mo.atom.frame = A|FF_TRANS10
			elseif timer == 115
				mo.atom.frame = A|FF_FULLBRIGHT
			end
			if timer > 25
			and timer < 130
				P_InstaThrust(mo.fatom,mo.fatom.angle, FRACUNIT*40)
				mo.fatom.angle = $ + ANG1*25
				local thokf = P_SpawnMobj(mo.fatom.x, mo.fatom.y, mo.fatom.z+8*FRACUNIT, MT_DUMMY)
				thokf.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
				thokf.color = SKINCOLOR_WHITE
				thokf.frame = A|FF_TRANS50
				thokf.tics = 5
				thokf.scale = FRACUNIT/4
				local thokff = P_SpawnMobj(mo.fatom.x, mo.fatom.y, mo.fatom.z+8*FRACUNIT, MT_DUMMY)
				thokff.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
				thokff.color = SKINCOLOR_WHITE
				thokff.frame = A|FF_TRANS70
				thokff.tics = 10
				thokff.scale = FRACUNIT/4
				P_InstaThrust(mo.batom,mo.batom.angle, FRACUNIT*40)
				mo.batom.angle = $ + ANG1*25
				local thokb = P_SpawnMobj(mo.batom.x, mo.batom.y, mo.batom.z+8*FRACUNIT, MT_DUMMY)
				thokb.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
				thokb.color = SKINCOLOR_WHITE
				thokb.frame = A|FF_TRANS50
				thokb.tics = 5
				thokb.scale = FRACUNIT/4
				local thokbb = P_SpawnMobj(mo.batom.x, mo.batom.y, mo.batom.z+8*FRACUNIT, MT_DUMMY)
				thokbb.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
				thokbb.color = SKINCOLOR_WHITE
				thokbb.frame = A|FF_TRANS70
				thokbb.tics = 10
				thokbb.scale = FRACUNIT/4
			end
			if timer == 128
				mo.fatom.tics = 2
				mo.batom.tics = 2
			elseif timer == 130
				local heals = target.maxhp
				damageObject(target, -heals)
				playSound(mo.battlen, sfx_lsheal)
				ANIM_set(target, target.anim_revive, true)
				for i = 1, 128
					local thokka = P_SpawnMobj(target.x, target.y, target.z + 8*FRACUNIT, MT_DUMMY)
					thokka.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
					thokka.color = SKINCOLOR_WHITE
					thokka.frame = A|FF_TRANS30
					thokka.tics = 50
					thokka.scale = FRACUNIT/4
					thokka.scalespeed = (FRACUNIT/4)/50
					thokka.destscale = 1
					thokka.momz = P_RandomRange(-5, 5)*FRACUNIT
					thokka.momx = P_RandomRange(-8, 8)*FRACUNIT
					thokka.momy = P_RandomRange(-8, 8)*FRACUNIT
				end
			elseif timer == 150
				mo.atom.tics = 10
			elseif timer == 160
				ANIM_set(target, target.anim_stand_bored, true)
				for i = 1, 128
					local thokka = P_SpawnMobj(target.x, target.y, target.z + 8*FRACUNIT, MT_DUMMY)
					thokka.flags = MF_NOBLOCKMAP|MF_NOGRAVITY
					thokka.color = SKINCOLOR_WHITE
					thokka.frame = A|FF_TRANS30
					thokka.tics = P_RandomRange(15,30)
					thokka.scale = FRACUNIT/4
					thokka.scalespeed = (FRACUNIT/4)/50
					thokka.destscale = 1
					thokka.momz = P_RandomRange(-5, 5)*FRACUNIT
					thokka.momx = P_RandomRange(-8, 8)*FRACUNIT
					thokka.momy = P_RandomRange(-8, 8)*FRACUNIT
				end
			elseif timer == 180
				mo.fatom = nil
				mo.batom = nil
				mo.atom = nil
				return true
			end
		end,
}

attackDefs["la_tear"] = {
		name = "La Tear",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 8,
		power = 50,
		desc = "Orbal Art.\nHeals a small amount of HP \nto everyone",
		nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
						local noheal = 0
						for i = 1, #targets
							if targets[i].hp >= targets[i].maxhp
								noheal = $+1
							end
						end
						if noheal >= #targets
							BTL_logMessage(targets[1].battlen, "No further effects.")
							return true
						end
					end,

		target = TGT_ALLALLIES,
		anim = function(mo, targets, hittargets, timer)

			for e = 1, #targets

				local time = timer - 10*(e-1)

				local target = targets[e]
				
				if time >= 20
				and time < 50
					if time < 50
						local r = P_SpawnMobj(target.x + P_RandomRange(128,-128)*FRACUNIT,target.y + P_RandomRange(128,-128)*FRACUNIT, target.z + P_RandomRange(128,-128)*FRACUNIT, MT_THOK)
						r.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
						r.sprite = SPR_BFUC
						r.frame = A
						r.fuse = 20
						r.scale = (FRACUNIT*2)
						r.momx = (target.x - r.x)/20
						r.momy = (target.y - r.y)/20
						r.momz = (target.z - r.z)/20
						r.destscale = 1
						r.scalespeed = (FRACUNIT*2)/20
						local q = P_SpawnMobj(target.x + P_RandomRange(128,-128)*FRACUNIT,target.y + P_RandomRange(128,-128)*FRACUNIT, target.z, MT_THOK)
						q.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
						q.sprite = SPR_BFUC
						q.frame = D
						q.fuse = 55
						q.tics = q.fuse
						q.scale = (FRACUNIT*2)/3
						q.momz = (P_RandomRange(5, 15))*FRACUNIT
					end

				elseif time == 70
					local b = P_SpawnMobj(target.x, target.y, target.z + 16*FRACUNIT, MT_THOK)
					b.fuse = 35
					b.scale = FRACUNIT/4
					b.destscale = 13*FRACUNIT
					b.scalespeed = ((51*FRACUNIT)/4)/35
					b.frame = A|FF_FULLBRIGHT
					b.color = SKINCOLOR_CYAN
					P_SpawnMobj(target.x, target.y, target.z, MT_IVSP)
					local heals = P_RandomRange(50, 60)
					playSound(mo.battlen, sfx_lsheal)
					damageObject(target, -heals)
				end
			end

			if timer == 110 + (#targets-1)*10
				return true
			end
			if timer == 26
			playSound(mo.battlen, sfx_tear) 
			end
		end,
}

attackDefs["la_teara"] = {
		name = "La Teara",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 16,
		power = 150,
		desc = "Orbal Art.\nHeals a medium amount of HP \nto everyone",
		nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
						local noheal = 0
						for i = 1, #targets
							if targets[i].hp >= targets[i].maxhp
								noheal = $+1
							end
						end
						if noheal >= #targets
							BTL_logMessage(targets[1].battlen, "No further effects.")
							return true
						end
					end,

		target = TGT_ALLALLIES,
		anim = function(mo, targets, hittargets, timer)

			for e = 1, #targets

				local time = timer - 10*(e-1)

				local target = targets[e]
				
				if time >= 20
				and time < 50
					if time < 50
						for i = 1, 2
							local r = P_SpawnMobj(target.x + P_RandomRange(128,-128)*FRACUNIT,target.y + P_RandomRange(128,-128)*FRACUNIT, target.z + P_RandomRange(128,-128)*FRACUNIT, MT_THOK)
							r.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
							r.sprite = SPR_BFUC
							r.frame = A
							r.fuse = 20
							r.scale = (FRACUNIT*2)
							r.momx = (target.x - r.x)/20
							r.momy = (target.y - r.y)/20
							r.momz = (target.z - r.z)/20
							r.destscale = 1
							r.scalespeed = (FRACUNIT*2)/20
							local q = P_SpawnMobj(target.x + P_RandomRange(128,-128)*FRACUNIT,target.y + P_RandomRange(128,-128)*FRACUNIT, target.z, MT_THOK)
							q.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
							q.sprite = SPR_BFUC
							q.frame = D
							q.fuse = 55
							q.tics = q.fuse
							q.scale = (FRACUNIT*2)/3
							q.momz = (P_RandomRange(5, 15))*FRACUNIT
						end
					end

				elseif time == 70
					local b = P_SpawnMobj(target.x, target.y, target.z + 16*FRACUNIT, MT_THOK)
					b.fuse = 35
					b.scale = FRACUNIT/4
					b.destscale = 13*FRACUNIT
					b.scalespeed = ((51*FRACUNIT)/4)/35
					b.frame = A|FF_FULLBRIGHT
					b.color = SKINCOLOR_CYAN
					P_SpawnMobj(target.x, target.y, target.z, MT_IVSP)
					local heals = P_RandomRange(150, 160)
					playSound(mo.battlen, sfx_lsheal)
					damageObject(target, -heals)
				end
			end

			if timer == 110 + (#targets-1)*10
				return true
			end
			if timer == 26
			playSound(mo.battlen, sfx_teara) 
			end
		end,
}

attackDefs["la_tearal"] = {
		name = "La Tearal",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 23,
		power = 250,
		desc = "Orbal Art.\nHeals a large amount of HP \nto everyone",
		nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
						local noheal = 0
						for i = 1, #targets
							if targets[i].hp >= targets[i].maxhp
								noheal = $+1
							end
						end
						if noheal >= #targets
							BTL_logMessage(targets[1].battlen, "No further effects.")
							return true
						end
					end,

		target = TGT_ALLALLIES,
				anim = function(mo, targets, hittargets, timer)

			for e = 1, #targets

				local time = timer - 10*(e-1)

				local target = targets[e]
				
				if time >= 20
				and time < 50
					if time < 50
						for i = 1, 5
							local r = P_SpawnMobj(target.x + P_RandomRange(128,-128)*FRACUNIT,target.y + P_RandomRange(128,-128)*FRACUNIT, target.z + P_RandomRange(128,-128)*FRACUNIT, MT_THOK)
							r.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
							r.sprite = SPR_BFUC
							r.frame = A
							r.fuse = 20
							r.scale = (FRACUNIT*2)
							r.momx = (target.x - r.x)/20
							r.momy = (target.y - r.y)/20
							r.momz = (target.z - r.z)/20
							r.destscale = 1
							r.scalespeed = (FRACUNIT*2)/20
							local q = P_SpawnMobj(target.x + P_RandomRange(128,-128)*FRACUNIT,target.y + P_RandomRange(128,-128)*FRACUNIT, target.z, MT_THOK)
							q.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
							q.sprite = SPR_BFUC
							q.frame = D
							q.fuse = 55
							q.tics = q.fuse
							q.scale = (FRACUNIT*2)/3
							q.momz = (P_RandomRange(5, 15))*FRACUNIT
						end
					end

				elseif time == 70
					local b = P_SpawnMobj(target.x, target.y, target.z + 16*FRACUNIT, MT_THOK)
					b.fuse = 35
					b.scale = FRACUNIT/4
					b.destscale = 13*FRACUNIT
					b.scalespeed = ((51*FRACUNIT)/4)/35
					b.frame = A|FF_FULLBRIGHT
					b.color = SKINCOLOR_CYAN
					P_SpawnMobj(target.x, target.y, target.z, MT_IVSP)
					local heals = target.maxhp
					playSound(mo.battlen, sfx_lsheal)
					damageObject(target, -heals)
				end
			end

			if timer == 110 + (#targets-1)*10
				return true
			end
			if timer == 26
			playSound(mo.battlen, sfx_tearal) 
			end
		end,

}

attackDefs["curia"] = {
		name = "Curia",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 5,
		desc = "Orbal Art.\nCures ailments to 1 ally",
		target = TGT_ALLY,
		anim = function(mo, targets, hittargets, timer)
			local colors = {SKINCOLOR_EMERALD}

			local target = hittargets[1]
			if timer == 20
				playSound(mo.battlen, sfx_curia)
				for j = 1, 16
					local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					orb.momx = P_RandomRange(-16, 16)<<FRACBITS
					orb.momy = P_RandomRange(-16, 16)<<FRACBITS
					orb.momz = P_RandomRange(-16, 16)<<FRACBITS
					orb.destscale = 0
					orb.frame = A
					orb.color = colors[P_RandomRange(1, #colors)]
				end
				if target.status_condition and target.status_condition < COND_HYPER
					cureStatus(target)
				end
				BTL_logMessage(targets[1].battlen, "Ailments cured")
			end
			if timer == TICRATE*3/2
				return true
			end
		end,
}

attackDefs["swellinghope"] = {
		name = "Swelling Hope",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 12,
		desc = "Encourage allies with hope.\nRaises attack and magic\nattack by 1 stage.",
		target = TGT_ALLALLIES,
		buff = true,
		anim = function(mo, targets, hittargets, timer)

			for i = 1, #targets do

				local target = targets[i]

				if timer == 20 + (i-1)*16
					playSound(mo.battlen, sfx_courge)
					VFX_Play(target, VFX_SUMMON)
					buffStat(target, "mag")
					buffStat(target, "atk")
					
					BTL_logMessage(targets[1].battlen, "Magic Attack and Attack up!")
					for i = 1,16
						local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						dust.angle = ANGLE_90 + ANG1* (22*(i-1))
						dust.state = S_CDUST1
						P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
						dust.color = SKINCOLOR_GOLD
						dust.scale = FRACUNIT*2
					end

				elseif timer > 20 + (i-1)*16 and timer <= 50 + (i-1)*16

					if leveltime%2 == 0
						for i = 1,16

							local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
							thok.state = S_CDUST1
							thok.momz = P_RandomRange(3, 10)*FRACUNIT
							thok.color = SKINCOLOR_GOLD
							thok.tics = P_RandomRange(10, 35)
							thok.scale = FRACUNIT*3/2
						end
					end

					for i = 1, 8
						local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
						thok.sprite = SPR_SUMN
						thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
						thok.momz = P_RandomRange(6, 16)*FRACUNIT
						thok.color = SKINCOLOR_GOLD
						thok.tics = P_RandomRange(10, 35)
					end
				end
			end
			if timer == 60 + (#targets-1)*16
				return true
			end
		end,
}

attackDefs["recuria"] = {
		name = "Recuria",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 16,
		desc = "Orbal Art.\nCures ailments to everyone",
		target = TGT_ALLALLIES,
		anim = function(mo, targets, hittargets, timer)
			local colors = {SKINCOLOR_EMERALD}
			if timer == 20
				playSound(mo.battlen, sfx_curia)
			end
			for i = 1, #targets
				local target = targets[i]
				if timer == 20 + (i-1)*3
					for j = 1, 16
						local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						orb.momx = P_RandomRange(-16, 16)<<FRACBITS
						orb.momy = P_RandomRange(-16, 16)<<FRACBITS
						orb.momz = P_RandomRange(-16, 16)<<FRACBITS
						orb.destscale = 0
						orb.frame = A
						orb.color = colors[P_RandomRange(1, #colors)]
					end
					if target.status_condition and target.status_condition < COND_HYPER
						cureStatus(target)
					end
					BTL_logMessage(targets[1].battlen, "Ailments cured")
				end
			end
			if timer == TICRATE*3/2 + (#targets-1)*5
				return true
			end
		end,
}

attackDefs["diamond_nova"] = {
		name = "Diamond Nova",
		type = ATK_ICE,
		power = 650,
		accuracy = 100,
		costtype = CST_SP,
		cost = 32,
		status = COND_FREEZE,
		statuschance = 10,
		desc = "Orbal Art\nSevere ice damage to a enemy.\nMay freeze",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			if (timer >= 20 and timer <= 150) and (target.bd and target.bd.valid)

				local bs = P_SpawnMobj(target.bd.x+(P_RandomRange(-512, 512)*mo.scale), target.bd.y+(P_RandomRange(-512, 512)*mo.scale), target.bd.z+(P_RandomRange(0, 512)*mo.scale), MT_BUFU)
				bs.state, bs.color = S_BUFU_PARTICLE_D, SKINCOLOR_CYAN
				bs.momz = P_RandomRange(-1, 1)*FRACUNIT

				if (timer <= 150)
					local baseangle = P_RandomRange(1, 360)*ANG1
					local dist = 48
					for i = 0, 12
						local angle = baseangle + i*6*ANG1
						local x, y = target.bd.x + dist*cos(angle), target.bd.y + dist*sin(angle)

						local aura = P_SpawnMobj(x, y, target.z+i*FRACUNIT*3, MT_DUMMY)
						aura.state = S_BUFUDYNE_AURA1
						aura.angle = angle - ANGLE_90
						aura.color = SKINCOLOR_CYAN
						aura.momz = P_RandomRange(2, 9)*FRACUNIT
						aura.scale = FRACUNIT*3/4
						aura.destscale = FRACUNIT*2
						P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(5, 8))
					end
				end
			end
			if (timer == 40)
				playSound(mo.battlen, sfx_cocyt)
				target.bd = P_SpawnMobj(target.x, target.y, target.z + mo.scale*128, MT_DUMMY)
				target.bd.tics = -1
				target.bd.scale = FRACUNIT/6
				target.bd.destscale = FRACUNIT*2
				target.bd.scalespeed = FRACUNIT/48
				target.bd.sprite = SPR_BFDA
				target.bd.frame = J|FF_FULLBRIGHT
			
			elseif (timer == 65)
				playSound(mo.battlen, sfx_icebrk)
				target.bd.scale = FRACUNIT*2 + FRACUNIT/16
				target.bd.destscale = target.bd.scale
				target.bd.frame = K|FF_FULLBRIGHT
				
				local g = P_SpawnGhostMobj(target.bd)
				g.destscale = FRACUNIT*4
				g.scalespeed = FRACUNIT/6
				
			elseif (timer == 67)
				target.bd.scale = FRACUNIT*2
				target.bd.frame = J|FF_FULLBRIGHT
			
			elseif (timer >= 80 and timer < 90)
				P_TeleportMove(target.bd, target.x + P_RandomRange(-8, 8)*mo.scale, target.y + P_RandomRange(-8, 8), target.z + 128*mo.scale + P_RandomRange(-8, 8)*mo.scale)
			

			elseif (timer == 90)
			
				local g = P_SpawnGhostMobj(target.bd)
				g.destscale = FRACUNIT*4
				g.scalespeed = FRACUNIT/4	
				localquake(mo.battlen, FRACUNIT*32, 16)
			
				for i = 1, P_RandomRange(17, 32)
					local ba = P_SpawnMobj(target.bd.x+(P_RandomRange(-50, 50)*target.bd.scale), target.bd.y+(P_RandomRange(-50, 50)*target.bd.scale), target.bd.z+(P_RandomRange(0, 128)*target.bd.scale), MT_BUFU_PARTICLE)
					ba.state, ba.scale = S_BUFU_PARTICLE_A, FRACUNIT*7/4
					ba.momx, ba.momy, ba.momz = P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(-13, 13)*FRACUNIT, P_RandomRange(6, 19)*FRACUNIT
				end
				for i = 1, P_RandomRange(11, 32)
					local bb = P_SpawnMobj(target.bd.x+(P_RandomRange(-50, 50)*target.bd.scale), target.bd.y+(P_RandomRange(-50, 50)*target.bd.scale), target.bd.z+(P_RandomRange(0, 128)*target.bd.scale), MT_BUFU_PARTICLE)
					bb.state, bb.scale = S_BUFU_PARTICLE_B, FRACUNIT*7/4
					bb.momx, bb.momy, bb.momz = P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(-9, 9)*FRACUNIT, P_RandomRange(9, 23)*FRACUNIT
				end
				for i = 1, 9
					local curangle = ANG1*40*i

					local dust = P_SpawnMobj(target.bd.x+(24*cos(curangle)), target.bd.y+(24*sin(curangle)), target.bd.z, MT_DUMMY)
					dust.flags = $|MF_NOGRAVITY|MF_NOCLIPHEIGHT
					dust.state, dust.scale, dust.angle = S_BUFUDYNE_DUST1, FRACUNIT*5/4, curangle
					dust.destscale = FRACUNIT*5/2
					dust.scalespeed = FRACUNIT/18
					P_InstaThrust(dust, dust.angle, 12*FRACUNIT)
					dust.momz = 4*FRACUNIT
				end
				P_RemoveMobj(target.bd)
				playSound(mo.battlen, sfx_icebr2)
				damageObject(target)
				localquake(mo.battlen, FRACUNIT*20, 10)
			elseif (timer == 160)
				target.bd = nil
				return true
			end
		end,
}