if not srb2p return end

DNG_Abilities["elie"] = {

    jfunc =     function(p)
                    local mo = p.mo

                    p.drawangle = mo.angle
                    mo.momz = 0
                    local t = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
                    t.color = mo.color
                    P_InstaThrust(mo,mo.angle,(46*FRACUNIT))
                    S_StartSound(p.mo,sfx_spdpad)
					mo.state = S_PLAY_ROLL
                end,

        func =        function(p)
                    local mo = p.mo

                    if mo.p_abl
                        if not P_IsObjectOnGround(mo)
                            if (leveltime%3)
                                local g = P_SpawnGhostMobj(mo)
                                g.tics = 4
                                g.colorized = true
                            end
                        else
                            mo.p_abl = false
                        end
                    end
                end,
}

freeslot("SPR_BATE", "SPR_ELCH", "SPR_ELDE", "SPR_ELFI", "SPR_ELGN", "SPR_ELRP", "SPR_ELST", "sfx_elgun", "sfx_elgry", "sfx_elspk", "sfx_elthr", "sfx_aercan", "sfx_arcann", "sfx_antisp", "sfx_preaer", "sfx_aersik")

charStats["elie"] = {

		-- GENERAL

		name = "Elie",			-- This is only for bots / enemies
		basehp = 62,			-- base HP for level 1
		basesp = 64,
		persona = "elieskillset",
		melee_natk = "revolver",	-- normal melee attack
		melee_satk = "aerialcannon",
		
		supercolor_start = SKINCOLOR_SUPERELIE1,
		
		wep = "ingrid",		-- default weapon.
		weptype = WPT_GENERICRANGED,	-- Equippable weapon type(s)

		atk = 40,
		acc = 90,
		crit = 5,

		-- ANIMS
		-- Anims are built like this:
		-- {SPR_SPRITE, frame1, frame2, frame3, ... , duration between each frame}

		anim_stand = 		{SPR_BATE, A, 8, "SPR2_BATE"},					-- standing
		anim_stand_hurt =	{SPR_BATE, A, 1, "SPR2_BATE"},					-- standing (low HP) *
		anim_stand_bored =	{SPR_BATE, A, 8, "SPR2_BATE"},					-- standing (occasionally plays after anim_stand has played several times)
		anim_guard = 		{SPR_ELDE, A, 1, "SPR2_ELDE"},					-- guarding
		anim_move =			{SPR_PLAY, A, B, C, D, 2, "SPR2_WALK"},	-- moving
		anim_run =			{SPR_PLAY, A, B, C, D, 2, "SPR2_RUN_"},	-- guess what
		anim_atk =			{SPR_ELGN, A, 2, "SPR2_ROLL"},			-- attacking
		anim_aoa_end =		{SPR_PLAY, A, 2, "SPR2_FALL"},			-- jumping out of all-out attack
		anim_hurt =			{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- taking damage
		anim_getdown =		{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- knocked down from weakness / crit *
		anim_downloop =		{SPR_ELRP, A, 1, "SPR2_ELRP"},					-- is down
		anim_getup =		{SPR_BATE, A, 1, "SPR2_BATE"},			-- gets up from down
		anim_death =		{SPR_PLAY, A, 30, "SPR2_DEAD"},					-- dies
		anim_revive =		{SPR_PLAY, A, 2, "SPR2_ROLL"},			-- gets revived
		anim_evoker =		{SPR_ELCH, A, 8, "SPR2_ELCH"},
		anim_evoker_shoot = {SPR_ELFI, A, 8, "SPR2_ELFI"},
		anim_special1 =		{SPR_ELGN, A, 1, "SPR2_ELGN"},
		anim_special2 =		{SPR_ELST, A, B, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, 2, "SPR2_ELST"},
		
		vfx_summon = {"sfx_elsmn1", "sfx_elsmn2", "sfx_elsmn3", "sfx_elsmn4", "sfx_elsmn5"},
		vfx_skill = {"sfx_elskl1", "sfx_elskl2", "sfx_elskl3", "sfx_elskl4"},
		vfx_item = {"sfx_elitem"},
		vfx_hurt = {"sfx_elhrt1", "sfx_elhrt2", "sfx_elhrt3"},
		vfx_hurtx = {"sfx_elhrt2"},
		vfx_die = {"sfx_elrip"},
		vfx_heal = {"sfx_elhel1", "sfx_elhel2"},
		vfx_healself = {"sfx_eldog1"},
		vfx_kill = {"sfx_elkil1", "sfx_elkil2", "sfx_elkil3"},
		vfx_1more = {"sfx_el1mo", "sfx_el1mor"},
		vfx_crit = {"sfx_elcrt1", "sfx_elcrt2", "sfx_elcrt3", "sfx_elcrt4"},
		vfx_aoaask = {"sfx_elaoi1", "sfx_elaoi2", "sfx_elaoi3"},
		vfx_aoado = {"sfx_elaoa1", "sfx_elaoa2"},
		vfx_aoarelent = {"sfx_eldog2"},
		vfx_miss = {"sfx_elmis1", "sfx_elmis2"},
		vfx_dodge = {"sfx_eldog1", "sfx_eldog2"},
		vfx_win = {"sfx_elwin1", "sfx_elwin2", "sfx_elwin3", "sfx_elwin4"},
		vfx_levelup = {"sfx_elkil2"},
		vfx_tartarus_pit = {"sfx_elrip"},
		vfx_tartarus_item = {"sfx_elitm2"},
		vfx_tartarus_spring = {"sfx_elspng"},
		vfx_tartarus_spike = {"sfx_elhrt1", "sfx_elhrt2", "sfx_elhrt3"},
		vfx_tartarus_critspike = {"sfx_elhrt2"},
		vfx_tartarus_spikepit = {"sfx_elmpit"},

		icon = "H_ELEICO",	-- icon for net select and other menus
		hudbust = "H_ELEBAR",			-- patch to draw on the stat hud
		hudaoa = "H_ELEAOA",	-- patch for all out attack hud
		hudcutin = "ELIE_A",	-- cut in
		aoa_quote = "They are down!\nLet's go everyone!",

		tip = "A member of the Special Support Section with Wind and Elec orbal arts using the ARCUS Orbment. With her orbal gun she can use powerful Pierce skills to shoot down the enemies. She also has a buff and a Dekunda Skill",
}

VFX_freeslotC("elie") 
	
personaList["elieskillset"] = {
		-- GENERAL
		name = "Elie",
		arcana = nil,

		-- STATS (@ lv10)

		sprite = SPR_NULL,
		anim_idle = 	{SPR_NULL, A, 8},
		anim_atk = 		{SPR_NULL, A, 8},
		startframe = 0,

		strength = 10,
		magic = 11,
		endurance = 7,
		luck = 3,
		agility = 8,
		weak = ATK_PSY,
		resist = ATK_WIND|ATK_ELEC,
		skills = {
						{"air_strike", 1}, {"snap", 4},
						{"sparkle", 9}, {"innocence_arc", 15}, {"aerial", 17},
						{"aero_sickle", 20, "air_strike"}, {"saintly_force", 22},
						{"antistep", 23}, {"spark_arrow", 26, "sparkle"},
						{"cruel attack", 28, "snap"}, {"gale_raid", 30, "aerial"},
						{"wind boost", 35},  {"fortuna", 36, "saintly_force"},
						{"vile assault", 37, "cruel attack"}, {"antistepall", 40, "antistep"},
						{"triple_burst", 44, "vile assault"}, {"grand_stream", 49, "aero_sickle"}, 
						{"triple_piercer", 53, "triple_burst"},
						{"wind amp", 57, "wind boost"},
						{"ragna_blast", 60, "spark_arrow"}, {"aero_storm", 64, "gale_raid"},
						{"ragna_vortex", 70, "grand_stream"},
						{"judgement_bolt", 75, "ragna_blast"},
						
				},
}

attackDefs["revolver"] = {
	name = "Revolver Shot",
	type = ATK_PIERCE,
	power = 38,
	accuracy = 95,
	critical = 6,
	target = TGT_ENEMY,
	costtype = CST_HP,
	cost = 0,
	desc = "Shoots a bullet to a enemy",
	physical = true,
	anim = function(mo, targets, hittargets, timer)
		local target = targets[1]
		local btl = server.P_BattleStatus[mo.battlen]
		local cam = btl.cam
		
		if timer == 1
			if mo.anim_special1 and #mo.anim_special1
			ANIM_set(mo, mo.anim_special1)
			end
			playSound(mo.battlen, sfx_elgry)
			mo.oldangle = mo.angle
			mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
			cam.angle = R_PointToAngle2(cam.x, cam.y, target.x, target.y)
		elseif timer == 5*TICRATE/8
			local cx = target.x + 168*cos(target.angle + ANG1*20)
			local cy = target.y + 168*sin(target.angle + ANG1*20)
			CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, target.z + FRACUNIT*30, 70*FRACUNIT)
			CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y))
		end
		
		if timer == 1*TICRATE/2
			playSound(mo.battlen, sfx_elgun)
		end
		
		if timer == 3*TICRATE/4
			damageObject(hittargets[1])
			playSound(mo.battlen, sfx_lydhit)
			P_StartQuake(FRACUNIT*7, 4)
			for i = 1, 2
				createSplat(mo)
			end
		end
		if timer == 3*TICRATE/2
			return true
		end
	end,
}

attackDefs["aerialcannon"] = {
	name = "Aerial Cannon",
	type = ATK_ALMIGHTY,
	power = 45,
	accuracy = 999,
	critical = 6,
	nometronome = true,
	norandom = true,
	target = TGT_ALLENEMIES, //Here I go
	costtype = CST_SP, //Special SP
	cost = 300,
	status = COND_BURN, //Idk lol
	statuschance = 15, 
	hits = 36, //Lets hit many times at random targets before a final kablewy - So.. Max times an enemy can be hit
	desc = "Elie's S-Craft\nPrays for Aidios to give power\nand shoots explosive shots",
	//physical = true, Yes I know I like cut-ins 
	anim = function(mo, targets, hittargets, timer)
	//Lets setup DaCamera first
		local cam = server.P_BattleStatus[mo.battlen].cam
		local ctgt = hittargets[1] //And aim at a random fucker
		local rnd = P_RandomRange(1,#hittargets) //Why yes I did steal from myself twice
		local rtgt = hittargets[rnd] //So incase we go for a random fucker
		if timer == 1
			ANIM_set(mo, mo.anim_special1, true)//Do this anim
			playSound(mo.battlen, sfx_cutlyd)
			playSound(mo.battlen, sfx_aercan)
			mo.angle = R_PointToAngle2(mo.x,mo.y,ctgt.x,ctgt.y) //Okay look at "1"
			//And of course, Camera
			local cx = mo.x + 192*cos(mo.angle)
			local cy = mo.y + 192*sin(mo.angle)
			P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*16)
			server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y) //Hello camera, welcome back
		elseif timer == 15
		//Make da bwWQUEwUW thing like the coool vfx thing this is how: THOK
			local cx = mo.x + 8*cos(mo.angle)
			local cy = mo.y + 8*sin(mo.angle)//TAKe this, thanks
			local thok = P_SpawnMobj(cx, cy, mo.z + FRACUNIT*40, MT_DUMMY)//At this Z height
			thok.color = SKINCOLOR_TEAL //Looks teal..?
			thok.frame = A|FF_FULLBRIGHT //Make it not transparent
			thok.tics = 90 //For 90 - 2 seconds + 20 frames
			thok.scale = FRACUNIT*2 //2 seems good
			mo.nrg = thok //This can now be called to as "mo.nrg"
		elseif timer >= 50 //One second later..
		and timer < 85
			local cx = mo.x + 192*cos(mo.angle+ANGLE_225)
			local cy = mo.y + 192*sin(mo.angle+ANGLE_225) //Tilted
			local ccx = mo.x + 9*cos(mo.angle)
			local ccy = mo.y + 9*sin(mo.angle)
			P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*24)
			server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
			local thok = P_SpawnMobj(ccx,ccy, mo.nrg.z + 16*FRACUNIT, MT_DUMMY) //Spawn cool stuff from the main
				thok.flags = MF_NOBLOCKMAP
				thok.color = SKINCOLOR_CYAN
				if timer%3 then thok.color = SKINCOLOR_ICY end
				if timer%2 then thok.color = SKINCOLOR_MINT end
				thok.frame = A
				thok.tics = 10
				thok.scale = FRACUNIT
				thok.scalespeed = FRACUNIT/11
				thok.destscale = 1
				thok.momz = P_RandomRange(-10, 10)*FRACUNIT
				thok.momx = P_RandomRange(-10, 10)*FRACUNIT
				thok.momy = P_RandomRange(-10, 10)*FRACUNIT
		elseif timer >=85
		and timer < 105
			if timer == 85
			playSound(mo.battlen, sfx_arcann)
			local cx = mo.x + 384*cos(mo.angle+ANGLE_225)
			local cy = mo.y + 384*sin(mo.angle+ANGLE_225) //Zoom out
			P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*24)
			server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
			end
			if not (timer%2)
			local shot = P_SpawnMobj(mo.nrg.x + P_RandomRange(-16, 16)*FRACUNIT, mo.nrg.y + P_RandomRange(-16, 16)*FRACUNIT, mo.nrg.z + P_RandomRange(-16, 16)*FRACUNIT, MT_DUMMY)
				if not (timer%4)
					playSound(mo.battlen, sfx_elgun)
				end
				shot.state = S_STAB_1_1
				shot.color = SKINCOLOR_TEAL //Pew pew effects
				shot.scale = (P_RandomRange(1,12)*FRACUNIT)/4
			end
		elseif timer == 105
			cam.momx = 0
			cam.momy = 0
			local cx = ctgt.x + 512*cos(ctgt.angle + ANG1*200)
			local cy = ctgt.y + 512*sin(ctgt.angle + ANG1*200) //Cool angle?
			P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*24)//...No guarantee
			server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, ctgt.x, ctgt.y)
		elseif timer >= 110
		and timer < 145 //35 seconds... Fuck em up.
			local booma = P_SpawnMobj(rtgt.x+P_RandomRange(-20, 20)*FRACUNIT, rtgt.y+P_RandomRange(-20, 20)*FRACUNIT, rtgt.z+P_RandomRange(-20, 20)*FRACUNIT, MT_BOSSEXPLODE)
				if not (leveltime%10)
					playSound(mo.battlen, sfx_tiexp)
				end
				booma.scale = FRACUNIT*3
				booma.state = S_QUICKBOOM1
				booma.colorized = true
				booma.color = SKINCOLOR_TEAL
			local boomb = P_SpawnMobj(rtgt.x+P_RandomRange(-64, 64)*FRACUNIT, rtgt.y+P_RandomRange(-64, 64)*FRACUNIT, rtgt.z+20*FRACUNIT, MT_BOSSEXPLODE)
				boomb.scale = FRACUNIT*4
				boomb.state = S_PFIRE1
				booma.colorized = true
				booma.color = SKINCOLOR_CYAN
			damageObject(rtgt) //BABABABABABABABAABALAAAAAST KABLEWYYYYYYYYYYYYYYYYYYYYYYY
			localquake(mo.battlen, FRACUNIT*24, 3) //Hyperactive Zoraxua moment: fukin TREMBLE the camera lol
		end
			local j = mo.columns and #mo.columns or 0
			while j
				local m = mo.columns[j]
				if not m or not m.valid
					j = $-1
					continue
				end

				for i = 1, 5
					local boom = P_SpawnMobj(m.x + P_RandomRange(-48, 48)*FRACUNIT, m.y + P_RandomRange(-48, 48)*FRACUNIT, m.z, MT_DUMMY)
					boom.state = S_QUICKBOOM1
					boom.colorized = true
					boom.color = SKINCOLOR_AQUA
					boom.momz = P_RandomRange(0, 48)*FRACUNIT
					boom.scale = FRACUNIT*3
				end
				P_StartQuake(FRACUNIT*8, 1)
				j = $-1
			end //Setup the KANNON BOOOOOM
		if timer >= 125
		and timer < 145
			if timer == 125
				DoExplosion(ctgt)
			end
			for i = 1, 12
				local boom = P_SpawnMobj(ctgt.x + P_RandomRange(-48, 48)*FRACUNIT, ctgt.y + P_RandomRange(-48, 48)*FRACUNIT, ctgt.z, MT_DUMMY)
				boom.state = S_QUICKBOOM1 //One person gets the biggest lol
				boom.colorized = true
				boom.color = SKINCOLOR_LIME
				boom.momz = P_RandomRange(0, 48)*FRACUNIT
				boom.scale = FRACUNIT*3/2
			end
		elseif timer == 145
			for k,v in ipairs(mo.allies)
				if v and v.control and v.control.valid
					P_FlashPal(v.control, 4, 10) //Redpal flash
				end
			end
		P_StartQuake(FRACUNIT*32, 15)//AGAIN AGAIN
		//It's time..
			for i = 1,#hittargets
				local target = hittargets[i]
				damageObject(target)
				local smol = P_SpawnMobj(ctgt.x, ctgt.y, ctgt.z, MT_SMOLDERING)
				smol.fuse = TICRATE*2
				smol.scale = FRACUNIT*3
				smol.colorized = true
				smol.color = SKINCOLOR_TEAL
			end
			DoExplosion(ctgt)
			mo.fangle = (R_PointToAngle(ctgt.x, ctgt.y)) + ANG1*180
			mo.columns = {}
			playSound(mo.battlen, sfx_megi5)
			//For my KANNON ! ! !

			local a = mo.fangle - ANG1*80

			for i = 1, 16
				local m = P_SpawnMobj(ctgt.x, ctgt.y, ctgt.z, MT_DUMMY)
				P_InstaThrust(m, a, FRACUNIT*48)
				mo.columns[#mo.columns+1] = m
				m.state = S_INVISIBLE
				m.tics = TICRATE
				a = $+ ANG1*10
			end
		elseif timer == 170 //Wrap it up
			for i = 1,#hittargets
				local target = hittargets[i]
				local smol = P_SpawnMobj(ctgt.x, ctgt.y, ctgt.z, MT_SMOLDERING)
				smol.fuse = TICRATE*2
				smol.scale = FRACUNIT*3
				smol.colorized = true
				smol.color = SKINCOLOR_SEAFOAM //More smoldering
			end
			mo.nrg = nil //Buh-bye
			return true
		end
	end, //Zoraxua moment: Let me error 6 times for missing commas
}

attackDefs["air_strike"] = {
		name = "Air Strike",
		type = ATK_WIND,
		power = 60,
		accuracy = 95,
		costtype = CST_SP,
		technical = COND_BURN,
		cost = 4,
		desc = "Orbal Art.\nLight Wind Damage to a enemy",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]

			if timer == 20

				for i = 1, 8
					local g = P_SpawnMobj(target.x, target.y, target.z + P_RandomRange(0, 60)*FRACUNIT, MT_TRAILSWIND)
					g.target = target
					g.angle = FixedAngle(P_RandomRange(1, 360)*FRACUNIT)
					if i == 1 or i == 8
						g.jizzcolor = true
					end
					if i%2
						g.invertrotation = true
					end
					g.dist = P_RandomRange(45, 90)
					g.tics = 25
				end

			elseif timer == 30
				playSound(mo.battlen, sfx_wind1)

			elseif timer == 33
			or timer == 36
			or timer == 39
				local s = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
				s.scale = FRACUNIT/4
				s.sprite = SPR_SLAS
				s.frame = I|TR_TRANS50 + P_RandomRange(0, 3)
				s.destscale = FRACUNIT*9
				s.scalespeed = FRACUNIT
				s.tics = TICRATE/3

			elseif timer == 40
				damageObject(target)
				for i = 1, 32
					local g = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					g.scale = FRACUNIT/2
					g.destscale = 1
					g.color = SKINCOLOR_EMERALD
					g.frame = A
					if i%2 then g.color = SKINCOLOR_WHITE end
					g.momx = P_RandomRange(-15, 15)*FRACUNIT
					g.momy = P_RandomRange(-15, 15)*FRACUNIT
					g.momz = P_RandomRange(-15, 15)*FRACUNIT
				end

			elseif timer == 75
				return true
			end
		end,
}

attackDefs["aerial"] = {
		name = "Aerial",
		type = ATK_WIND,
		power = 60,
		accuracy = 90,
		costtype = CST_SP,
		cost = 8,
		desc = "Orbal Art.\nLight Wind Damage to all enemies",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)

			for k,e in ipairs(hittargets)
			local target = e
			local time = timer - 5*(k-1)

				if time == 20

					for i = 1, 8
						local g = P_SpawnMobj(target.x, target.y, target.z + P_RandomRange(0, 60)*FRACUNIT, MT_TRAILSWIND)
						g.target = target
						g.angle = FixedAngle(P_RandomRange(1, 360)*FRACUNIT)
						if i == 1 or i == 8
							g.jizzcolor = true
						end
						if i%2
							g.invertrotation = true
						end
						g.dist = P_RandomRange(45, 90)
						g.tics = 25
						g.lowquality = true
					end

				elseif time == 30
					playSound(mo.battlen, sfx_wind1)

				elseif time == 33
				or time == 36
				or time == 39
					local s = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					s.scale = FRACUNIT/4
					s.sprite = SPR_SLAS
					s.frame = I|TR_TRANS50 + P_RandomRange(0, 3)
					s.destscale = FRACUNIT*9
					s.scalespeed = FRACUNIT
					s.tics = TICRATE/3

				elseif time == 40
					damageObject(target)
				end
			end
			if timer == 75 + 5*(#hittargets-1)
				return true
			end
		end,
}

attackDefs["aero_sickle"] = {
		name = "Aero Sickle",
		type = ATK_WIND,
		power = 140,
		accuracy = 95,
		costtype = CST_SP,
		cost = 8,
		desc = "Orbal Art.\nMedium Wind Damage to a enemy",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			local wepx = mo.x + 8*cos(mo.angle + ANGLE_45)
			local wepy = mo.y + 8*sin(mo.angle + ANGLE_45)
			local wepz = mo.z + FRACUNIT*40
			//PUPPY DO A LUA yet again
			//hERES MY AWESOME WEPX WEPY WEPZ DEFS AWESOME
			if timer == 1 
				mo.angle = R_PointToAngle2(mo.x,mo.y,target.x,target.y)
				//Aim and Look fuckface
			end
			if timer < 35
				local s = P_SpawnMobj(wepx, wepy, wepz, MT_DUMMY)
				s.scale = FRACUNIT
				s.sprite = SPR_SLAS
				s.frame = I|TR_TRANS50 + P_RandomRange(0, 3)
				s.destscale = 1
				s.scalespeed = FRACUNIT/5
				s.tics = 5
				s.rollangle = ANG1*P_RandomRange(1,360)
				//Wind "energy"
			end
			if timer == 35
				local thok = P_SpawnMobj(wepx, wepy, wepz, MT_DUMMY)	
				thok.color = SKINCOLOR_EMERALD
				thok.frame = A|FF_FULLBRIGHT
				thok.flags2 = $|MF2_SPLAT
				thok.tics = 50 //2* target hit time - make it resume on
				thok.scale = mo.scale
				thok.momx = (target.x - thok.x)/25
				thok.momy = (target.y - thok.y)/25
				thok.momz = (target.z - thok.z)/25
				//Why yes I did take this from Zorua's attacks! WELL I made the lua so I CAN STEAL FROM MYSELF (Yes this is the dumb Slybrid btw)
				mo.windblob = thok //Okay set this as an object so we can throw bullshit around! AWesome!
				playSound(mo.battlen, sfx_s3k4b)
			end
			
			if timer == 60
				damageObject(target)
				if target.damagestate ~= DMG_MISS
				and target.damagestate ~= DMG_BLOCK
				and target.damagestate ~= DMG_DRAIN
					P_SetObjectMomZ(target,FRACUNIT*17,true)
					playSound(mo.battlen, sfx_aersik)
				else
					playSound(mo.battlen, sfx_s3k47)
				end	
				for i = 1,20
					local thok = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)	
					thok.color = SKINCOLOR_MINT
					thok.frame = A|FF_FULLBRIGHT
					thok.flags = $|MF_GRENADEBOUNCE|MF_MISSILE|MF_NOCLIPTHING & !MF_NOGRAVITY
					thok.tics = 105
					thok.scale = mo.scale/2
					thok.destscale = 1
					thok.scalespeed = (mo.scale/2)/105
					thok.momx = P_RandomRange(-15,15)*FRACUNIT
					thok.momy = P_RandomRange(-15,15)*FRACUNIT
					thok.momz = P_RandomRange(5,15)*FRACUNIT
				end//Also swiped from the Tricky Fox
			end
			//We speculate to stike here - So lets damage here!
			if timer < 85 and mo.windblob
				local s = P_SpawnMobj(mo.windblob.x, mo.windblob.y, mo.windblob.z, MT_DUMMY)
				s.scale = FRACUNIT/2
				s.sprite = SPR_SLAS
				s.frame = I|TR_TRANS50 + P_RandomRange(0, 3)
				s.destscale = 1
				s.scalespeed = (FRACUNIT/2)/min(5,mo.windblob.tics)
				s.tics = min(5,mo.windblob.tics)
				s.rollangle = ANG1*P_RandomRange(1,360)
				s.momx = mo.windblob.momx
				s.momy = mo.windblob.momy
			end 
			//Spawn winds by the windblob
			if timer == 85
				if mo.windblob
					mo.windblob = nil
				end
				return true
			end
			if timer == 10
			playSound(mo.battlen, sfx_preaer) 
			end
		end,
}

attackDefs["gale_raid"] = {
		name = "Gale Raid",
		type = ATK_WIND,
		power = 140,
		accuracy = 90,
		costtype = CST_SP,
		cost = 16,
		desc = "Orbal Art.\nMedium Wind Damage to all enemies",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)

			for k,e in ipairs(hittargets)
			local target = e
			local time = timer - 5*(k-1)

				if time == 20
					playSound(mo.battlen, sfx_wind2)
					for i = 1, 10
						local g = P_SpawnMobj(target.x, target.y, target.z + P_RandomRange(0, 120)*FRACUNIT, MT_TRAILSWIND)
						g.target = target
						g.angle = FixedAngle(P_RandomRange(1, 360)*FRACUNIT)
						if i == 1 or i == 8
							g.jizzcolor = true
						end
						if i%2
							g.invertrotation = true
						end
						g.dist = P_RandomRange(45, 140)
						g.tics = 25
						g.lowquality = true
					end

				elseif time == 30
				or time == 33
				or time == 36
				or time == 39
					local s = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					s.scale = FRACUNIT/4
					s.sprite = SPR_SLAS
					s.frame = I|TR_TRANS50 + P_RandomRange(0, 3)
					s.destscale = FRACUNIT*9
					s.scalespeed = FRACUNIT
					s.tics = TICRATE/3

				elseif time == 40
					damageObject(target)
				end
			end
			if timer == 75 + 5*(#hittargets-1)
				return true
			end
		end,
}
	
attackDefs["grand_stream"] = {
		name = "Grand Stream",
		type = ATK_WIND,
		power = 350,
		accuracy = 95,
		costtype = CST_SP,
		cost = 12,
		desc = "Orbal Art.\nHeavy Wind Damage to a enemy",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]

			if timer > 20
			and timer < 50
			and leveltime%5 == 0
				local s = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
				s.scale = FRACUNIT/4
				s.sprite = SPR_SLAS
				s.frame = I|TR_TRANS50 + P_RandomRange(0, 3)
				s.destscale = FRACUNIT*9
				s.scalespeed = FRACUNIT
				s.tics = TICRATE/3
			end

			if timer == 20
				playSound(mo.battlen, sfx_wind3)
				local barrier = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
				target.elec = barrier
				barrier.scale = FRACUNIT*2
				barrier.state = S_PLAY_STND
				barrier.tics = -1
				barrier.sprite = SPR_ELEC
				barrier.fuse = 40
				local g = P_SpawnGhostMobj(barrier)
				g.destscale = FRACUNIT*4

				for i = 1, 12
					local g = P_SpawnMobj(target.x, target.y, target.z + P_RandomRange(0, 120)*FRACUNIT, MT_TRAILSWIND)
					g.target = target
					g.angle = FixedAngle(P_RandomRange(1, 360)*FRACUNIT)
					if i == 1 or i == 8
						g.jizzcolor = true
					end
					if i%2
						g.invertrotation = true
					end
					g.dist = P_RandomRange(45, 140)
					g.tics = 35
				end
			elseif timer == 55
				damageObject(target)
				P_StartQuake(FRACUNIT*8, 8)
				for i = 1, 32
					local g = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					g.scale = FRACUNIT/2
					g.destscale = 1
					g.color = SKINCOLOR_EMERALD
					g.frame = A
					if i%2 then g.color = SKINCOLOR_WHITE end
					g.momx = P_RandomRange(-15, 15)*FRACUNIT
					g.momy = P_RandomRange(-15, 15)*FRACUNIT
					g.momz = P_RandomRange(-15, 15)*FRACUNIT
				end
			elseif timer == 85
				target.elec = nil
				return true
			end

			if target.elec
			and target.elec.valid
			and not (leveltime%2)
				target.elec.frame = P_RandomRange(A, L)
			end
		end,
}

attackDefs["aero_storm"] = {
		name = "Aero Storm",
		type = ATK_WIND,
		power = 350,
		accuracy = 90,
		costtype = CST_SP,
		cost = 24,
		desc = "Orbal Art.\nHeavy Wind Damage to all enemies",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)

			for k,e in ipairs(hittargets)
			local target = e
			local time = timer - 5*(k-1)

				if time == 20
					playSound(mo.battlen, sfx_wind3)
					local barrier = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					target.elec = barrier
					barrier.scale = FRACUNIT*2
					barrier.state = S_PLAY_STND
					barrier.tics = -1
					barrier.sprite = SPR_ELEC
					barrier.fuse = 40
					for i = 1, 10
						local g = P_SpawnMobj(target.x, target.y, target.z + P_RandomRange(0, 120)*FRACUNIT, MT_TRAILSWIND)
						g.target = target
						g.angle = FixedAngle(P_RandomRange(1, 360)*FRACUNIT)
						if i == 1 or i == 8
							g.jizzcolor = true
						end
						if i%2
							g.invertrotation = true
						end
						g.dist = P_RandomRange(45, 140)
						g.tics = 35
						g.lowquality = true
					end
				elseif time == 50
					target.elec = nil
					damageObject(target)
					P_StartQuake(FRACUNIT*8, 8)
				end

				if target.elec
				and target.elec.valid
				and not (leveltime%2)
					target.elec.frame = P_RandomRange(A, L)
				end

			end
			if timer == 85 + 5*(#hittargets-1)
				return true
			end
		end,
}

attackDefs["sparkle"] = {
		name = "Sparkle",
		type = ATK_ELEC,
		power = 60,
		accuracy = 95,
		costtype = CST_SP,
		status = COND_SHOCK,
		statuschance = 5,
		cost = 4,
		desc = "Orbal Art.\nLight Elec Damage to a enemy.\nMay Shock",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
            if (timer == 20)
				-- first one, the one behind
				local z1 = P_SpawnMobj(target.x, target.y, target.floorz, MT_DUMMY)
                z1.state, z1.scale, z1.color = S_LZIO11, target.scale*9/4, SKINCOLOR_TEAL
                z1.destscale = target.scale    -- this probably looks retarded at smaller scales from afar lmao
				-- second, the dominant in front
				local z2 = P_SpawnMobj(target.x, target.y, target.floorz, MT_DUMMY)
				z2.state, z2.scale, z2.color = S_LZIO21, target.scale*9/4, SKINCOLOR_GOLD
				z2.destscale = target.scale

				playSound(mo.battlen, sfx_elspk)
				damageObject(target)
			elseif (timer == 60)
				return true
			end
		end,
}

attackDefs["spark_arrow"] = {
		name = "Spark Arrow",
		type = ATK_ELEC,
		power = 140,
		accuracy = 95,
		costtype = CST_SP,
		status = COND_SHOCK,
		statuschance = 5,
		cost = 8,
		desc = "Orbal Art.\nMedium Elec Damage to a enemy.\nMay Shock",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			if (timer == 20)
				target.z_dangle = P_RandomRange(1, 359)*ANG1 -- default angle we'll base the second zio on
				local dist = 36+P_RandomRange(-6, 6)

				local z1 = P_SpawnMobj(target.x+(dist*cos(target.z_dangle)), target.y+(dist*sin(target.z_dangle)), target.floorz, MT_DUMMY)
				z1.state, z1.scale, z1.color = S_LZIO11, target.scale*9/4, SKINCOLOR_CYAN
				z1.destscale = target.scale
				local z2 = P_SpawnMobj(target.x+(dist*cos(target.z_dangle)), target.y+(dist*sin(target.z_dangle)), target.floorz, MT_DUMMY)
				z2.state, z2.scale, z2.color = S_LZIO21, target.scale*9/4, SKINCOLOR_CYAN
				z2.destscale = target.scale

				playSound(mo.battlen, sfx_elspk)
			elseif (timer == 27)
				local dist = 25+P_RandomRange(-6, 6)
				local angle = target.z_dangle+ANGLE_180+(P_RandomRange(-22, 22)*ANG1)

				local z1 = P_SpawnMobj(target.x+(dist*cos(angle)), target.y+(dist*sin(angle)), target.floorz, MT_DUMMY)
				z1.state, z1.scale, z1.color = S_LZIO11, target.scale*11/4, SKINCOLOR_CYAN
				z1.destscale = target.scale*5/4
				local z2 = P_SpawnMobj(target.x+(dist*cos(angle)), target.y+(dist*sin(angle)), target.floorz, MT_DUMMY)
				z2.state, z2.scale, z2.color = S_LZIO21, target.scale*11/4, SKINCOLOR_CYAN
				z2.destscale = target.scale*5/4

				playSound(mo.battlen, sfx_elspk)
			elseif (timer >= 42 and timer <= 56)
				if (timer == 42)
					local z1 = P_SpawnMobj(target.x, target.y, target.floorz, MT_DUMMY)
					z1.state, z1.scale, z1.color = S_LZIO11, target.scale*15/4, SKINCOLOR_CYAN
					z1.destscale = target.scale*3/2
					local z2 = P_SpawnMobj(target.x, target.y, target.floorz, MT_DUMMY)
					z2.state, z2.scale, z2.color = S_LZIO21, target.scale*15/4, SKINCOLOR_CYAN
					z2.destscale = target.scale*3/2

					playSound(mo.battlen, sfx_lydhit)
					damageObject(target)
				end
				for i = 1, 2
					if not (timer%3)
						local angle = P_RandomRange(1, 359)*ANG1
						local dist = P_RandomRange(30, 36)

						local s = P_SpawnMobj(target.x+(dist*cos(angle)), target.y+(dist*sin(angle)), target.floorz, MT_DUMMY)
						s.state, s.color, s.scale = S_SSPK1, SKINCOLOR_WHITE, target.scale*2
						s.momz, s.destscale = P_RandomRange(5, 24)*FRACUNIT, FRACUNIT/6
						P_InstaThrust(s, angle, P_RandomRange(6, 8)*FRACUNIT)
					end
				end
			elseif (timer == 76)
				target.z_dangle = nil
				return true
			end
		end
}

attackDefs["ragna_blast"] = {
		name = "Ragna Blast",
		type = ATK_ELEC,
		power = 350,
		accuracy = 95,
		costtype = CST_SP,
		status = COND_SHOCK,
		statuschance = 5,
		cost = 12,
		desc = "Orbal Art.\nHeavy Elec Damage to a enemy.\nMay Shock",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			if timer == 20
				playSound(mo.battlen, sfx_elthr)
				lightningblast(target, SKINCOLOR_MAGENTA, FRACUNIT*3/2)
				localquake(mo.battlen, FRACUNIT*8, 8)
				damageObject(target)
			elseif timer == 60
				return true
			end
		end,
}

attackDefs["innocence_arc"] = {
		name = "Innocence Arc",
		dekunda = true,	-- see above w/ dekaja
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 10,
		desc = "Orbal Art\nRemove party debuffs",
		target = TGT_ALLALLIES,
		anim = function(mo, targets, hittargets, timer)
			local colors = {SKINCOLOR_GOLD, SKINCOLOR_YELLOW, SKINCOLOR_LIME}
			local strs = {"atk", "mag", "def", "agi"}

			for i = 1, #targets
				local target = targets[i]
				if timer == 20 + (i-1)*10
					playSound(mo.battlen, sfx_curia)
					for j = 1, 16
						local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						orb.momx = P_RandomRange(-16, 16)<<FRACBITS
						orb.momy = P_RandomRange(-16, 16)<<FRACBITS
						orb.momz = P_RandomRange(-16, 16)<<FRACBITS
						orb.destscale = 0
						orb.frame = A
						orb.color = colors[P_RandomRange(1, #colors)]
					end
					for j = 1, #strs
						local t = targets[i]
						local s = strs[j]
						if t.buffs[s][1] < 0
							t.buffs[s][1] = 0
							t.buffs[s][2] = 0
						end
					end
					BTL_logMessage(targets[1].battlen, "Debuffs removed")
				end
			end
			if timer == TICRATE*3/2 + (#targets-1)*10
				return true
			end
		end,
}

attackDefs["triple_burst"] = {
		name = "Triple Burst",
		type = ATK_PIERCE,
		power = 80,
		accuracy = 100,
		costtype = CST_HPPERCENT,
		technical = COND_FREEZE,
		cost = 15,
		critical = 2,
		hits = 3,
		desc = "Fires three high-accuracy shots\ncausing Light Damage\nto one enemy",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]

			if timer >= 15 and timer <= 45
			and not (timer%2)

				local shot = P_SpawnMobj(target.x + P_RandomRange(-150, 150)*FRACUNIT, target.y + P_RandomRange(-150, 150)*FRACUNIT, target.z + P_RandomRange(0, 150)*FRACUNIT, MT_DUMMY)
				if not (timer%4)
					playSound(mo.battlen, sfx_elgun)
				end
				shot.state = S_STAB_1_1
				shot.color = SKINCOLOR_WHITE
				shot.scale = $ + P_RandomRange(0, 65535)*3

				if not (timer%8)
					createSplat(mo)
					P_StartQuake(FRACUNIT*4, 4)
				end

			end
			if timer == 30
			or timer == 40
			or timer == 50
				damageObject(target)
			elseif timer == 85
				return true
			end
		end,
}

attackDefs["triple_piercer"] = {
		name = "Triple Piercer",
		type = ATK_PIERCE,
		power = 120,
		accuracy = 120,
		costtype = CST_HPPERCENT,
		technical = COND_FREEZE,
		cost = 22,
		critical = 2,
		hits = 3,
		desc = "Fires three high-accuracy shots\ncausing Medium Damage \nto one enemy",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			local wepx = mo.x + 8*cos(mo.angle + ANGLE_45)
			local wepy = mo.y + 8*sin(mo.angle + ANGLE_45)
			local cx = mo.x + 128*cos(mo.angle + ANG1*202)
			local cy = mo.y + 128*sin(mo.angle + ANG1*202)
			local wepz = mo.z + FRACUNIT*40
			//Hello funny Slybrid here: This is my funky lil angle def for Elie's funny pewpew stick
			local cam = server.P_BattleStatus[mo.battlen].cam
			CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cam.x, cam.y, target.x, target.y))
			//CONSTANTLY be chasing the right angle!
			
			//MY MISCHIEF IS SCHEDULED:
			//Megido star, make some shocks, fire 2 shots looking with Thoks then the final one after a smaller pause - 5 5 15 in framedata (epic)
			local dist = (R_PointToDist2(mo.x,mo.y,target.x,target.y)/FRACUNIT)/2
			//Learning from Jolt's Supervolt, measure distance/FRACUNIT for special use.. mwehehe..
			
			
			if timer == 1
				//CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, FRACUNIT*40, 10*FRACUNIT) //Hm
				if mo.anim_special2 and #mo.anim_special2
				ANIM_set(mo, mo.anim_special2, true)
				end
				playSound(mo.battlen, sfx_elgry)
				mo.angle = R_PointToAngle2(mo.x,mo.y,target.x,target.y)
				//Looking at our victim!
			end//DO THE ANIM YOU DORK
			if timer == 10
				local s = P_SpawnMobj(wepx,wepy,wepz, MT_DUMMY)
				s.color = SKINCOLOR_WHITE
				s.state = S_MEGISTAR1
				s.scale = mo.scale
				playSound(mo.battlen, sfx_hamas1)
			end
			//PREPARE the star!
			if timer == 40
				local thok = P_SpawnMobj(wepx,wepy,wepz, MT_THOK)
				thok.tics = 20
				thok.destscale = 1
				thok.scalespeed = FRACUNIT/20
				thok.color = SKINCOLOR_GOLD
			end
			//Charge they bwarb
			if timer == 45
			or timer == 55 //HITT TTWICE!! WOW EPIC
				for i = 1, dist //Lmao imagine having a bad pc	
					local dx = wepx + (i*4)*cos(mo.angle)
					local dy = wepy + (i*4)*sin(mo.angle)
					local thok = P_SpawnMobj(dx,dy,wepz, MT_THOK)
					thok.scale = FRACUNIT/4
					thok.tics = 1
					thok.color = SKINCOLOR_YELLOW
					local g = P_SpawnGhostMobj(thok)
						g.fuse = 5
						g.color = thok.color
				end
				damageObject(target)
				for i = 1,15
					local p = P_SpawnMobj(target.x, target.y, mo.z + 40*FRACUNIT, MT_DUMMY)
					local rt = P_RandomRange(2,20)*FRACUNIT
					p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
					p.state = S_SSPK1
					p.scale = mo.scale
					p.colorized = true
					p.color = SKINCOLOR_GOLD
					p.angle = mo.angle + P_RandomRange(-30, 30)*ANG1
					p.momz = P_RandomRange(-12, 12)*mo.scale
					P_InstaThrust(p, p.angle, rt)
				end
				playSound(mo.battlen, sfx_elgun)
			end
			//Basically like a laser, I think it looks neat!
			if timer == 55
				local thok = P_SpawnMobj(wepx,wepy,FRACUNIT*10, MT_THOK)
				thok.tics = 15
				thok.scale = FRACUNIT*2
				thok.destscale = 1
				thok.scalespeed = (FRACUNIT*2)/15
				thok.color = SKINCOLOR_MINT
				playSound(mo.battlen, sfx_s3k9c)
			end
			//3rd SHOT'S orb charge - This one actually ends at the start of the shot
			if timer == 70
				for i = 1, dist 
					local dx = wepx + (i*4)*cos(mo.angle)
					local dy = wepy + (i*4)*sin(mo.angle)
					local thok = P_SpawnMobj(dx,dy,wepz, MT_THOK)
					thok.scale = FRACUNIT/2
					thok.color = SKINCOLOR_TEAL
					thok.tics = 2
					local g = P_SpawnGhostMobj(thok)
						g.fuse = 35
						g.color = thok.color
				end
				damageObject(target)
				for i = 1,30
					local p = P_SpawnMobj(target.x, target.y, mo.z + 40*FRACUNIT, MT_DUMMY)
					local rt = P_RandomRange(2,35)*FRACUNIT
					p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
					p.state = S_SSPK1
					p.scale = mo.scale
					p.colorized = true
					p.color = SKINCOLOR_EMERALD
					p.angle = mo.angle + P_RandomRange(-45, 45)*ANG1
					p.momz = P_RandomRange(-20, 20)*mo.scale
					P_InstaThrust(p, p.angle, rt)
				end
				playSound(mo.battlen, sfx_s3kc5l)
				playSound(mo.battlen, sfx_cdfm35)
				playSound(mo.battlen, sfx_cdfm35)
				//Final shot!! BAP!!!!! HAH!!!!
			end
			if timer == 105 //70 + TICRATE
				return true //Yaya
			end
		end,
}

attackDefs["saintly_force"] = {
		name = "Saintly Force",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 6,
		desc = "Orbal Art.\nRaises magic attack to 1 ally \nby 1 stage",
		target = TGT_ALLY,
		buff = true,
		nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
						local target = targets[n]
						if target.buffs["mag"][1] >= 75
							BTL_logMessage(targets[1].battlen, "Limit reached!")
							return true
						end
					end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]

			if timer == 20
				playSound(mo.battlen, sfx_buff)
				buffStat(target, "mag")
				for i = 1,16
					local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					dust.angle = ANGLE_90 + ANG1* (22*(i-1))
					dust.state = S_CDUST1
					P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
					dust.color = SKINCOLOR_WHITE
					dust.scale = FRACUNIT*2
				end

			elseif timer > 20 and timer <= 50

				if leveltime%2 == 0
					for i = 1,16

						local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
						thok.state = S_CDUST1
						thok.momz = P_RandomRange(3, 10)*FRACUNIT
						thok.color = SKINCOLOR_SILVER
						thok.tics = P_RandomRange(10, 35)
						thok.scale = FRACUNIT*3/2
					end
				end

				for i = 1, 8
					local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
					thok.sprite = SPR_SUMN
					thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
					thok.momz = P_RandomRange(6, 16)*FRACUNIT
					thok.color = SKINCOLOR_BONE
					thok.tics = P_RandomRange(10, 35)
				end
			elseif timer == 60
				return true
			end
		end,
}

attackDefs["fortuna"] = {
		name = "Fortuna",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 12,
		desc = "Orbal Art.\nRaises magic attack and defence\n to all allies by 1 stage",
		target = TGT_ALLALLIES,
		buff = true,
		anim = function(mo, targets, hittargets, timer)

			for i = 1, #targets do

				local target = targets[i]

				if timer == 20 + (i-1)*16
					playSound(mo.battlen, sfx_buff)
					buffStat(target, "mag")
					buffStat(target, "def")
					
					BTL_logMessage(targets[1].battlen, "Magic Attack and Defence up!")
					for i = 1,16
						local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						dust.angle = ANGLE_90 + ANG1* (22*(i-1))
						dust.state = S_CDUST1
						P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
						dust.color = SKINCOLOR_GOLD
						dust.scale = FRACUNIT*2
					end

				elseif timer > 20 + (i-1)*16 and timer <= 50 + (i-1)*16

					if leveltime%2 == 0
						for i = 1,16

							local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
							thok.state = S_CDUST1
							thok.momz = P_RandomRange(3, 10)*FRACUNIT
							thok.color = SKINCOLOR_YELLOW
							thok.tics = P_RandomRange(10, 35)
							thok.scale = FRACUNIT*3/2
						end
					end

					for i = 1, 8
						local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
						thok.sprite = SPR_SUMN
						thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
						thok.momz = P_RandomRange(6, 16)*FRACUNIT
						thok.color = SKINCOLOR_WHITE
						thok.tics = P_RandomRange(10, 35)
					end
				end
			end
			if timer == 60 + (#targets-1)*16
				return true
			end
		end,
}

attackDefs["antistep"] = {
		name = "Anti-Step",
		type = ATK_SUPPORT,
		power = 0,
		accuracy = 40,
		statuschance = 40,
		status = COND_SILENCE,
		costtype = CST_SP,
		luckbased = true,	-- use luck instead of agility
		cost = 12,
		desc = "Orbal Art.\nInflicts Silence on 1 enemy.",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
				local target = hittargets[1]

				if timer == 10
					playSound(mo.battlen, sfx_antisp)
				end

				if timer <= 35
                    local thok = P_SpawnMobj(target.x, target.y, target.z + target.height + 40*FRACUNIT, MT_DUMMY)
                    thok.state = S_ANTISTEPART1
                    thok.momz = -3*FRACUNIT 
                    thok.color = SKINCOLOR_RED
                    thok.tics = 35
                    thok.scale = 1
                    thok.destscale = target.scale*(2/2)
					thok.scalespeed = (target.scale*(2/2))/30
                end
				
                if timer <= 35
                    local shit = P_SpawnMobj(target.x, target.y, target.z + target.height + 40*FRACUNIT, MT_DUMMY)
                    shit.sprite = SPR_THOK
                    shit.momz = 0
                        shit.momy = 0
                        shit.momx = 0
                    shit.color = SKINCOLOR_ROSY
                    shit.tics = 2 
                    shit.scale = FRACUNIT*2
					shit.destscale = 1
                    shit.frame = A|FF_FULLBRIGHT
                end
				
				if timer == 35
                    local shits = P_SpawnMobj(target.x, target.y, target.z + target.height + 40*FRACUNIT, MT_DUMMY)
                    shits.sprite = SPR_THOK
                    shits.momz = 0
                        shits.momy = 0
                        shits.momx = 0
                    shits.color = SKINCOLOR_ROSY
                    shits.tics = 35
                    shits.scale = FRACUNIT*2
                        shits.destscale = 1
                        shits.scalespeed = (FRACUNIT*2)/35
                    shits.frame = A|FF_FULLBRIGHT
                end
				
				if timer == 50
					damageObject(target)
				elseif timer == 70
					return true
				end
		end,
}
//LUA is a bitch to make shit work
//You can hear Hajime and Zoruxua screaming in the background
attackDefs["antistepall"] = { 
		name = "Anti-Step All",
		type = ATK_SUPPORT,
		power = 0,
		accuracy = 40,
		statuschance = 40,
		status = COND_SILENCE,
		costtype = CST_SP,
		luckbased = true,	-- use luck instead of agility
		cost = 12,
		desc = "Orbal Art.\nInflicts Silence on all enemies.",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
				for i = 1, #hittargets
					local target = hittargets[i]

					local t = timer - (i-1)*6
					
				if timer == 10
					playSound(mo.battlen, sfx_antisp)
				end

				if timer <= 35
                    local thok = P_SpawnMobj(target.x, target.y, target.z + target.height + 40*FRACUNIT, MT_DUMMY)
                    thok.state = S_ANTISTEPART1
                    thok.momz = -3*FRACUNIT 
                    thok.color = SKINCOLOR_RED
                    thok.tics = 35
                    thok.scale = 1
                    thok.destscale = target.scale*(2/2)
					thok.scalespeed = (target.scale*(2/2))/30
                end
				
                if timer <= 35
                    local shit = P_SpawnMobj(target.x, target.y, target.z + target.height + 40*FRACUNIT, MT_DUMMY)
                    shit.sprite = SPR_THOK
                    shit.momz = 0
                        shit.momy = 0
                        shit.momx = 0
                    shit.color = SKINCOLOR_ROSY
                    shit.tics = 2 
                    shit.scale = FRACUNIT*2
					shit.destscale = 1
                    shit.frame = A|FF_FULLBRIGHT
                end
				
				if timer == 35
                    local shits = P_SpawnMobj(target.x, target.y, target.z + target.height + 40*FRACUNIT, MT_DUMMY)
                    shits.sprite = SPR_THOK
                    shits.momz = 0
                        shits.momy = 0
                        shits.momx = 0
                    shits.color = SKINCOLOR_ROSY
                    shits.tics = 35
                    shits.scale = FRACUNIT*2
                        shits.destscale = 1
                        shits.scalespeed = (FRACUNIT*2)/35
                    shits.frame = A|FF_FULLBRIGHT
                end
				
				if timer == 50
					damageObject(target)
				elseif timer == 70 + (#hittargets-1)*6
					return true
				end
			end	
		end,
}

attackDefs["judgement_bolt"] = {
		name = "Judgement Bolt",
		type = ATK_ELEC,
		power = 650,
		accuracy = 100,
		costtype = CST_SP,
		status = COND_SHOCK,
		statuschance = 10,
		cost = 32,
		desc = "Orbal Art.\nSevere Elec Damage to a enemy.\nMay Shock",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			
			if timer == 15
				playSound(mo.battlen, sfx_zio5)
			end	
			
			if timer >= 16
			and timer <= 20
				local s = P_SpawnMobj(target.x, target.y, target.z + target.height/2, MT_THOK)
				s.tics = -1
				s.sprite = SPR_LZI1
				s.frame = F|FF_FULLBRIGHT|FF_TRANS70
				s.scale = mo.scale/2
				s.destscale = mo.scale*16
				s.scalespeed = mo.scale/(12-((timer-16)*2))
				s.blendmode = AST_ADD
				s.fuse = 70 - timer
			end
			
			if timer >= 16
			and timer <= 70
			and leveltime%3 == 0
			
			
				local range = 60
				if timer >= 50
					range = 100
				end
			
				local s = P_SpawnMobj(target.x + P_RandomRange(-range, range)*mo.scale, target.y + P_RandomRange(-range, range)*mo.scale, target.z + P_RandomRange(0, 100)*mo.scale, MT_SUPERSPARK)
			end
			
			if timer == 50
			or timer == 70
				for i = 1, #server.playerlist[mo.battlen]
					if server.playerlist[mo.battlen][i]
						P_FlashPal(server.playerlist[mo.battlen][i], 1, 2)
					end	
				end
				localquake(mo.battlen, FRACUNIT*(timer == 50 and 16 or 32), 10)
			end
			
			if timer == 70
				playSound(mo.battlen, sfx_elthr)
				playSound(mo.battlen, sfx_tiexp)
				lightningblast(target, SKINCOLOR_EMERALD, FRACUNIT*3)
				damageObject(target)
				
				for i = 1, 10
					local range = 1024
					local z1 = P_SpawnMobj(target.x + P_RandomRange(-range, range)*mo.scale, target.y + P_RandomRange(-range, range)*mo.scale, target.z, MT_DUMMY)
					z1.state, z1.scale, z1.color = S_LZIO11, target.scale*9/4, SKINCOLOR_EMERALD
					z1.destscale = target.scale
					z1.tics = $ + P_RandomRange(-1, 12)
				end
			
			elseif timer == 120
				return true
			end	
			
		end,
}

attackDefs["ragna_vortex"] = {
		name = "Ragna Vortex",
		type = ATK_WIND,
		power = 650,
		accuracy = 95,
		costtype = CST_SP,
		cost = 24,
		desc = "Orbal Art.\nSevere Wind Damage to a enemy.",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)

				local target = hittargets[1]

				if timer == 1
					mo.blades = {}
					-- blades have an addtional vangle property.
					-- extravalue1 determines whether they spin forward or backwards

				elseif timer == 20

					-- spawn blades:

					local an = target.angle + ANG1*90
					playSound(mo.battlen, sfx_wind4)

					local b = P_SpawnMobj(target.x + 1024*cos(an), target.y + 1024*sin(an), target.z + 512*FRACUNIT, MT_DUMMY)
					b.vangle = ANG1*60
					b.state = S_INVISIBLE
					b.extravalue1 = 1
					b.extravalue2 = 16
					mo.blades[#mo.blades+1] = b
					b.momx = -(b.x - target.x)/b.extravalue2
					b.momy = -(b.y - target.y)/b.extravalue2
					b.momz = -(b.z - (target.z + 96*FRACUNIT))/b.extravalue2
					b.fuse = TICRATE*3

					b = P_SpawnMobj(target.x - 1024*cos(an), target.y - 1024*sin(an), target.z + 320*FRACUNIT, MT_DUMMY)
					b.vangle = -ANG1*30
					b.state = S_INVISIBLE
					b.extravalue1 = -1
					b.extravalue2 = 16
					mo.blades[#mo.blades+1] = b
					b.momx = -(b.x - target.x)/b.extravalue2
					b.momy = -(b.y - target.y)/b.extravalue2
					b.momz = -(b.z - (target.z + 96*FRACUNIT))/b.extravalue2
					b.fuse = TICRATE*3

				elseif timer == TICRATE*3 + 20
					damageObject(target)

				elseif timer == TICRATE*5
					return true
				end

				local i = #mo.blades
				while i
					local b = mo.blades[i]
					if not b or not b.valid
						table.remove(mo.blades, i)
						i = $-1
						continue
					end

					if R_PointToDist2(b.x, b.y, target.x, target.y) < 192*FRACUNIT
						b.momx = 0
						b.momy = 0
						b.momz = 0

						localquake(mo.battlen, FRACUNIT*10, 2)

						if leveltime%2 and i == 1

							for i=1,10
								local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
								b.momx = P_RandomRange(-35, 35)*FRACUNIT
								b.momy = P_RandomRange(-35, 35)*FRACUNIT
								b.momz = P_RandomRange(-35, 35)*FRACUNIT
								b.color = SKINCOLOR_GREEN
								b.frame = A|FF_FULLBRIGHT
								b.scale = FRACUNIT/2
								b.destscale = FRACUNIT/12
								b.tics = TICRATE/4
							end

							local s = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
							s.scale = FRACUNIT/4
							s.sprite = SPR_SLAS
							s.frame = I|TR_TRANS50 + P_RandomRange(0, 3)
							s.destscale = FRACUNIT*9
							s.scalespeed = FRACUNIT
							s.tics = TICRATE/3

						end
						if leveltime%8 == 0
							playSound(target.battlen, sfx_hit2)
							localquake(mo.battlen, FRACUNIT*32, 8)
						end
					end
					b.angle = $ + ANG1*24*b.extravalue1
					local addang = 360/6
						for j = 1, 6
							local sang = b.angle
							for k = 1, 4

								local sx = b.x + (k-1)*8*cos(sang + (j-1)*addang*ANG1)
								local sy = b.y + (k-1)*8*sin(sang + (j-1)*addang*ANG1)
								local sz = b.z + (k-1)*8*FixedMul(cos(sang + (j-1)*addang*ANG1), sin(b.vangle))

								local p = P_SpawnMobj(sx, sy, sz, MT_DUMMY)
								p.tics = TICRATE
								p.scale = FRACUNIT*3/4
								p.destscale = 1
								p.frame = FF_FULLBRIGHT
								p.color = j%2 and SKINCOLOR_MINT or SKINCOLOR_LIME

								p.angle = sang + (j-1)*addang*ANG1
								P_InstaThrust(p, p.angle, 32*FRACUNIT)
								p.momz = 32*FixedMul(cos(p.angle), sin(b.vangle))

								sang = $-(ANG1*6)

							end
						end
					i = $-1
				end

		end,
}