if not srb2p return end

DNG_Abilities["tita"] = {

	jfunc = 	function(p)
					local mo = p.mo

					p.drawangle = mo.angle
					P_SetObjectMomZ(mo, FRACUNIT*10)
					local t = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
					t.color = mo.color
					P_InstaThrust(mo,mo.angle,(32*FRACUNIT)/*(mo.scale)*/)
					S_StartSound(p.mo,sfx_spdpad)
				end,

		func =		function(p)
					local mo = p.mo

					if mo.p_abl
						if not P_IsObjectOnGround(mo)
							if (leveltime%3)
								local g = P_SpawnGhostMobj(mo)
								g.tics = 4
								g.colorized = true
							end
						else
							mo.p_abl = false
						end
					end
				end,
}

freeslot("SPR_BATI", "SPR_BOOM", "SPR_TCHR", "SPR_TFIR", "SPR_TDEF", "SPR_TRIP", "SPR_SATB", "SPR_SATE", "SPR_TSAB", "sfx_tisho", "sfx_tiexp", "sfx_tiok", "sfx_smocn", "sfx_darmat")

charStats["tita"] = {

		-- GENERAL

		name = "Tita",			-- This is only for bots / enemies
		basehp = 48,			-- base HP for level 1
		basesp = 59,
		persona = "titaskillset",
		melee_natk = "explosion",	-- normal melee attack
		melee_satk = "satbeam",

		supercolor_start = SKINCOLOR_SUPERTITA1,
		
		wep = "p-03",		-- default weapon.
		weptype = WPT_GENERICRANGED,	-- Equippable weapon type(s)

		atk = 46,
		acc = 85,
		crit = 1,

		-- ANIMS
		-- Anims are built like this:
		-- {SPR_SPRITE, frame1, frame2, frame3, ... , duration between each frame}

		anim_stand = 		{SPR_BATI, A, 8, "SPR2_BATI"},					-- standing
		anim_stand_hurt =	{SPR_BATI, A, 1, "SPR2_BATI"},					-- standing (low HP) *
		anim_stand_bored =	{SPR_BATI, A, 8, "SPR2_BATI"},					-- standing (occasionally plays after anim_stand has played several times)
		anim_guard = 		{SPR_TDEF, A, 1, "SPR2_TDEF"},					-- guarding
		anim_move =			{SPR_PLAY, A, B, C, D, 2, "SPR2_WALK"},	-- moving
		anim_run =			{SPR_PLAY, A, B, C, D, E, 2, "SPR2_RUN_"},	-- guess what
		anim_atk =			{SPR_PLAY, A, 2, "SPR2_ROLL"},			-- attacking
		anim_aoa_end =		{SPR_PLAY, A, 2, "SPR2_ROLL"},			-- jumping out of all-out attack
		anim_hurt =			{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- taking damage
		anim_getdown =		{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- knocked down from weakness / crit *
		anim_downloop =		{SPR_TRIP, A, 1, "SPR2_TRIP"},					-- is down
		anim_getup =		{SPR_BATI, A, 1, "SPR2_BATI"},			-- gets up from down
		anim_death =		{SPR_PLAY, A, 30, "SPR2_DEAD"},					-- dies
		anim_revive =		{SPR_PLAY, A, 2, "SPR2_ROLL"},			-- gets revived
		anim_evoker =		{SPR_TCHR, A, 8, "SPR2_TCHR"},
		anim_evoker_shoot = {SPR_TFIR, A, 8, "SPR2_TFIR"},
		anim_special1 =		{SPR_TSAB, A,B,C,D,E,F,G,H,I,J,K,L,M,N,O,P,Q,R,S,S,S,T,U,V,W,W,W, 4, "SPR2_TSAB"}, //108 Frames, a note for da stoopid Zoraxua
		
		vfx_summon = {"sfx_tismn1", "sfx_tismn2", "sfx_tismn3", "sfx_tismn4"},
		vfx_skill = {"sfx_tiskl1", "sfx_tiskl2", "sfx_tiskl3", "sfx_tiskl4"},
		vfx_item = {"sfx_tidog1"}, 
		vfx_hurt = {"sfx_tihrt1", "sfx_tihrt2", "sfx_tihrt3", "sfx_tihrt4"},
		vfx_hurtx = {"sfx_tixht"},
		vfx_die = {"sfx_tirip1", "sfx_tirip2"},
		vfx_heal = {"sfx_tihel1", "sfx_tihel2"},
		vfx_healself = {"sfx_tihel2"},
		vfx_kill = {"sfx_tikil1", "sfx_tikil2"},
		vfx_1more = {"sfx_ti1mo", "sfx_ti1mo2"},
		vfx_crit = {"sfx_ticrt1", "sfx_ticrt2", "sfx_ticrt3", "sfx_ticrt4"},
		vfx_aoaask = {"sfx_tiaoi1", "sfx_tiaoi2"},
		vfx_aoado = {"sfx_tiaoa1", "sfx_tiaoa2", "sfx_tiaoa3", "sfx_tiaoa4"},
		vfx_aoarelent = {"sfx_timis1", "sfx_timis2"},
		vfx_miss = {"sfx_timis1", "sfx_timis2", "sfx_timis3"},
		vfx_dodge = {"sfx_tidog1", "sfx_tidog2"},
		vfx_win = {"sfx_tiwin1", "sfx_tiwin2", "sfx_tiwin3", "sfx_tiwin4"},
		vfx_levelup = {"sfx_tilevl"},
		vfx_tartarus_pit = {"sfx_tirip2"},
		vfx_tartarus_item = {"sfx_tiitem"},
		vfx_tartarus_spring = {"sfx_tispng"},
		vfx_tartarus_spike = {"sfx_tihrt1", "sfx_tihrt2", "sfx_tihrt3", "sfx_tihrt4"},
		vfx_tartarus_critspike = {"sfx_tixht"},
		vfx_tartarus_spikepit = {"sfx_tixht"},

		icon = "H_TITICO",	-- icon for net select and other menus
		hudbust = "H_TITBAR",			-- patch to draw on the stat hud
		hudaoa = "H_TITAOA",	-- patch for all out attack hud
		hudcutin = "TITA_A",	-- cut in
		aoa_quote = "P-Prepare to meet\nyour doom!",

		tip = "A young engineer with powerful Nuke orbal arts with her ARCUS Orbment. Most of the nuke skills can cause debuffs or status but keep in mind of her SP though, it can drop really fast, same thing with her HP also."
}
	
VFX_freeslotC("tita")
	
personaList["titaskillset"] = {
		-- GENERAL
		name = "Tita",
		arcana = nil,

		-- STATS (@ lv10)

		sprite = SPR_NULL,
		anim_idle = {SPR_NULL, A, 8},
		anim_atk = {SPR_NULL, A, 8},
		startframe = 0,

		strength = 8,
		magic = 9,
		endurance = 7,
		luck = 4,
		agility = 6,
		weak = ATK_ICE,
		resist = ATK_NUCLEAR,
		skills = {
							{bionis and "scrap_bolt" or "photon shoot I", 1}, {"clock_up", 5},
							{"smokecannon", 11},
							{bionis and "scrap_wave" or "golden sphere", 14}, {bionis and "metal break" or "nuke break", 16},
							{bionis and "metal_blast" or "photon shoot II", 20, bionis and "scrap_bolt" or "photon shoot I"},
							{"a_reflex", 26}, {bionis and "metal boost" or "nuke boost", 30},
							{bionis and "junk_blast" or "dark matter", 34, bionis and "scrap_wave" or "golden sphere"}, 
							{"chrono_drive", 38, "clock_up"},
							{"smokecannon2", 39, "smokecannon"}, {"vital cannon I", 44},
							{bionis and "blast_force" or "altair cannon", 50, bionis and "metal_blast" or "photon shoot II"}, 
							{bionis and "metal amp" or "nuke amp", 54, bionis and "metal boost" or "nuke boost"}, 
							{"crescent mirror", 59, "a_reflex"},
							{bionis and "orbal_parts" or "zeruel_cannon", 64, bionis and "junk_blast" or "dark matter"}, 
							{"vital cannon II", 67, "vital cannon I"},
							{"seventh caliber", 72, bionis and "blast_force" or "altair cannon"},
		
					//Old Table (Was really broken)
					/*{bionis and "scrap_bolt" or "photon shoot I", 1},
					{"smokecannon", 3},
					{bionis and "metal_blast" or "photon shoot II", 7, bionis and "scrap_bolt" or "photon shoot I"},
					{bionis and "blast_force" or "photon shoot III", 12, bionis and "metal_blast" or "photon shoot II"}, 
					{bionis and "scrap_wave" or "golden spheres", 15},
					{"smokecannon2", 20, "smokecannon"},
					{bionis and "metal break" or "nuke break", 23},
					{bionis and "metal boost" or "nuke boost", 29},
					{"a_reflex", 32},
					{bionis and "junk_blast" or "altair cannon", 35, bionis and "scrap_wave" or "golden spheres"},
					{bionis and "metal amp" or "nuke amp", 40, bionis and "metal boost" or "nuke boost"}, 
					{bionis and "orbal_parts" or "dark matter", 45, bionis and "junk_blast" or "altair cannon"},
					{"vital cannon I", 53}, {"crescent mirror", 59, "a_reflex"},
					{"seventh caliber", 64}, {"vital cannon II", 67, "vital cannon I"},
					{bionis and "dodge ice" or "nuke augment", 73, bionis and "metal amp" or "nuke amp"}*/
				},
}

attackDefs["satbeam"] = {
		name = "Satellite Beam",
		type = ATK_ALMIGHTY,
		power = 4500,
		accuracy = 999,
		costtype = CST_SP,
		cost = 450,
		hits = 2,
		nometronome = true,
		norandom = true,
		critical = 15,
		desc = "Tita's S-Craft\nActivates a satellite to destroy enemies.\nRandom Target",
		target = TGT_ALLENEMIES,
		norepel = true,
		anim_norepel = true,
		anim = function(mo, targets, hittargets, timer)
		local cam = server.P_BattleStatus[mo.battlen].cam
		local stgt = hittargets[1]
			if timer == 1 //Everyone's favouite illiterate nuisance Zoraxua making messes again, time to comment
				//playSound(mo.battlen, sfx_) sound goeS here if you want lol
				playSound(mo.battlen, sfx_tiaoa2) //Placeholder for now
				cam.momx = 0
				cam.momy = 0
				cam.momz = 0 //Makse sure camera sits still
			elseif timer == 2
			local cx = mo.x + 192*cos(mo.angle)
			local cy = mo.y + 192*sin(mo.angle)
			P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*16)
			server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y) //Hello camera, look at me
			ANIM_set(mo, mo.anim_special1, true) //Takes 108 frames
			playSound(mo.battlen, sfx_cutlyd)
				local thok = P_SpawnMobj(mo.x, mo.y, mo.z + FRACUNIT*1920, MT_DUMMY)	
				thok.frame = A|FF_FULLBRIGHT
				thok.tics = 99999
				thok.sprite = SPR_SATE
				thok.scale = FRACUNIT*2
				mo.satellite = thok //Lets set this puppy up, stay strong Mr Satellite!
			end
			if timer >= 2
			and timer < 58 //end at 56'th for sfx
				for i = 1,3
					local thok = P_SpawnMobj(mo.x + P_RandomRange(-40, 40)*FRACUNIT, mo.y + P_RandomRange(-40, 40)*FRACUNIT, mo.z, MT_DUMMY)
					thok.flags = MF_NOBLOCKMAP
					thok.color = SKINCOLOR_EMERALD
					if timer%2 then thok.color = SKINCOLOR_JET end
					thok.frame = A
					thok.tics = 10 //Hackerlass
					thok.scale = FRACUNIT/4
					thok.scalespeed = (FRACUNIT/4)/9
					thok.destscale = 1
					thok.momz = P_RandomRange(8, 12)*FRACUNIT
					thok.momx = P_RandomRange(-10, 10)*FRACUNIT
					thok.momy = P_RandomRange(-10, 10)*FRACUNIT
				end
			elseif timer >= 58
			and timer < 70  //Make a signal effect or something
				local sigcol = {SKINCOLOR_EMERALD, SKINCOLOR_JET}
				local ol = P_SpawnMobj(mo.x, mo.y, mo.z + 16*FRACUNIT, MT_DUMMY)
				ol.sprite = SPR_NTHK
				ol.color = sigcol[P_RandomRange(1, #sigcol)]
				ol.scale = 1
				ol.destscale = FRACUNIT*32
				ol.scalespeed = FRACUNIT/5
				ol.frame = B|FF_FULLBRIGHT
				ol.tics = 20

				ol = P_SpawnMobj(mo.x, mo.y, mo.z + 16*FRACUNIT, MT_DUMMY)
				ol.sprite = SPR_NTHK
				ol.color = sigcol[P_RandomRange(1, #sigcol)]
				ol.scale = 1
				ol.destscale = FRACUNIT*32
				ol.scalespeed = FRACUNIT
				ol.frame = B|FF_FULLBRIGHT|TR_TRANS50
				ol.tics = 8
				if timer == 58
					playSound(mo.battlen, sfx_3db06) //SFX go here lol
				end
			elseif timer == 110
				ANIM_set(mo, mo.anim_stand, true) //So go back to not using 0 angle sprites
				playSound(mo.battlen, sfx_tiok)
				local cx = mo.x + 384*cos(mo.angle) //And launch this camera up
				local cy = mo.y + 384*sin(mo.angle)
				P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*1952)//YEET
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y) //Don't lose focus, starcam
				playSound(mo.battlen, sfx_s3kbds)
			//Alright... Time to do something, painful but I don't wanna make an animated state
			//Satellite goes to Z..
			end
			if timer >= 111
			and timer <= 160 //I fucked up the mo.satellite so I'm using this lil hack
				local satellite = mo.satellite //Zoraxua has 2 IQ (verified science fact)
					local thok = P_SpawnMobj(satellite.x + P_RandomRange(-40, 40)*FRACUNIT, satellite.y + P_RandomRange(-40, 40)*FRACUNIT, satellite.z + P_RandomRange(8, 40)*FRACUNIT, MT_DUMMY)
					thok.flags = MF_NOBLOCKMAP
					thok.color = SKINCOLOR_EMERALD
					if timer%2 then thok.color = SKINCOLOR_JET end
					thok.frame = A
					thok.tics = 5 //Hackerlass
					thok.scale = FRACUNIT/2
					thok.scalespeed = (FRACUNIT/2)/4
					thok.destscale = 1
					thok.momz = P_RandomRange(-10, 10)*FRACUNIT
					thok.momx = P_RandomRange(-10, 10)*FRACUNIT
					thok.momy = P_RandomRange(-10, 10)*FRACUNIT
					if not (leveltime%(P_RandomRange(4,10)))
						playSound(mo.battlen, sfx_s3k89)
					end
				if timer == 112
					satellite.frame = B|FF_FULLBRIGHT //Yep...
				elseif timer == 114
					satellite.frame = C|FF_FULLBRIGHT
				elseif timer == 116
					satellite.frame = D|FF_FULLBRIGHT
				elseif timer == 118
					satellite.frame = E|FF_FULLBRIGHT
				elseif timer == 120
					satellite.frame = F|FF_FULLBRIGHT
				elseif timer == 122
					satellite.frame = G|FF_FULLBRIGHT
				elseif timer == 124
					satellite.frame = H|FF_FULLBRIGHT
				elseif timer == 126
					satellite.frame = I|FF_FULLBRIGHT
					
					local ol = P_SpawnMobj(mo.x, mo.y, satellite.z + 32*FRACUNIT, MT_DUMMY)
					ol.sprite = SPR_NTHK
					ol.color = SKINCOLOR_EMERALD
					ol.scale = 1
					ol.destscale = FRACUNIT*32
					ol.scalespeed = FRACUNIT/5
					ol.frame = B|FF_FULLBRIGHT
					ol.tics = 20
					//Ping, im been hakk
					playSound(mo.battlen, sfx_s3k86)
					ol = P_SpawnMobj(mo.x, mo.y, satellite.z + 32*FRACUNIT, MT_DUMMY)
					ol.sprite = SPR_NTHK
					ol.color = SKINCOLOR_JET
					ol.scale = 1
					ol.destscale = FRACUNIT*32
					ol.scalespeed = FRACUNIT
					ol.frame = B|FF_FULLBRIGHT|TR_TRANS50
					ol.tics = 8
					
				elseif timer == 128
					satellite.frame = J|FF_FULLBRIGHT
				elseif timer == 130
					satellite.frame = K|FF_FULLBRIGHT //I am SO sorry to anyone reading this, please don't do this stupid example of mine
				elseif timer == 132
					satellite.frame = L|FF_FULLBRIGHT
				elseif timer == 134
					satellite.frame = M|FF_FULLBRIGHT
				elseif timer == 136
					satellite.frame = N|FF_FULLBRIGHT
				elseif timer == 138
					satellite.frame = O|FF_FULLBRIGHT
				elseif timer == 140
					satellite.frame = P|FF_FULLBRIGHT
				elseif timer == 142
					satellite.frame = Q|FF_FULLBRIGHT
				elseif timer == 144
					satellite.frame = R|FF_FULLBRIGHT
				elseif timer == 146
					satellite.frame = S|FF_FULLBRIGHT
				elseif timer == 148
					satellite.frame = T|FF_FULLBRIGHT
				elseif timer == 150
					satellite.frame = U|FF_FULLBRIGHT
				elseif timer == 152
					satellite.frame = V|FF_FULLBRIGHT
				elseif timer == 154 //,,,I couldve used a  for i = 1,26 and done iftimer = i or something 
					satellite.frame = W|FF_FULLBRIGHT
				elseif timer == 156
					satellite.frame = X|FF_FULLBRIGHT
				elseif timer == 158 //No that wouldnt work anyways??? Right??? lol
					satellite.frame = Y|FF_FULLBRIGHT
				elseif timer == 160
					satellite.frame = Z|FF_FULLBRIGHT //wATCH me not get the DAMN ALPHABET correct
				end
			end// HOW DID I FORGET THIS END- yeah 2 IQ
			if timer >= 161
			and timer < 195 //fine dont work, i'll do this instead
				if not (leveltime%(P_RandomRange(3,10)))
					playSound(mo.battlen, sfx_s3k89)
				end
				if timer == 161
					playSound(mo.battlen, sfx_s3k84)
				end
				local satellite = mo.satellite
				local satx = mo.x + 48*cos(mo.angle +ANGLE_270) 
				local saty = mo.y + 48*sin(mo.angle +ANGLE_270)
				local cthok = P_SpawnMobj(satx, saty, satellite.z - 32*FRACUNIT, MT_DUMMY)
				cthok.flags = MF_NOBLOCKMAP
				cthok.color = SKINCOLOR_CYAN //Charge vfx which is actually to verify target
				cthok.frame = A
				cthok.tics = 2
				if timer < 170
				cthok.scale = FRACUNIT/4
				elseif timer < 180
				cthok.scale = FRACUNIT/2
				elseif timer < 190
				cthok.scale = FRACUNIT
				else
				cthok.scale = FRACUNIT*2
//				cthok.destscale = 3*FRACUNIT //Make beeger
//				cthok.scalespeed = (FRACUNIT*3)/20
				end
			end//I can't fire properly so... Lets just uh pretend we did LMAO
			if timer == 195
				local cx = stgt.x + 256*cos(stgt.angle)
				local cy = stgt.y + 256*sin(stgt.angle)
				P_TeleportMove(cam, cx, cy, stgt.z + FRACUNIT*16)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, stgt.x, stgt.y) //They're fucked lol
				mo.satellite.tics = 5
				mo.satellite = nil //Don't need this anymore
			end
			if timer >= 195
			and timer < 230
				if timer == 195
					playSound(mo.battlen, sfx_s3ka1)
				end
				for i = 1, 5
					local thoka = P_SpawnMobj(stgt.x + P_RandomRange(-256, 256)*FRACUNIT, stgt.y + P_RandomRange(-256, 256)*FRACUNIT, stgt.z, MT_DUMMY)
					thoka.flags = MF_NOBLOCKMAP
					thoka.color = SKINCOLOR_CYAN
					if timer%2 then thoka.color = SKINCOLOR_ICY end
					thoka.frame = A
					thoka.tics = 10 //Hackerlass
					thoka.scale = FRACUNIT/2
					thoka.scalespeed = (FRACUNIT/2)/9
					thoka.destscale = 1
					thoka.momz = P_RandomRange(12, 64)*FRACUNIT
				end
				localquake(mo.battlen, FRACUNIT*12, 2)
				if timer == 210
					local cx = stgt.x + 768*cos(stgt.angle)
					local cy = stgt.y + 768*sin(stgt.angle)
					CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, stgt.z + FRACUNIT*64, 50*FRACUNIT)
					server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, stgt.x, stgt.y) //They're fucked lol
				end
			elseif timer >= 230
			and timer < 300 
				if not (leveltime%10)
					playSound(mo.battlen, sfx_s3kc4s)
					playSound(mo.battlen, sfx_s3kc4s)
				end
				if timer == 230
					playSound(mo.battlen, sfx_s3kd0s)
					for k,v in ipairs(mo.allies)
						if v and v.control and v.control.valid
							P_FlashPal(v.control, 4, 5)
						end
					end
				end
				if timer == 298
					for k,v in ipairs(mo.allies)
						if v and v.control and v.control.valid
							P_FlashPal(v.control, 5, 2)
						end
					end
				end
				if timer == 265
					if stgt.boss
						damageObject(stgt)
					else
						damageObject(stgt, stgt.hp)
					end
				end
				localquake(mo.battlen, FRACUNIT*64, 10)
				local beam = P_SpawnMobj(stgt.x, stgt.y, stgt.z + FRACUNIT*640, MT_DUMMY)
				beam.flags = MF_NOBLOCKMAP
				beam.sprite = SPR_SATB
				beam.frame = A|FF_FULLBRIGHT
				beam.tics = 20 //Hackerlass
				beam.scale = 5*stgt.scale
				beam.momz = -48*FRACUNIT
			end
			
				local j = mo.columns and #mo.columns or 0
				while j
					local m = mo.columns[j]
					if not m or not m.valid
						j = $-1
						continue
					end

					for i = 1, 5
						local boom = P_SpawnMobj(m.x + P_RandomRange(-48, 48)*FRACUNIT, m.y + P_RandomRange(-48, 48)*FRACUNIT, m.z, MT_DUMMY)
						boom.state = S_QUICKBOOM1
						boom.colorized = true
						boom.color = SKINCOLOR_CYAN
						boom.momz = P_RandomRange(0, 48)*FRACUNIT
						boom.scale = FRACUNIT*3
					end
					P_StartQuake(FRACUNIT*8, 1)
					j = $-1
				end
				
			if timer == 300
				for k,v in ipairs(mo.allies)
					if v and v.control and v.control.valid
						P_FlashPal(v.control, 1, 10)
					end
				end
				for i = 1,#hittargets
					local target = hittargets[i]
					damageObject(target)
				end
				mo.fangle = (R_PointToAngle(stgt.x, stgt.y)) + ANG1*180
				mo.columns = {}
				playSound(mo.battlen, sfx_megi5)
				playSound(mo.battlen, sfx_s3k9f)

				local a = mo.fangle - ANG1*80

				for i = 1, 16
					local m = P_SpawnMobj(stgt.x, stgt.y, stgt.z, MT_DUMMY)
					P_InstaThrust(m, a, FRACUNIT*48)
					mo.columns[#mo.columns+1] = m
					m.state = S_INVISIBLE
					m.tics = TICRATE
					a = $+ ANG1*10
				end
			end
			if timer == 330
				return true
			end
		end,
}

attackDefs["explosion"] = {
		name = "Cannon Shot",
		type = ATK_STRIKE,
		power = 60,
		accuracy = 85,
		costtype = CST_HPPERCENT,
		cost = 0,
		desc = "Cause an explosion around\nyour general vicinity.",
		physical = true,
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
            for i = 1, #hittargets
                local target = hittargets[i]
                if timer == 10
                or timer == 14
					if mo.anim_atk and #mo.anim_atk
					ANIM_set(mo, mo.anim_atk, true)
					end
                    local boom = P_SpawnMobj(target.x+P_RandomRange(-20, 20)*FRACUNIT, target.y+P_RandomRange(-20, 20)*FRACUNIT, target.z+P_RandomRange(-20, 20)*FRACUNIT, MT_BOSSEXPLODE)
                    boom.scale = FRACUNIT*3
                    boom.state = S_QUICKBOOM1
                elseif timer == 30
                    local boom = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_BOSSEXPLODE)
                    boom.scale = FRACUNIT*4
                    boom.state = S_PFIRE1
                    damageObject(target)


                    for i = 1, 8
                        local smoke = P_SpawnMobj(boom.x, boom.y, boom.z, MT_SMOKE)
                        smoke.scale = FRACUNIT*6
                        smoke.momx = P_RandomRange(-5, 5)*FRACUNIT
                        smoke.momy = P_RandomRange(-5, 5)*FRACUNIT
                        smoke.momz = P_RandomRange(3, 6)*FRACUNIT
                    end

                    local sm = P_SpawnMobj(target.x, target.y, target.z, MT_SMOLDERING)
                    sm.fuse = TICRATE/2
                    sm.scale = target.scale*3/2

                elseif timer == 70
                    return true
                end
            end
            if timer == 10
            or timer == 14
                playSound(mo.battlen, sfx_tisho)
            elseif timer == 30
                playSound(mo.battlen, sfx_tiexp)
                localquake(mo.battlen, FRACUNIT*32, 8)
            end
        end,	
}


attackDefs["photon shoot I"] = {
		name = "Photon Shoot I",
		type = ATK_NUCLEAR,
		costtype = CST_SP,
		cost = 4,
		technical = COND_BURN|COND_FREEZE|COND_SHOCK,
		power = 70,
		accuracy = 95,
		desc = "Orbal Art.\nLight Nuke damage to one enemy.",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]

			if timer == 20
				playSound(mo.battlen, sfx_debuff)
				local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
				orb.sprite = SPR_DBUF
				orb.frame = A|TR_TRANS30
				orb.scale = FRACUNIT*2
				orb.scalespeed = FRACUNIT/32
				orb.destscale = FRACUNIT/6
				orb.tics = 2*TICRATE-15
				orb.color = SKINCOLOR_GOLD

			elseif timer == 5+2*TICRATE
				damageObject(target)
				playSound(mo.battlen, sfx_fire2)
				local dbuff = P_SpawnMobj(target.x, target.y, target.z+target.height, MT_DUMMY)
				dbuff.state = S_DBUFF1
				dbuff.color = SKINCOLOR_GOLD
				dbuff.scale = FRACUNIT*5/2

			elseif timer == TICRATE*3
				return true
			end
		end,
}

attackDefs["photon shoot II"] = {
		name = "Photon Shoot II",
		type = ATK_NUCLEAR,
		power = 140,
		accuracy = 95,
		costtype = CST_SP,
		cost = 8,
		technical = COND_BURN|COND_FREEZE|COND_SHOCK,
		desc = "Orbal Art.\nMedium Nuke damage to one enemy.",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]

			if timer == 20
				playSound(mo.battlen, sfx_debuff)
				--local x, y = target.x + 20*cos(target.angle), target.y + 20*sin(target.angle)
				local x,y = target.x + P_RandomRange(-128, 128)<<FRACBITS, target.y + P_RandomRange(-128, 128)<<FRACBITS
				target.frei = P_SpawnMobj(x, y, target.z+FRACUNIT*256, MT_DUMMY)
				target.frei.state = S_PLAY_STND
				target.frei.dispoffset = 5
				target.frei.tics = -1
				target.frei.fuse = 60
				target.frei.sprite = SPR_FREI
				target.frei.frame = G|TR_TRANS20|FF_FULLBRIGHT
				target.frei.scale = FRACUNIT/20
				target.frei.color = SKINCOLOR_GOLD
				target.frei.target = target
				target.frei.flags = MF_NOGRAVITY

			elseif timer > 20 and timer <= 50
				target.frei.scale = min(2*FRACUNIT, $+ FRACUNIT/12)
				local f = target.frei

				f.momx = (target.x-f.x)/20
				f.momy = (target.y-f.y)/20
				f.momz = (target.z-f.z)/20

				--A_HomingChase(target.frei, 6*FRACUNIT)

					-- spawn cool explosions on the way down
				local boom = P_SpawnMobj(target.frei.x + P_RandomRange(-20, 20)*FRACUNIT, target.frei.y + P_RandomRange(-20, 20)*FRACUNIT, target.frei.z + 10*FRACUNIT, MT_DUMMY)
				boom.state = S_CQUICKBOOM1
				boom.color = SKINCOLOR_WHITE
				boom.momx = P_RandomRange(-8, 8)*FRACUNIT
				boom.momy = P_RandomRange(-8, 8)*FRACUNIT
				boom.momz = P_RandomRange(-8, 8)*FRACUNIT
				boom.scale = FRACUNIT

				P_SpawnMobj(target.frei.x + P_RandomRange(-20, 20)*FRACUNIT, target.frei.y + P_RandomRange(-20, 20)*FRACUNIT, target.frei.z + 10*FRACUNIT, MT_SMOKE)
				boom.momx = P_RandomRange(-8, 8)*FRACUNIT
				boom.momy = P_RandomRange(-8, 8)*FRACUNIT
				boom.momz = P_RandomRange(-8, 8)*FRACUNIT
				boom.scale = FRACUNIT

				if timer%2
					target.frei.flags2 = $|MF2_DONTDRAW
				else
					target.frei.flags2 = $ & ~ MF2_DONTDRAW
				end



			elseif timer == 51
			or timer == 61
			or timer == 71
				target.frei.flags2 = $|MF2_DONTDRAW
				if timer == 71
					damageObject(target)
					target.frei.fuse = 1
					target.frei = nil
					local sm = P_SpawnMobj(target.x, target.y, target.z, MT_SMOLDERING)
					sm.fuse = TICRATE*2
					sm.scale = FRACUNIT*3/2
				end

				local bx = target.x + P_RandomRange(-192, 192)*FRACUNIT
				local by = target.y + P_RandomRange(-129, 192)*FRACUNIT
				local bz = target.z + P_RandomRange(0, 256)*FRACUNIT

				for i = 1, 32
					local boom = P_SpawnMobj(bx + P_RandomRange(-20, 20)*FRACUNIT, by + P_RandomRange(-20, 20)*FRACUNIT, bz + 10*FRACUNIT, MT_DUMMY)
					boom.state = S_CQUICKBOOM1
					boom.color = SKINCOLOR_GOLD
					boom.momx = P_RandomRange(-20, 20)*FRACUNIT
					boom.momy = P_RandomRange(-20, 20)*FRACUNIT
					boom.momz = P_RandomRange(-20, 20)*FRACUNIT
					boom.scale = FRACUNIT*3/2
				end

				local sm = P_SpawnMobj(bx, by, bz, MT_SMOLDERING)
				sm.fuse = TICRATE

				playSound(mo.battlen, sfx_megi6)
				localquake(mo.battlen, FRACUNIT*24, 10)

			elseif timer == 110
				return true
			end
		end,
}

attackDefs["golden sphere"] = {
		name = "Golden Sphere",
		type = ATK_NUCLEAR,
		power = 60,
		accuracy = 90,
		costtype = CST_SP,
		cost = 8,
		technical = COND_BURN|COND_FREEZE|COND_SHOCK,
		desc = "Orbal Art. Light Nuke damage to all enemies.",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)

			for k,v in ipairs(hittargets)
				local target = v
				local time = timer - (k-1)*6

				if time == 20
					playSound(mo.battlen, sfx_debuff)
					--local x, y = target.x + 20*cos(target.angle), target.y + 20*sin(target.angle)
					local x,y = target.x, target.y
					local frei = P_SpawnMobj(x, y, target.z+FRACUNIT*10, MT_DUMMY)
					frei.state = S_PLAY_STND
					frei.dispoffset = 5
					frei.tics = -1
					frei.fuse = 60
					frei.sprite = SPR_FREI
					frei.frame = G|TR_TRANS20|FF_FULLBRIGHT
					frei.scale = FRACUNIT/20
					frei.color = SKINCOLOR_GOLD
					v.frei = frei

				elseif time > 20 and time <= 50
					v.frei.scale = min(2*FRACUNIT, $+ FRACUNIT/12)
					if time%2
						v.frei.flags2 = $|MF2_DONTDRAW
					else
						v.frei.flags2 = $ & ~ MF2_DONTDRAW
					end
					if not (time%4)
						local x, y = target.x + 20*cos(target.angle), target.y + 20*sin(target.angle)
						x, y = target.x, target.y
						local frei = P_SpawnMobj(x, y, target.z+FRACUNIT*10, MT_DUMMY)
						frei.dispoffset = 5
						frei.state = S_FREI1
						frei.scale = FRACUNIT*5/2
						if not (timer%8) then frei.state = S_FREI4 end
					end
				elseif time == 51

					local sm = P_SpawnMobj(target.x, target.y, target.z, MT_SMOLDERING)
					sm.fuse = TICRATE*2
					sm.scale = FRACUNIT*3/2

					damageObject(target)
					v.frei.fuse = 1
					for i = 1, 16
						local boom = P_SpawnMobj(target.x + P_RandomRange(-20, 20)*FRACUNIT, target.y + P_RandomRange(-20, 20)*FRACUNIT, target.z + 10*FRACUNIT, MT_DUMMY)
						boom.state = S_CQUICKBOOM1
						boom.color = SKINCOLOR_FLAME
						boom.momx = P_RandomRange(-20, 20)*FRACUNIT
						boom.momy = P_RandomRange(-20, 20)*FRACUNIT
						boom.momz = P_RandomRange(-20, 20)*FRACUNIT
						boom.scale = FRACUNIT*3/2
					end
					playSound(mo.battlen, sfx_megi6)
					localquake(mo.battlen, FRACUNIT*16, 10)
					v.frei = nil
				end
			end

			if timer == 90 + (#hittargets-1)*6
				return true
			end
		end,
}

attackDefs["a_reflex"] = {
		name = "A-Reflex",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 16,
		target = TGT_ALLY,
		superbuff = true,
		desc = "Orbal Art. Give a\nbarrier that repels magic\nattacks to one ally.",
		anim = 	function(mo, targets, hittargets, timer)
					local target = hittargets[1]
					if timer >= 10 and timer <= 40
						if leveltime%2 == 0
							local s = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
							s.sprite = SPR_ARMA
							s.tics = 1
						end
					elseif timer == 41
						local thok = P_SpawnMobj(target.x, target.y, target.z+5*FRACUNIT, MT_DUMMY)
						thok.state = S_INVISIBLE
						thok.tics = 1
						A_OldRingExplode(thok, MT_SUPERSPARK)
						playSound(mo.battlen, sfx_mirror)

						BTL_logMessage(targets[1].battlen, target.name.." has\na magic barrier")

						target.makarakarn = true
					end

					if timer == 60
						return true
					end

				end,
}

attackDefs["crescent mirror"] = {
		name = "Crescent Mirror",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 24,
		target = TGT_ALLALLIES,
		desc = "Orbal Art. Give a\nbarrier that repels magic\nattacks to all allies.",
		superbuff = true,
		anim = 	function(mo, targets, hittargets, timer)

					for i = 1, #targets
						local target = hittargets[i]
						local t = timer - (i-1)*6

						if t >= 10 and t <= 40
							if leveltime%2 == 0
								local s = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
								s.sprite = SPR_ELEM
								s.tics = 1
							end
						elseif t == 41
							local thok = P_SpawnMobj(target.x, target.y, target.z+5*FRACUNIT, MT_DUMMY)
							thok.state = S_INVISIBLE
							thok.tics = 1
							A_OldRingExplode(thok, MT_SUPERSPARK)
							playSound(mo.battlen, sfx_mirror)

							BTL_logMessage(targets[1].battlen, target.name.." has\na magic barrier")

							target.makarakarn = true
						end
					end

					if timer == 60 + (#hittargets-1)*6
						return true
					end

				end,

}


attackDefs["dark matter"] = {
    name = "Dark Matter",
    type = ATK_NUCLEAR,
    power = 140,
    accuracy = 90,
    costtype = CST_SP,
    cost = 24,
    technical = COND_BURN|COND_FREEZE|COND_SHOCK,
    status = COND_DIZZY,
    statuschance = 20,
    desc = "Orbal Art. Medium Nuke\ndamage to all enemies. May\ninflict dizzy, lowers agility.",
    target = TGT_ALLENEMIES,
    hudfunc =     function(v, mo, timer)

                        if timer >= TICRATE*2
                        and timer <= TICRATE*2+15
                            local t = timer-TICRATE*2
                            local p = "H_ATR"..t/2
                            if v.patchExists(p)
                                drawScreenwidePatch(v, v.cachePatch(p))
                            end
                        end
                    end,
    
    
    anim =     function(mo, targets, hittargets, timer)
    
        local battleStatus = server.P_BattleStatus[mo.battlen]
        
        if timer == 20
           mo.st = P_SpawnMobj(battleStatus.arena_coords[1], battleStatus.arena_coords[2], battleStatus.arena_coords[3] - FRACUNIT*52, MT_DUMMY)
            mo.st.state = S_DARKMATTER
            mo.st.fuse = TICRATE*2
            mo.st.scale = FRACUNIT*1/4
            mo.st.destspeed = TICRATE/2
            mo.st.destscale = FRACUNIT*500
            playSound(mo.battlen, sfx_darmat)
        end
        
        if mo.st and mo.st.valid
            if timer%5 == 0
                local st = P_SpawnMobj(mo.st.x + P_RandomRange(-128, 128)<<FRACBITS, mo.st.y + P_RandomRange(-128, 128)<<FRACBITS, mo.st.z + P_RandomRange(-192, 192)<<FRACBITS, MT_DUMMY)
                st.color = SKINCOLOR_AZURE
                st.state = S_MEGISTAR1
                st.scale = mo.st.scale + P_RandomRange(0, 65535)
                st.target = mo.st
            end
			local thok = P_SpawnMobj(mo.st.x, mo.st.y, mo.z, MT_DUMMY)
			thok.flags = MF_NOBLOCKMAP|MF_NOCLIP
			thok.color = SKINCOLOR_PURPLE
			if timer%2 then thok.color = SKINCOLOR_NEON end
			thok.frame = A
			thok.tics = 70
			thok.scale = FRACUNIT
			thok.scalespeed = FRACUNIT/32
			thok.destscale = 1
			thok.momz = P_RandomRange(8, 12)*FRACUNIT
			thok.momx = P_RandomRange(-10, 10)*FRACUNIT
			thok.momy = P_RandomRange(-10, 10)*FRACUNIT
        end
        
        for k,e in ipairs(hittargets)
            local target = e
            
            if timer == TICRATE*2
                damageObject(target)
                if target.damagestate ~= DMG_MISS
                and target.damagestate ~= DMG_BLOCK
                and target.damagestate ~= DMG_DRAIN  
                    buffStat(target, "agi", -25)
                end    
            end
        end
        
        if timer == TICRATE*3
            return true
        end
    end
}


attackDefs["zeruel_cannon"] = {
		name = "Zeruel Cannon",
		type = ATK_NUCLEAR,
		power = 350,
		accuracy = 90,
		costtype = CST_SP,
		cost = 30,
		technical = COND_BURN|COND_FREEZE|COND_SHOCK,
		status = COND_DIZZY,
		statuschance = 20,
		desc = "Orbal Art. Heavy Nuke\ndamage to all enemies. May\ninflict dizzy, lowers agility.",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)

			for k,v in ipairs(hittargets)

				local target = v
				local time = timer - 6*(k-1)

				if time == 15
				or time == 25
				or time == 35
					local bx = target.x + P_RandomRange(-192, 192)*FRACUNIT
					local by = target.y + P_RandomRange(-129, 192)*FRACUNIT
					local bz = target.z + P_RandomRange(0, 256)*FRACUNIT

					for i = 1, 32
						local boom = P_SpawnMobj(bx + P_RandomRange(-20, 20)*FRACUNIT, by + P_RandomRange(-20, 20)*FRACUNIT, bz + 10*FRACUNIT, MT_DUMMY)
						boom.state = S_CQUICKBOOM1
						boom.color = SKINCOLOR_FLAME
						boom.momx = P_RandomRange(-20, 20)*FRACUNIT
						boom.momy = P_RandomRange(-20, 20)*FRACUNIT
						boom.momz = P_RandomRange(-20, 20)*FRACUNIT
						boom.scale = FRACUNIT*3/2
					end
					playSound(mo.battlen, sfx_megi6)
					localquake(mo.battlen, FRACUNIT*32, 10)

				elseif time >= 50
				and time <= 90

					if time == 50
						target.nukethrust = {}
						playSound(mo.battlen, sfx_megi5)
					end

					local an = leveltime%360*2
					if not (leveltime%2) and time < 122
						for i = 1, 32
							local x = target.x + 192*cos(an*ANG1)
							local y = target.y + 192*sin(an*ANG1)
							local nuke = P_SpawnMobj(x, y, target.z, MT_DUMMY)
							nuke.flags = MF_NOGRAVITY|MF_NOCLIP
							target.nukethrust[#target.nukethrust+1] = nuke
							nuke.state = S_CQUICKBOOM1
							nuke.color = SKINCOLOR_GOLD
							nuke.angle = an*ANG1
							nuke.momz = P_RandomRange(4, 6)*FRACUNIT
							P_InstaThrust(nuke, nuke.angle, 40*FRACUNIT)
							an = $ + 360/32
						end
					end

					for i = 1, #target.nukethrust
						local nuke = target.nukethrust[i]
						if not nuke or not nuke.valid continue end
						P_Thrust(nuke, nuke.angle, -FRACUNIT*8)
					end

				elseif time >= 92
				and time <= 150

					target.nukethrust = nil

					if time == 95
						damageObject(target)
						playSound(mo.battlen, sfx_megi5)
						if target.damagestate ~= DMG_MISS
						and target.damagestate ~= DMG_BLOCK
						and target.damagestate ~= DMG_DRAIN  
							buffStat(target, "agi", -25)
							buffStat(target, "def", -25)
							BTL_logMessage(targets[1].battlen, "Agility and Defense down!")
						end
						localquake(mo.battlen, FRACUNIT*64, 10)
						

						local sm = P_SpawnMobj(target.x, target.y, target.z, MT_SMOLDERING)
						sm.fuse = TICRATE*3
						sm.scale = FRACUNIT*3

					elseif timer == 150 + (#hittargets-1)*6
						return true
					end

					for i = 1, 12
						local boom = P_SpawnMobj(target.x + P_RandomRange(-96, 96)*FRACUNIT, target.y + P_RandomRange(-96, 96)*FRACUNIT, target.z, MT_DUMMY)
						boom.state = S_CQUICKBOOM1
						boom.color = SKINCOLOR_GOLD
						boom.momz = P_RandomRange(0, 48)*FRACUNIT
						boom.scale = FRACUNIT*3/2
					end
				end
			end
		end,
}

attackDefs["altair cannon"] = {
		name = "Altair Cannon",
		type = ATK_NUCLEAR,
		power = 350,
		accuracy = 95,
		costtype = CST_SP,
		cost = 19,
		technical = COND_BURN|COND_FREEZE|COND_SHOCK,
		desc = "Orbal Art. Heavy Nuke\ndamage to one enemy.\nLowers Magic Attack and Defense.",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]

			if timer == 15
			or timer == 25
			or timer == 35
				local bx = target.x + P_RandomRange(-192, 192)*FRACUNIT
				local by = target.y + P_RandomRange(-129, 192)*FRACUNIT
				local bz = target.z + P_RandomRange(0, 256)*FRACUNIT

				for i = 1, 32
					local boom = P_SpawnMobj(bx + P_RandomRange(-20, 20)*FRACUNIT, by + P_RandomRange(-20, 20)*FRACUNIT, bz + 10*FRACUNIT, MT_DUMMY)
					boom.state = S_CQUICKBOOM1
					boom.color = SKINCOLOR_WHITE
					boom.momx = P_RandomRange(-20, 20)*FRACUNIT
					boom.momy = P_RandomRange(-20, 20)*FRACUNIT
					boom.momz = P_RandomRange(-20, 20)*FRACUNIT
					boom.scale = FRACUNIT*3/2
				end
				local sm = P_SpawnMobj(bx, by, bz, MT_SMOLDERING)
				sm.fuse = TICRATE

				playSound(mo.battlen, sfx_megi6)
				localquake(mo.battlen, FRACUNIT*32, 10)

			elseif timer >= 50
			and timer <= 90

				if timer == 50
					target.nukethrust = {}
					playSound(mo.battlen, sfx_megi5)
				end

				local an = leveltime%360*2
				if not (leveltime%2) and timer < 122
					for i = 1, 32
						local x = target.x + 192*cos(an*ANG1)
						local y = target.y + 192*sin(an*ANG1)
						local nuke = P_SpawnMobj(x, y, target.z, MT_DUMMY)
						nuke.flags = MF_NOGRAVITY|MF_NOCLIP
						target.nukethrust[#target.nukethrust+1] = nuke
						nuke.state = S_CQUICKBOOM1
						nuke.color = SKINCOLOR_GOLD
						nuke.angle = an*ANG1
						nuke.momz = P_RandomRange(4, 6)*FRACUNIT
						P_InstaThrust(nuke, nuke.angle, 40*FRACUNIT)
						an = $ + 360/32
					end
				end

				for i = 1, #target.nukethrust
					local nuke = target.nukethrust[i]
					if not nuke or not nuke.valid continue end
					P_Thrust(nuke, nuke.angle, -FRACUNIT*8)
				end

			elseif timer >= 92
			and timer <= 150

				target.nukethrust = nil

				if timer == 95
					damageObject(target)
					playSound(mo.battlen, sfx_megi5)
					if target.damagestate ~= DMG_MISS
					and target.damagestate ~= DMG_BLOCK
					and target.damagestate ~= DMG_DRAIN 
						buffStat(target, "mag", -25)
						buffStat(target, "def", -25)
						BTL_logMessage(targets[1].battlen, "Magic Attack and Defense down!")
					end	
					localquake(mo.battlen, FRACUNIT*64, TICRATE)
					

					local sm = P_SpawnMobj(target.x, target.y, target.z, MT_SMOLDERING)
					sm.fuse = TICRATE*3
					sm.scale = FRACUNIT*3

				elseif timer == 150
					return true
				end

				for i = 1, 12
					local boom = P_SpawnMobj(target.x + P_RandomRange(-96, 96)*FRACUNIT, target.y + P_RandomRange(-96, 96)*FRACUNIT, target.z, MT_DUMMY)
					boom.state = S_CQUICKBOOM1
					boom.color = SKINCOLOR_GOLD
					boom.momz = P_RandomRange(0, 48)*FRACUNIT
					boom.scale = FRACUNIT*3/2
				end
			end
		end,
}

attackDefs["seventh caliber"] = {
		name = "Seventh Caliber",
		type = ATK_NUCLEAR,
		power = 650,
		accuracy = 95,
		costtype = CST_SP,
		cost = 40,
		technical = COND_BURN|COND_FREEZE|COND_SHOCK,
		desc = "Orbal Art.\nSevere Nuke damage to 1 enemy.\nLowers all stats by one stage.",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)

			local target = hittargets[1]

			if timer == 1
				mo.columns = {}
				playSound(mo.battlen, sfx_megi5)
			end

			if timer >= 10 and timer <= 30
			and (timer%5) == 0

				local s = P_SpawnMobj(mo.x + P_RandomRange(-128, 128)<<FRACBITS, mo.y + P_RandomRange(-128, 128)<<FRACBITS, mo.z + P_RandomRange(0, 256)<<FRACBITS, MT_DUMMY)
				s.color = SKINCOLOR_YELLOW
				s.state = S_MEGISTAR1
				s.scale = $*2 + P_RandomRange(0, 65535)
				playSound(mo.battlen, sfx_hamas1)
			end

			if timer == 30
				mo.bod = P_SpawnMobj(mo.x, mo.y, mo.z + FRACUNIT*192, MT_DUMMY)
				mo.bod.state = S_THOK
				mo.bod.tics = -1
				mo.bod.fuse = TICRATE
				mo.bod.color = SKINCOLOR_GOLD

				mo.bod.momx = (target.x - mo.x)/TICRATE
				mo.bod.momy = (target.y - mo.y)/TICRATE
				mo.bod.momz = (target.z - mo.bod.z)/TICRATE
			end

			if mo.bod and mo.bod.valid
				mo.bod.frame = FF_FULLBRIGHT
				mo.bod.scale = FRACUNIT*2 + P_RandomRange(-FRACUNIT/2 +1, FRACUNIT/2 -1)
				if timer%2
					local g = P_SpawnGhostMobj(mo.bod)
					g.fuse = TICRATE/3
					g.scalespeed = FRACUNIT/2
					g.detscale = FRACUNIT*8
				end
			end

			local j = mo.columns and #mo.columns or 0
			while j
				local m = mo.columns[j]
				if not m or not m.valid
					j = $-1
					continue
				end

				for i = 1, 5
					local boom = P_SpawnMobj(m.x + P_RandomRange(-48, 48)*FRACUNIT, m.y + P_RandomRange(-48, 48)*FRACUNIT, m.z, MT_DUMMY)
					boom.state = S_QUICKBOOM1
					boom.colorized = true
					boom.color = SKINCOLOR_FLAME
					boom.momz = P_RandomRange(0, 48)*FRACUNIT
					boom.scale = FRACUNIT*3/2
				end
				localquake(mo.battlen, FRACUNIT*8, 1)
				j = $-1
			end

			if timer == 30 + TICRATE

				local cam = server.P_BattleStatus[mo.battlen].cam

				local x = cam.x - 380*cos(cam.angle)
				local y = cam.y - 380*sin(cam.angle)
				CAM_goto(cam, x, y, cam.z + FRACUNIT*24)
			end

			if timer >= 30 + TICRATE
			and timer <= 30 + TICRATE*2
			and timer%4 == 0

				local s = P_SpawnMobj(target.x + P_RandomRange(-128, 128)<<FRACBITS, target.y + P_RandomRange(-128, 128)<<FRACBITS, target.z + P_RandomRange(0, 256)<<FRACBITS, MT_DUMMY)
				s.color = SKINCOLOR_WHITE
				s.state = S_MEGISTAR1
				s.scale = $*2 + P_RandomRange(0, 65535)
				playSound(mo.battlen, sfx_hamas1)

			end

			if timer == 30 + TICRATE*2
				-- delet old shit:
				mo.fangle = (R_PointToAngle(target.x, target.y)) + ANG1*180
				mo.columns = {}
				playSound(mo.battlen, sfx_megi5)

				local a = mo.fangle - ANG1*80

				for i = 1, 16
					local m = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					P_InstaThrust(m, a, FRACUNIT*48)
					mo.columns[#mo.columns+1] = m
					m.state = S_INVISIBLE
					m.tics = TICRATE
					a = $+ ANG1*10
				end


				for i = 1, #hittargets
					if hittargets[i] ~= mo
						damageObject(hittargets[i])
						if target.damagestate ~= DMG_MISS
						and target.damagestate ~= DMG_BLOCK
						and target.damagestate ~= DMG_DRAIN
							buffStat(hittargets[i], "atk", -25)
							buffStat(hittargets[i], "def", -25)
							buffStat(hittargets[i], "agi", -25)
							buffStat(hittargets[i], "mag", -25)
							BTL_logMessage(targets[1].battlen, "All stats decreased!")
						end
					end
				end

				localquake(mo.battlen, FRACUNIT*50, 10)
				for i = 1, 4
					createSplat(mo)
				end
			end

			if timer == 30 + TICRATE*4
				return true
			end
		end,
}

attackDefs["vital cannon I"] = {
        name = "Vital Cannon I",
        type = ATK_HEAL,
        costtype = CST_SP,
        cost = 16,
        power = 150,
        desc = "Loads a bullet that\nHeals a medium amount of HP\nto everyone.",
        nocast =     function(targets, n)    -- we can't cast this skill if this function returns true
                        local noheal = 0
                        for i = 1, #targets
                            if targets[i].hp >= targets[i].maxhp
                                noheal = $+1
                            end
                        end
                        if noheal >= #targets
                            BTL_logMessage(targets[1].battlen, "No further effects.")
                            return true
                        end
                    end,

        target = TGT_ALLALLIES,
        anim = function(mo, targets, hittargets, timer)
            local colors = {SKINCOLOR_CYAN}
            if timer == 20
                playSound(mo.battlen, sfx_lsheal)
            end
            for i = 1, #targets
                local target = targets[i]
                if timer == 20 + (i-1)*3
                                        local heals = P_RandomRange(150, 160)
                        damageObject(target, -heals)
                    for j = 1, 16
                        local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
                        orb.momx = P_RandomRange(-16, 16)<<FRACBITS
                        orb.momy = P_RandomRange(-16, 16)<<FRACBITS
                        orb.momz = P_RandomRange(-16, 16)<<FRACBITS
                        orb.destscale = 0
                        orb.tics = 20
                        orb.frame = A
                        orb.color = colors[P_RandomRange(1, #colors)]
                        
                    end    
                end
            end

            if timer == TICRATE*3/2 + (#targets-1)*5
                return true
            end
        end,
}

attackDefs["vital cannon II"] = {
		name = "Vital Cannon II",
		dekunda = true,
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 45,
		power= 250,
		desc = "Loads a bullet that fully heal\nto all allies, and clears\nstatus and debuffs.",
		target = TGT_ALLALLIES,
		anim = function(mo, targets, hittargets, timer)
			local colors = {SKINCOLOR_CYAN}
			local strs = {"atk", "mag", "def", "agi"}

			if timer == 20
				playSound(mo.battlen, sfx_lsheal)
			end
            for i = 1, #targets
                local target = targets[i]
                if timer == 20 + (i-1)*3
                                        local heals = target.maxhp
                        damageObject(target, -heals)
                    for j = 1, 16
						local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						orb.momx = P_RandomRange(-16, 16)<<FRACBITS
						orb.momy = P_RandomRange(-16, 16)<<FRACBITS
						orb.momz = P_RandomRange(-16, 16)<<FRACBITS
						orb.destscale = 0
						orb.tics = 20
						orb.frame = A
						orb.color = colors[P_RandomRange(1, #colors)]
					end
					for j = 1, #strs
						local t = targets[i]
						local s = strs[j]
						if t.buffs[s][1] < 0
							t.buffs[s][1] = 0
							t.buffs[s][2] = 0
						end
					end
					if target.status_condition and target.status_condition < COND_HYPER
						cureStatus(target)
					end
				end
			end
			if timer == TICRATE*3/2 + (#targets-1)*10
				return true
			end
		end,
}

attackDefs["smokecannon"] = {
		name = "Smoke Cannon",
		type = ATK_SUPPORT,
		power = 0,
		accuracy = 60,
		statuschance = 60,
		status = COND_DIZZY,
		costtype = CST_SP,
		luckbased = true,
		cost = 6,
		desc = "Shots a smoke screen that causes \nDizziness on 1 enemy.\nHigh Chance",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]

			if timer >= 20 and timer <= 40
				if not (timer%10)
				end
				if not (leveltime%3)
					local boom = P_SpawnMobj(target.x+P_RandomRange(-20, 20)*FRACUNIT, target.y+P_RandomRange(-20, 20)*FRACUNIT, target.z+P_RandomRange(-20, 20)*FRACUNIT, MT_DUMMY)
					boom.scale = FRACUNIT*3/2
					boom.state = S_SMOKE1

					for	 i = 1, 4
						local smoke = P_SpawnMobj(boom.x, boom.y, boom.z, MT_SMOKE)
						smoke.momx = P_RandomRange(-4, 4)*FRACUNIT
						smoke.momy = P_RandomRange(-4, 4)*FRACUNIT
						smoke.momz = P_RandomRange(2, 5)*FRACUNIT
					end

				end
				if timer == 30
					local sm = P_SpawnMobj(target.x, target.y, target.z, MT_SMOLDERING)
					sm.fuse = TICRATE
					damageObject(target)
				end
			elseif timer == 70
				return true
			end
			if timer == 20
			playSound(mo.battlen, sfx_smocn) 
			end
		end,
}

attackDefs["smokecannon2"] = {
		name = "Smoke Cannon II",
		type = ATK_SUPPORT,
		power = 0,
		accuracy = 25,
		statuschance = 25,
		status = COND_DIZZY,
		costtype = CST_SP,
		cost = 12,
		luckbased = true,
		desc = "Shots a smoke screen that causes \nDizziness on all enemies.\nLow Chance",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)

				for k,e in ipairs(hittargets)
					local time = timer
					local target = e

					if time >= 20 and time <= 40
						if timer == 20
						or timer == 30
						or timer == 40
						end
						if not (leveltime%3)
							local boom = P_SpawnMobj(target.x+P_RandomRange(-20, 20)*FRACUNIT, target.y+P_RandomRange(-20, 20)*FRACUNIT, target.z+P_RandomRange(-20, 20)*FRACUNIT, MT_BOSSEXPLODE)
							boom.scale = FRACUNIT*3/2
							boom.state = S_SMOKE1

							for	 i = 1, 4
								local smoke = P_SpawnMobj(boom.x, boom.y, boom.z, MT_SMOKE)
								smoke.momx = P_RandomRange(-4, 4)*FRACUNIT
								smoke.momy = P_RandomRange(-4, 4)*FRACUNIT
								smoke.momz = P_RandomRange(2, 5)*FRACUNIT
							end

						end
						if time == 30
							local sm = P_SpawnMobj(target.x, target.y, target.z, MT_SMOLDERING)
							sm.fuse = TICRATE
							damageObject(target)
						end
					end
				end
				if timer == 85 //Leeway with animation
					return true
				end
				if timer == 20
				playSound(mo.battlen, sfx_smocn)
				end
			end,
}

attackDefs["clock_up"] = {
		name = "Clock Up",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 6,
		desc = "Orbal Art.\nRaises agility to 1 ally \nby 1 stage",
		target = TGT_ALLY,
		buff = true,
		norepel = true,
		nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
						local target = targets[n]
						if target.buffs["agi"][2] >= 9
							BTL_logMessage(targets[1].battlen, "Limit reached!")
							return true
						end
					end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]

			if timer == 20
				playSound(mo.battlen, sfx_buff)
				buffStat(target, "agi")
				for i = 1,16
					local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					dust.angle = ANGLE_90 + ANG1* (22*(i-1))
					dust.state = S_CDUST1
					P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
					dust.color = SKINCOLOR_SUNSET
					dust.scale = FRACUNIT*2
				end

			elseif timer > 20 and timer <= 50

				if leveltime%2 == 0
					for i = 1,16

						local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
						thok.state = S_CDUST1
						thok.momz = P_RandomRange(3, 10)*FRACUNIT
						thok.color = SKINCOLOR_SUNSET
						thok.tics = P_RandomRange(10, 35)
						thok.scale = FRACUNIT*3/2
					end
				end

				local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
				thok.sprite = SPR_SUMN
				thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
				thok.momz = P_RandomRange(6, 16)*FRACUNIT
				thok.color = SKINCOLOR_SUNSET
				thok.tics = P_RandomRange(10, 35)
			elseif timer == 60
				return true
			end
		end,
}

attackDefs["chrono_drive"] = {
		name = "Chrono Drive",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 12,
		desc = "Orbal Art.\nRaises agility to all allies \nby 1 stage",
		target = TGT_ALLALLIES,
		buff = true,	-- is a buff
		anim = function(mo, targets, hittargets, timer)

			for i = 1, #targets do

				local target = targets[i]

				if timer == 20 + (i-1)*16
					playSound(mo.battlen, sfx_buff)
					buffStat(target, "agi")
					for i = 1,16
						local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						dust.angle = ANGLE_90 + ANG1* (22*(i-1))
						dust.state = S_CDUST1
						P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
						dust.color = SKINCOLOR_AZURE
						dust.scale = FRACUNIT*2
					end

				elseif timer > 20 + (i-1)*16 and timer <= 50 + (i-1)*16

					if leveltime%2 == 0
						for i = 1,16

							local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
							thok.state = S_CDUST1
							thok.momz = P_RandomRange(3, 10)*FRACUNIT
							thok.color = SKINCOLOR_AZURE
							thok.tics = P_RandomRange(10, 35)
							thok.scale = FRACUNIT*3/2
						end
					end

					for i = 1, 8
						local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
						thok.sprite = SPR_SUMN
						thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
						thok.momz = P_RandomRange(6, 16)*FRACUNIT
						thok.color = SKINCOLOR_AZURE
						thok.tics = P_RandomRange(10, 35)
					end
				end
			end
			if timer == 60 + (#targets-1)*16
				return true
			end
		end,
}